function add_colorbar_fcn

fig = get(0,'CurrentFigure');
toolbar = get(fig,'UserData');

this_colorbar = sort(findobj(fig,'Type','axes','Tag','colorbar')');

for j=1:size(this_colorbar,2);
   curr_axes = get(this_colorbar(1,j),'UserData');
   this_surf_type = [];
   this_surfhandle = findobj(curr_axes,'Type','surface')';
   if isempty(this_surfhandle)==0;
      for j1=1:size(this_surfhandle,2);
         if ischar(get(this_surfhandle(1,j1),'UserData'))==1;
            this_surf_type = [this_surf_type 1];
         else;
            this_surf_type = [this_surf_type 0];
         end;
      end;
      this_surfhandle = this_surfhandle(this_surf_type==1);
   end;
   if isempty(this_surfhandle)==0;
      %
      old_aunits = get(curr_axes,'Units');
      set(curr_axes,'Units','pixels');
      old_axes_pos = get(curr_axes,'Position');
      set(curr_axes,'Units','normalized');
      curr_axes_pos = get(curr_axes,'Position');
      stripe = 0.075;
      edge = 0.02;
      [az,el] = view;
      if all([az,el]==[0 90]);
         space = 0.05;
      else;
         space = .1;
      end;
      %
      this_axes_pos = [curr_axes_pos(1:2) curr_axes_pos(3)*(1-stripe-edge-space) curr_axes_pos(4)];
      set(curr_axes,'Position',this_axes_pos);
      set(curr_axes,'Units','pixels');
      new_axes_pos = get(curr_axes,'Position');
      %
      % fix legend (if any)
      %
      old_leg = get(curr_axes,'UserData');
      if isempty(old_leg)==0;
         if ishandle(old_leg)==0;
            old_leg = find_legend(curr_axes);
         end;
         ud = get(old_leg,'UserData');
         leg_context = get(ud.UIContextMenu);
         lock_handle = findobj(leg_context,'Label','Unlock Legend')';
         if isempty(lock_handle)==1;
            if (ud.legendpos==1)|(ud.legendpos==4);
               old_leg_units = get(old_leg,'Units');
               set(old_leg,'Units','pixels');
               plot_pos = get(old_leg,'Position');
               diff_pos = old_axes_pos(1)+old_axes_pos(3)-(new_axes_pos(1)+new_axes_pos(3));
               set(old_leg,'Position',[max(0,plot_pos(1)-diff_pos) plot_pos(2:4)]);
               set(old_leg,'Units',old_leg_units);
               leg_pos = get(old_leg,'Position');
               ud.LegendPosition = leg_pos;
               set(old_leg,'UserData',ud);
            end;
         end;
      end;
      %
      par = get(toolbar.deletecolorbar,'Parent');
      d_pos = get(toolbar.deletecolorbar,'Position');
      %
      if isfield(toolbar,'colorbar')==0;
         toolbar.colorbar = uimenu('Parent',par, ...
            'Label','&Hide Colorbar', ...
            'Position',d_pos, ...
            'Callback','toolbar_colorbar_fcn', ...
            'Enable','on', ...
            'Tag','ColorBar');
      end;
      %
      set(toolbar.deletecolorbar,'Label','&Delete Colorbar','Callback','delete_colorbar_fcn');
      %
      ax_fontangle = get(curr_axes,'FontAngle');
      ax_fontname = get(curr_axes,'FontName');
      ax_fontsize = get(curr_axes,'FontSize');
      ax_fontunits = get(curr_axes,'FontUnits');
      ax_fontweight = get(curr_axes,'FontWeight');
      set(this_colorbar(1,j),'FontName',ax_fontname, ...
         'FontAngle',ax_fontangle, ...
         'FontSize',ax_fontsize, ...
         'FontWeight',ax_fontweight, ...
         'FontUnits',ax_fontunits);
      %
      kids = get(this_colorbar(1,j),'Children')';
      set(kids,'Visible','on');
      set(kids(1,1),'UserData','');
      set(this_colorbar(1,j),'Visible','on');
      %
      set(curr_axes,'Units',old_aunits);
      set(fig,'UserData',toolbar);
      %
      % fix context menu of axes
      %
      create_axes_contextmenu_fcn(curr_axes);
   end;
end;

%
% check if there are axes objects which don't have a colorbar
%

myaxes = get(toolbar.print,'UserData');
missing_axes = [];
if size(myaxes,2)~=size(this_colorbar);
   for i=1:size(myaxes,2);
      num = 1;
      if myaxes(1,i)==get(this_colorbar(1,num),'UserData');
         num = num+1;
      else;
         missing_axes = [missing_axes myaxes(1,i)];
      end;
   end;
end;

if isempty(missing_axes)==0;
   old_gca = gca;
   for i=1:size(missing_axes,2);
      this_surf_type = [];
      this_surfhandle = findobj(missing_axes(1,i),'Type','surface')';
      if isempty(this_surfhandle)==0;
         for j=1:size(this_surfhandle,2);
            if ischar(get(this_surfhandle(1,j),'UserData'))==1;
               this_surf_type = [this_surf_type 1];
            else;
               this_surf_type = [this_surf_type 0];
            end;
         end;
         this_surfhandle = this_surfhandle(this_surf_type==1);
      end;
      if isempty(this_surfhandle)==0;
         axes(missing_axes(1,i));
         toolbar_addcolorbar_fcn;
      end;
   end;
   if (isempty(old_gca)==0)&(ishandle(old_gca)==1)&(strcmp(get(old_gca,'Type'),'axes')==1);
      axes(old_gca);
   end;
end;

%
% end of add_colorbar_fcn.m
%
