function [status,prog_seq] = check_pdf(curr_ini)

status = 1;
prog_seq = '';
my_latex = curr_ini.latex;
my_dvipdfm = '';
my_dvips = '';
my_distiller = '';

if (isempty(curr_ini.latex)==0)&(isempty(curr_ini.pdfviewer)==0);
   fid1 = fopen(curr_ini.latex,'rb');
   if fid1>-1;
      fclose(fid1);
   end;
   fid2 = fopen(curr_ini.pdfviewer,'rb');
   if fid2>-1;
      fclose(fid2);
   end;
   if min([fid1 fid2])==-1;
      return;
   else;
      %
      % check for pdflatex or dvipdfm if latex or distiller if latex
      %
      sec_parm = 0;
      latex = getname(curr_ini.latex);
      if size(latex,2)>=5;
         if strcmp(lower(latex(1,1:3)),'pdf')==1;
            if isempty(findstr(latex,'latex'))==0;
               sec_parm = 1;
            end;
         end;
         if sec_parm==0;
            %
            % check if latex
            %
            if isempty(findstr(latex,'latex'))==0;
               if curr_ini.dvipdfm==0;
                  sec_parm_1 = 0;
                  fid2 = fopen(curr_ini.distiller,'rb');
                  if fid2>-1;
                     fclose(fid2);
                     %
                     % make sure dvips or dvipsk exists
                     %
                     if strcmp(computer,'PCWIN')==1;
                        dvips = [getpath(curr_ini.latex) 'dvips.exe'];
                     else;
                        dvips = [getpath(curr_ini.latex) '/dvips' getext(curr_ini.latex)];
                     end;
                     fid3 = fopen(dvips,'rb');
                     if fid3>-1;
                        fclose(fid3);
                        my_dvips = dvips;
                        my_distiller = curr_ini.distiller;
                        sec_parm_1 = 1;
                        sec_parm = 1;
                     else;
                        if strcmp(computer,'PCWIN')==1;
                           dvips = [getpath(curr_ini.latex) 'dvipsk.exe'];
                        else;
                           dvips = [getpath(curr_ini.latex) '/dvipsk' getext(curr_ini.latex)];
                        end;
                        fid3 = fopen(dvips,'rb');
                        if fid3>-1;
                           fclose(fid3);
                           my_dvips = dvips;
                           my_distiller = curr_ini.distiller;
                           sec_parm_1 = 1;
                           sec_parm = 1;
                        end;
                     end;
                     if fid3==-1;
                        fid2 = -1;
                     end;
                  end;
                  if sec_parm_1==0;
                     if strcmp(computer,'PCWIN')==1;
                        dvipdfm = [getpath(curr_ini.latex) 'dvipdfm.exe'];
                     else;
                        dvipdfm = [getpath(curr_ini.latex) '/dvipdfm' getext(curr_ini.latex)];
                     end;
                     fid1 = fopen(dvipdfm,'rb');
                     if fid1>-1;
                        fclose(fid1);
                        my_dvipdfm = dvipdfm;
                        sec_parm = 1;
                     end;
                  end;
               else;
                  if strcmp(computer,'PCWIN')==1;
                     dvipdfm = [getpath(curr_ini.latex) 'dvipdfm.exe'];
                  else;
                     dvipdfm = [getpath(curr_ini.latex) '/dvipdfm' getext(curr_ini.latex)];
                  end;
                  fid1 = fopen(dvipdfm,'rb');
                  sec_parm_1 = 0;
                  if fid1>-1;
                     fclose(fid1);
                     my_dvipdfm = dvipdfm;
                     sec_parm_1 = 1;
                     sec_parm = 1;
                  end;
                  if sec_parm_1==0;
                     fid2 = fopen(curr_ini.distiller,'rb');
                     if fid2>-1;
                        fclose(fid2);
                        %
                        % make sure dvips or dvipsk exists
                        %
                        if strcmp(computer,'PCWIN')==1;
                           dvips = [getpath(curr_ini.latex) 'dvips.exe'];
                        else;
                           dvips = [getpath(curr_ini.latex) '/dvips' getext(curr_ini.latex)];
                        end;
                        fid3 = fopen(dvips,'rb');
                        if fid3>-1;
                           fclose(fid3);
                           my_dvips = dvips;
                           my_distiller = curr_ini.distiller;
                           sec_parm = 1;
                        else;
                           if strcmp(computer,'PCWIN')==1;
                              dvips = [getpath(curr_ini.latex) 'dvipsk.exe'];
                           else;
                              dvips = [getpath(curr_ini.latex) '/dvipsk' getext(curr_ini.latex)];
                           end;
                           fid3 = fopen(dvips,'rb');
                           if fid3>-1;
                              fclose(fid3);
                              my_dvips = dvips;
                              my_distiller = curr_ini.distiller;
                              sec_parm = 1;
                           end;
                        end;
                        if fid3==-1;
                           fid2 = -1;
                        end;
                     end;
                  end;
               end;
            end;
         end;
      end;
      if sec_parm==0;
         return;
      else;
         status = 0;
         prog_seq = strvcat(my_latex,my_dvipdfm,my_dvips,my_distiller);
      end;
   end;
end;

%
% end of check_pdf.m
%
