function copy_line_fcn

curr_line = gco;
line_prop.color = get(curr_line,'Color');
line_prop.xdata = get(curr_line,'XData');
line_prop.ydata = get(curr_line,'YData');
line_prop.zdata = get(curr_line,'ZData');
line_prop.linestyle = get(curr_line,'LineStyle');
line_prop.linewidth = get(curr_line,'LineWidth');
line_prop.marker = get(curr_line,'Marker');
line_prop.markersize = get(curr_line,'MarkerSize');
line_prop.markeredgecolor = get(curr_line,'MarkerEdgeColor');
line_prop.markerfacecolor = get(curr_line,'MarkerFaceColor');
line_prop.tag = get(curr_line,'Tag');

fix_fig = findobj('Tag','StructuralVAR');
model = get(fix_fig,'UserData');
copy = get(model.run,'UserData');

update_figs = 0;
if isfield(copy,'line_properties')==0;
   update_figs = 1;
end;
copy.line_properties = line_prop;
set(model.run,'UserData',copy);

%
% update all open figure such that pasting of lines are enabled
%

if update_figs==1;
   my_figs = sort(findobj(0,'Type','figure')');
   for i=1:size(my_figs,2);
      this_toolbar = get(my_figs(1,i),'UserData');
      if isempty(this_toolbar)==0;
         %
         % make sure we're not dealing with a program figure
         %
         if isfield(this_toolbar,'renderer')==1;
            myaxes = get(this_toolbar.print,'UserData');
            for j=1:size(myaxes,2);
               line_menu = findobj(get(myaxes(1,j),'UIContextMenu'),'Label','Line')';
               if isempty(line_menu)==0;
                  set(line_menu,'Enable','on');
               end;
            end;
         end;
      end;
   end;
end;

%
% end of copy_line_fcn.m
%