function these_axes = create_preview_plots_fcn(fig,this_gui)

%
% fig is the figure handle and this_gui is the handle for the figure model in print preview
%

old_gui_units = get(this_gui,'Units');
set(this_gui,'Units','pixels');
gui_scale_pos = get(this_gui,'Position');
set(this_gui,'Units','normalized');
gui_pos = get(this_gui,'Position');
my_context = get(this_gui,'UIContextMenu');

toolbar = get(fig,'UserData');
myaxes = get(toolbar.print,'UserData');
inv_hardcopy = get(fig,'InvertHardcopy');

curr_ini = find_inisettings;

%
% learn about scaling of model figure area relative to print figure area
%

if strcmp(get(fig,'PaperPositionMode'),'auto')==1;
   old_fig_units = get(fig,'Units');
   set(fig,'Units','pixels');
   fig_scale_pos = get(fig,'Position');
   fig_pos = fig_scale_pos;
   set(fig,'Units',old_fig_units);
else;
   old_paper_units = get(fig,'PaperUnits');
   set(fig,'PaperUnits','inches');
   fig_scale_pos = get(fig,'PaperPosition');
   fig_pos = get(fig,'Position');
   %
   % recompute from inches to pixels
   %
   fig_scale_pos = fig_scale_pos*get(0,'ScreenPixelsPerInch');
   set(fig,'PaperUnits',old_paper_units);
end;
x_scaling = gui_scale_pos(3)/fig_scale_pos(3);
y_scaling = gui_scale_pos(4)/fig_scale_pos(4);
%font_scaling = gui_scale_pos(3)/fig_pos(3);
font_scaling = x_scaling;


old_fig_units = get(fig,'Units');
set(fig,'Units','points');
old_paper_units = get(fig,'PaperUnits');
set(fig,'PaperUnits','points');
fig_position_points = get(fig,'Position');
fig_paper_position = get(fig,'PaperPosition');
set(fig,'Units',old_fig_units,'PaperUnits',old_paper_units);
x_fig_scaling = fig_position_points(3)/fig_paper_position(3);
y_fig_scaling = fig_position_points(4)/fig_paper_position(4);

these_axes = [];

for i=1:size(myaxes,2);
   old_axes_units = get(myaxes(1,i),'Units');
   set(myaxes(1,i),'Units','normalized');
   axes_pos = get(myaxes(1,i),'Position');
   %
   % deal with axes width and height
   %
   axes_pos(3) = gui_pos(3)*axes_pos(3);
   axes_pos(4) = gui_pos(4)*axes_pos(4);
   %
   % deal with left and bottom
   %
   axes_pos(1) = gui_pos(1)+(gui_pos(3)*axes_pos(1));
   axes_pos(2) = gui_pos(2)+(gui_pos(4)*axes_pos(2));
   %
   %
   %
   % retrieve data from axes object
   %
   %
   % collecting information about axes
   %
   ax_box = get(myaxes(1,i),'Box');
   ax_xgrid = get(myaxes(1,i),'XGrid');
   ax_ygrid = get(myaxes(1,i),'YGrid');
   ax_zgrid = get(myaxes(1,i),'ZGrid');
   ax_fontangle = get(myaxes(1,i),'FontAngle');
   ax_fontname = get(myaxes(1,i),'FontName');
   ax_fontsize = round(get(myaxes(1,i),'FontSize')*font_scaling);
   ax_fontunits = get(myaxes(1,i),'FontUnits');
   ax_fontweight = get(myaxes(1,i),'FontWeight');
   ax_xlim = get(myaxes(1,i),'XLim');
   ax_ylim = get(myaxes(1,i),'YLim');
   ax_zlim = get(myaxes(1,i),'ZLim');
   ax_xscale = get(myaxes(1,i),'XScale');
   ax_yscale = get(myaxes(1,i),'YScale');
   ax_zscale = get(myaxes(1,i),'ZScale');
   ax_xtick = get(myaxes(1,i),'XTick');
   ax_ytick = get(myaxes(1,i),'YTick');
   ax_ztick = get(myaxes(1,i),'ZTick');
   ax_xtickmode = get(myaxes(1,i),'XTickMode');
   ax_ytickmode = get(myaxes(1,i),'YTickMode');
   ax_ztickmode = get(myaxes(1,i),'ZTickMode');
   ax_color = get(myaxes(1,i),'Color');
   ax_xcolor = get(myaxes(1,i),'XColor');
   ax_ycolor = get(myaxes(1,i),'YColor');
   ax_zcolor = get(myaxes(1,i),'ZColor');
   ax_layer = get(myaxes(1,i),'Layer');
   ax_ambientlightcolor = get(myaxes(1,i),'AmbientLightColor');
   ax_clim = get(myaxes(1,i),'CLim');
   ax_climmode = get(myaxes(1,i),'CLimMode');
   ax_colororder = get(myaxes(1,i),'ColorOrder');
   ax_xaxislocation = get(myaxes(1,i),'XAxisLocation');
   ax_yaxislocation = get(myaxes(1,i),'YAxisLocation');
   ax_view = get(myaxes(1,i),'View');
   ax_gridlinestyle = get(myaxes(1,i),'GridLineStyle');
   ax_tickdir = get(myaxes(1,i),'TickDir');
%   ax_nextplot = get(myaxes(1,i),'NextPlot');
   ax_cameraposition = get(myaxes(1,i),'CameraPosition');
   ax_camerapositionmode = get(myaxes(1,i),'CameraPositionMode');
   ax_cameratarget = get(myaxes(1,i),'CameraTarget');
   ax_cameratargetmode = get(myaxes(1,i),'CameraTargetMode');
   ax_cameraupvector = get(myaxes(1,i),'CameraUpVector');
   ax_cameraupvectormode = get(myaxes(1,i),'CameraUpVectorMode');
   ax_cameraviewangle = get(myaxes(1,i),'CameraViewAngle');
   ax_cameraviewanglemode = get(myaxes(1,i),'CameraViewAngleMode');
   ax_dataaspectratio = get(myaxes(1,i),'DataAspectRatio');
   ax_dataaspectratiomode = get(myaxes(1,i),'DataAspectRatioMode');
   ax_plotboxaspectratio = get(myaxes(1,i),'PlotBoxAspectRatio');
   ax_plotboxaspectratiomode = get(myaxes(1,i),'PlotBoxAspectRatioMode');
   ax_xlimmode = get(myaxes(1,i),'XLimMode');
   ax_ylimmode = get(myaxes(1,i),'YLimMode');
   ax_zlimmode = get(myaxes(1,i),'ZLimMode');
   %
   % collecting info about title
   %
   my_title = get(myaxes(1,i),'Title');
   title_text = get(my_title,'String');
   title_color = get(my_title,'Color');
   title_fontangle = get(my_title,'FontAngle');
   title_fontname = get(my_title,'FontName');
   title_fontsize = round(get(my_title,'FontSize')*font_scaling);
   title_fontunits = get(my_title,'FontUnits');
   title_fontweight = get(my_title,'FontWeight');
   title_units = get(my_title,'Units');
   title_position = get(my_title,'Position');
   title_rotation = get(my_title,'Rotation');
   title_horizontalalignment = get(my_title,'HorizontalAlignment');
   title_verticalalignment = get(my_title,'VerticalAlignment');
   %
   % collecting info about the xlabel, ylabel, zlabel
   %
   my_xlabel = get(myaxes(1,i),'XLabel');
   xlabel_text = get(my_xlabel,'String');
   xlabel_color = get(my_xlabel,'Color');
   xlabel_fontangle = get(my_xlabel,'FontAngle');
   xlabel_fontname = get(my_xlabel,'FontName');
   xlabel_fontsize = round(get(my_xlabel,'FontSize')*font_scaling);
   xlabel_fontunits = get(my_xlabel,'FontUnits');
   xlabel_fontweight = get(my_xlabel,'FontWeight');
   xlabel_units = get(my_xlabel,'Units');
   xlabel_position = get(my_xlabel,'Position');
   xlabel_rotation = get(my_xlabel,'Rotation');
   xlabel_horizontalalignment = get(my_xlabel,'HorizontalAlignment');
   xlabel_verticalalignment = get(my_xlabel,'VerticalAlignment');
   %
   my_ylabel = get(myaxes(1,i),'YLabel');
   ylabel_text = get(my_ylabel,'String');
   ylabel_color = get(my_ylabel,'Color');
   ylabel_fontangle = get(my_ylabel,'FontAngle');
   ylabel_fontname = get(my_ylabel,'FontName');
   ylabel_fontsize = round(get(my_ylabel,'FontSize')*font_scaling);
   ylabel_fontunits = get(my_ylabel,'FontUnits');
   ylabel_fontweight = get(my_ylabel,'FontWeight');
   ylabel_units = get(my_ylabel,'Units');
   ylabel_position = get(my_ylabel,'Position');
   ylabel_rotation = get(my_ylabel,'Rotation');
   ylabel_horizontalalignment = get(my_ylabel,'HorizontalAlignment');
   ylabel_verticalalignment = get(my_ylabel,'VerticalAlignment');
   %
   my_zlabel = get(myaxes(1,i),'ZLabel');
   zlabel_text = get(my_zlabel,'String');
   zlabel_color = get(my_zlabel,'Color');
   zlabel_fontangle = get(my_zlabel,'FontAngle');
   zlabel_fontname = get(my_zlabel,'FontName');
   zlabel_fontsize = round(get(my_zlabel,'FontSize')*font_scaling);
   zlabel_fontunits = get(my_zlabel,'FontUnits');
   zlabel_fontweight = get(my_zlabel,'FontWeight');
   zlabel_units = get(my_zlabel,'Units');
   zlabel_position = get(my_zlabel,'Position');
   zlabel_rotation = get(my_zlabel,'Rotation');
   zlabel_horizontalalignment = get(my_zlabel,'HorizontalAlignment');
   zlabel_verticalalignment = get(my_zlabel,'VerticalAlignment');
   if strcmp(inv_hardcopy,'on')==1;
      ax_color = [1 1 1];
      ax_xcolor = [0 0 0];
      ax_ycolor = [0 0 0];
      ax_zcolor = [0 0 0];
      title_color = [0 0 0];
      xlabel_color = [0 0 0];
      ylabel_color = [0 0 0];
      zlabel_color = [0 0 0];
   end;
   %
   % create axes object
   %
   new_axes = axes('Units','normalized', ...
      'Position',axes_pos, ...
      'Box',ax_box, ...
      'AmbientLightColor',ax_ambientlightcolor, ...
      'CLim',ax_clim, ...
      'CLimMode',ax_climmode, ...
      'ColorOrder',ax_colororder, ...
      'GridLineStyle',ax_gridlinestyle, ...
      'XGrid',ax_xgrid, ...
      'YGrid',ax_ygrid, ...
      'ZGrid',ax_zgrid, ...
      'TickDir',ax_tickdir, ...
      'NextPlot','add', ...
      'CameraPosition',ax_cameraposition, ...
      'CameraPositionMode',ax_camerapositionmode, ...
      'CameraTarget',ax_cameratarget, ...
      'CameraTargetMode',ax_cameratargetmode, ...
      'CameraUpVector',ax_cameraupvector, ...
      'CameraUpVectorMode',ax_cameraupvectormode, ...
      'CameraViewAngle',ax_cameraviewangle, ...
      'CameraViewAngleMode',ax_cameraviewanglemode, ...
      'DataAspectRatio',ax_dataaspectratio, ...
      'DataAspectRatioMode',ax_dataaspectratiomode, ...
      'PlotBoxAspectRatio',ax_plotboxaspectratio, ...
      'PlotBoxAspectRatioMode',ax_plotboxaspectratiomode, ...
      'FontAngle',ax_fontangle, ...
      'FontName',ax_fontname, ...
      'FontSize',ax_fontsize, ...
      'FontUnits',ax_fontunits, ...
      'FontWeight',ax_fontweight, ...
      'XLim',ax_xlim, ...
      'YLim',ax_ylim, ...
      'ZLim',ax_zlim, ...
      'XLimMode',ax_xlimmode, ...
      'YLimMode',ax_ylimmode, ...
      'ZLimMode',ax_zlimmode, ...
      'XScale',ax_xscale, ...
      'YScale',ax_yscale, ...
      'ZScale',ax_zscale, ...
      'XTick',ax_xtick, ...
      'YTick',ax_ytick, ...
      'ZTick',ax_ztick, ...
      'XTickMode','manual', ...
      'YTickMode','manual', ...
      'ZTickMode','manual', ...
      'XAxisLocation',ax_xaxislocation, ...
      'YAxisLocation',ax_yaxislocation, ...
      'Visible',get(myaxes(1,i),'Visible'), ...
      'Projection',get(myaxes(1,i),'Projection'), ...
      'LineWidth',get(myaxes(1,i),'LineWidth')*x_scaling, ...
      'View',ax_view, ...
      'Tag',get(myaxes(1,i),'Tag'), ...
      'UIContextMenu',my_context, ...
      'UserData',myaxes(1,i), ...
      'Color',ax_color, ...
      'Layer',ax_layer, ...
      'XColor',ax_xcolor, ...
      'YColor',ax_ycolor, ...
      'ZColor',ax_zcolor);
   %
   % setting up the title
   %
   new_title = title(title_text, ...
      'Color',title_color, ...
      'Units',title_units, ...
      'Position',title_position, ...
      'Rotation',title_rotation, ...
      'HorizontalAlignment',title_horizontalalignment, ...
      'VerticalAlignment',title_verticalalignment, ...
      'UIContextMenu',my_context, ...
      'FontAngle',title_fontangle, ...
      'FontName',title_fontname, ...
      'FontSize',title_fontsize, ...
      'FontUnits',title_fontunits, ...
      'FontWeight',title_fontweight);
   %
   % setting up the xlabel, ylabel, zlabel
   %
   new_xlabel = xlabel(xlabel_text, ...
      'Color',xlabel_color, ...
      'Units',xlabel_units, ...
      'Position',xlabel_position, ...
      'Rotation',xlabel_rotation, ...
      'HorizontalAlignment',xlabel_horizontalalignment, ...
      'VerticalAlignment',xlabel_verticalalignment, ...
      'UIContextMenu',my_context, ...
      'FontAngle',xlabel_fontangle, ...
      'FontName',xlabel_fontname, ...
      'FontSize',xlabel_fontsize, ...
      'FontUnits',xlabel_fontunits, ...
      'FontWeight',xlabel_fontweight);
   %
   new_ylabel = ylabel(ylabel_text, ...
      'Color',ylabel_color, ...
      'Units',ylabel_units, ...
      'Position',ylabel_position, ...
      'Rotation',ylabel_rotation, ...
      'HorizontalAlignment',ylabel_horizontalalignment, ...
      'VerticalAlignment',ylabel_verticalalignment, ...
      'UIContextMenu',my_context, ...
      'FontAngle',ylabel_fontangle, ...
      'FontName',ylabel_fontname, ...
      'FontSize',ylabel_fontsize, ...
      'FontUnits',ylabel_fontunits, ...
      'FontWeight',ylabel_fontweight);
   %
   new_zlabel = zlabel(zlabel_text, ...
      'Color',zlabel_color, ...
      'Units',zlabel_units, ...
      'Position',zlabel_position, ...
      'Rotation',zlabel_rotation, ...
      'HorizontalAlignment',zlabel_horizontalalignment, ...
      'VerticalAlignment',zlabel_verticalalignment, ...
      'UIContextMenu',my_context, ...
      'FontAngle',zlabel_fontangle, ...
      'FontName',zlabel_fontname, ...
      'FontSize',zlabel_fontsize, ...
      'FontUnits',zlabel_fontunits, ...
      'FontWeight',zlabel_fontweight);
   %
   % recreate lines and patches
   %
   leg_objects = [];
   linehandles = findobj(myaxes(1,i),'Type','line')';
   patchhandles = findobj(myaxes(1,i),'Type','patch')';
   surfhandles = findobj(myaxes(1,i),'Type','surface')';
   imagehandles = findobj(myaxes(1,i),'Type','image')';
   lighthandles = findobj(myaxes(1,i),'Type','light')';
   if isempty(surfhandles)==0;
      patchhandles = [];
      imagehandles = [];
   end;
   %
   old_objects = reverse(get(myaxes(1,i),'Children'))';
   %
   if isempty(old_objects)==0;
      num_lines = 0;
      num_patches = 0;
      num_surfaces = 0;
      num_images = 0;
      num_lights = 0;
      for j=1:size(old_objects,2);
         if strcmp(get(old_objects(1,j),'Type'),'line')==1;
            num_lines = num_lines+1;
            line_color = get(old_objects(1,j),'Color');
            marker_edge_color = get(old_objects(1,j),'MarkerEdgeColor');
            marker_face_color = get(old_objects(1,j),'MarkerFaceColor');
            if strcmp(inv_hardcopy,'on')==1;
               if isnumeric(line_color(1))==1;
                  line_color = mean(line_color)*ones(1,3);
                  if max(line_color)>1;
                     line_color = (1/255)*abs(line_color);
                  end;
               end;
               if isnumeric(marker_edge_color(1))==1;
                  marker_edge_color = mean(marker_edge_color)*ones(1,3);
                  if max(marker_edge_color)>1;
                     marker_edge_color = (1/255)*abs(marker_edge_color);
                  end;
               end;
               if isnumeric(marker_face_color)==1;
                  marker_face_color = mean(marker_face_color)*ones(1,3);
                  if max(marker_face_color)>1;
                     marker_face_color = (1/255)*abs(marker_face_color);
                  end;
               end;
            end;
            %
            this_line = line('XData',get(old_objects(1,j),'XData'), ...
               'YData',get(old_objects(1,j),'YData'), ...
               'Zdata',get(old_objects(1,j),'ZData'), ...
               'UserData',old_objects(1,j), ...
               'Color',line_color, ...
               'Parent',new_axes, ...
               'Clipping',get(old_objects(1,j),'Clipping'), ...
               'EraseMode',get(old_objects(1,j),'EraseMode'), ...
               'SelectionHighlight',get(old_objects(1,j),'SelectionHighlight'), ...
               'HandleVisibility',get(old_objects(1,j),'HandleVisibility'), ...
               'HitTest',get(old_objects(1,j),'HitTest'), ...
               'Selected',get(old_objects(1,j),'Selected'), ...
               'Visible',get(old_objects(1,j),'Visible'), ...
               'UIContextMenu',my_context, ...
               'Tag',get(old_objects(1,j),'Tag'), ...
               'LineStyle',get(old_objects(1,j),'LineStyle'), ...
               'LineWidth',get(old_objects(1,j),'LineWidth')*x_scaling, ...
               'Marker',get(old_objects(1,j),'Marker'), ...
               'MarkerEdgeColor',marker_edge_color, ...
               'MarkerFaceColor',marker_face_color, ...
               'MarkerSize',max(round(get(old_objects(1,j),'MarkerSize')*x_scaling),1));
            %
            if isempty(get(old_objects(1,j),'UserData'))==0;
               this_tag = get(old_objects(1,j),'Tag');
               if size(this_tag,2)>8;
                  this_tag = this_tag(1,1:8);
               end;
               if (strcmp(this_tag,'3dlines-')==1)|(strcmp(this_tag,'light')==1);
               else;
                  leg_objects = [leg_objects this_line];
               end;
            end;
         elseif strcmp(get(old_objects(1,j),'Type'),'patch')==1;
            num_patches = num_patches+1;
            patch_face_color = get(old_objects(1,j),'FaceColor');
            patch_edge_color = get(old_objects(1,j),'EdgeColor');
            patch_marker_face_color = get(old_objects(1,j),'MarkerFaceColor');
            patch_marker_edge_color = get(old_objects(1,j),'MarkerEdgeColor');
            if strcmp(inv_hardcopy,'on')==1;
               if isnumeric(patch_face_color(1))==1;
                  patch_face_color = mean(patch_face_color)*ones(1,3);
               end;
               if isnumeric(patch_edge_color(1))==1;
                  patch_edge_color = mean(patch_edge_color)*ones(1,3);
               end;
               if isnumeric(patch_marker_face_color(1))==1;
                  patch_marker_face_color = mean(patch_marker_face_color)*ones(1,3);
               end;
               if isnumeric(patch_marker_edge_color(1))==1;
                  patch_marker_edge_color = mean(patch_marker_edge_color)*ones(1,3);
               end;
            end;
            this_patch = patch('XData',get(old_objects(1,j),'XData'), ...
               'YData',get(old_objects(1,j),'YData'), ...
               'Zdata',get(old_objects(1,j),'ZData'), ...
               'CData',get(old_objects(1,j),'CData'), ...
               'CDataMapping',get(old_objects(1,j),'CDataMapping'), ...
               'AmbientStrength',get(old_objects(1,j),'AmbientStrength'), ...
               'BackFaceLighting',get(old_objects(1,j),'BackFaceLighting'), ...
               'DiffuseStrength',get(old_objects(1,j),'DiffuseStrength'), ...
               'EdgeLighting',get(old_objects(1,j),'EdgeLighting'), ...
               'FaceLighting',get(old_objects(1,j),'FaceLighting'), ...
               'SpecularColorReflectance',get(old_objects(1,j),'SpecularColorReflectance'), ...
               'SpecularExponent',get(old_objects(1,j),'SpecularExponent'), ...
               'SpecularStrength',get(old_objects(1,j),'SpecularStrength'), ...
               'Clipping',get(old_objects(1,j),'Clipping'), ...
               'UserData',old_objects(1,j), ...
               'Tag',get(old_objects(1,j),'Tag'), ...
               'Parent',new_axes, ...
               'Visible',get(old_objects(1,j),'Visible'), ...
               'UIContextMenu',my_context, ...
               'FaceColor',patch_face_color, ...
               'EdgeColor',patch_edge_color, ...
               'LineStyle',get(old_objects(1,j),'LineStyle'), ...
               'LineWidth',get(old_objects(1,j),'LineWidth')*x_scaling, ...
               'Marker',get(old_objects(1,j),'Marker'), ...
               'MarkerFaceColor',patch_marker_face_color, ...
               'MarkerEdgeColor',patch_marker_edge_color, ...
               'MarkerSize',max(round(get(old_objects(1,j),'MarkerSize')*x_scaling),1));
            if isempty(get(old_objects(1,j),'UserData'))==0;
               leg_objects = [leg_objects this_patch];
            end;
         elseif strcmp(get(old_objects(1,j),'Type'),'surface')==1;
            num_surfaces = num_surfaces+1;
            this_surface = surface('Xdata',get(surfhandles(1,num_surfaces),'XData'), ...
               'YData',get(surfhandles(1,num_surfaces),'YData'), ...
               'ZData',get(surfhandles(1,num_surfaces),'ZData'), ...
               'UserData',surfhandles(1,num_surfaces), ...
               'Tag',get(surfhandles(1,num_surfaces),'Tag'), ...
               'Parent',new_axes, ...
               'Visible',get(surfhandles(1,num_surfaces),'Visible'), ...
               'UIContextMenu',my_context, ...
               'CData',get(surfhandles(1,num_surfaces),'CData'), ...
               'CDataMapping',get(surfhandles(1,num_surfaces),'CDataMapping'), ...
               'EdgeColor',get(surfhandles(1,num_surfaces),'EdgeColor'), ...
               'FaceColor',get(surfhandles(1,num_surfaces),'FaceColor'), ...
               'AmbientStrength',get(surfhandles(1,num_surfaces),'AmbientStrength'), ...
               'BackFaceLighting',get(surfhandles(1,num_surfaces),'BackFaceLighting'), ...
               'DiffuseStrength',get(surfhandles(1,num_surfaces),'DiffuseStrength'), ...
               'EdgeLighting',get(surfhandles(1,num_surfaces),'EdgeLighting'), ...
               'FaceLighting',get(surfhandles(1,num_surfaces),'FaceLighting'), ...
               'SpecularColorReflectance',get(surfhandles(1,num_surfaces),'SpecularColorReflectance'), ...
               'SpecularExponent',get(surfhandles(1,num_surfaces),'SpecularExponent'), ...
               'SpecularStrength',get(surfhandles(1,num_surfaces),'SpecularStrength'), ...
               'LineStyle',get(surfhandles(1,num_surfaces),'LineStyle'), ...
               'LineWidth',get(surfhandles(1,num_surfaces),'LineWidth')*x_scaling, ...
               'Marker',get(surfhandles(1,num_surfaces),'Marker'), ...
               'MarkerSize',max(round(get(surfhandles(1,num_surfaces),'MarkerSize')*x_scaling),1), ...
               'MarkerFaceColor',get(surfhandles(1,num_surfaces),'MarkerFaceColor'), ...
               'MarkerEdgeColor',get(surfhandles(1,num_surfaces),'MarkerEdgeColor'));
            if isempty(get(surfhandles(1,num_surfaces),'UserData'))==0;
               leg_objects = [leg_objects this_surface];
            end;
         elseif strcmp(get(old_objects(1,j),'Type'),'image')==1;
            num_images = num_images+1;
            image('CData',get(imagehandles(1,num_images),'CData'), ...
               'CDataMapping',get(imagehandles(1,num_images),'CDataMapping'), ...
               'UserData',imagehandles(1,num_images), ...
               'Parent',new_axes, ...
               'Visible',get(imagehandles(1,num_images),'Visible'), ...
               'UIContextMenu',my_context, ...
               'Tag',get(imagehandles(1,num_images),'Tag'), ...
               'XData',get(imagehandles(1,num_images),'XData'), ...
               'YData',get(imagehandles(1,num_images),'YData'));
         elseif strcmp(get(old_objects(1,j),'Type'),'light')==1;
            num_lights = num_lights+1;
            light_color = get(lighthandles(1,num_lights),'Color');
            if strcmp(inv_hardcopy,'on')==1;
               if isnumeric(light_color(1))==1;
                  light_color = mean(light_color)*ones(1,3);
                  if max(light_color)>1;
                     light_color = (1/255)*abs(light_color);
                  end;
               end;
            end;
            light('Color',light_color, ...
               'UserData',lighthandles(1,num_lights), ...
               'Position',get(lighthandles(1,num_lights),'Position'), ...
               'Parent',new_axes, ...
               'Tag',get(lighthandles(1,num_lights),'Tag'), ...
               'Visible',get(lighthandles(1,num_lights),'Visible'), ...
               'Style',get(lighthandles(1,num_lights),'Style'));
         end;
         hold('on');
      end;
   end;
   %
   % deal with text
   %
   texthandles = sort(findobj(myaxes(1,i),'Type','text')');
   if isempty(texthandles)==0;
      for j=1:size(texthandles,2);
         old_text_units = get(texthandles(1,j),'Units');
         set(texthandles(1,j),'Units','data');
         text_color = get(texthandles(1,j),'Color');
         if strcmp(inv_hardcopy,'on')==1;
            text_color = mean(text_color)*ones(1,3);
         end;
         text('Units','data', ...
            'Position',get(texthandles(1,j),'Position'), ...
            'String',get(texthandles(1,j),'String'), ...
            'HorizontalAlignment',get(texthandles(1,j),'HorizontalAlignment'), ...
            'VerticalAlignment',get(texthandles(1,j),'VerticalAlignment'), ...
            'UserData',texthandles(1,j), ...
            'Color',text_color, ...
            'Parent',new_axes, ...
            'Visible',get(texthandles(1,j),'Visible'), ...
            'UIContextMenu',my_context, ...
            'FontName',get(texthandles(1,j),'FontName'), ...
            'FontSize',round(get(texthandles(1,j),'FontSize')*font_scaling), ...
            'FontWeight',get(texthandles(1,j),'FontWeight'), ...
            'FontUnits',get(texthandles(1,j),'FontUnits'), ...
            'FontAngle',get(texthandles(1,j),'FontAngle'));
         set(texthandles(1,j),'Units',old_text_units);
      end;
   end;
   %
   re_p = [];
   if istimeseries(new_axes)==1;
      re_p = [re_p;sort([findobj(new_axes,'Tag','rectpatch');findobj(new_axes,'Tag','rectpatch-new')])];
   end;
   re_p = [re_p;sort([findobj(new_axes,'Tag','confpatch');findobj(new_axes,'Tag','confpatch-new')])];
   re_p = [re_p;sort([findobj(new_axes,'Type','patch','Tag','import-data');findobj(new_axes,'Type','patch','Tag','import-data-new')])];
   %
   %
   if isempty(re_p)==0;
      kids = get(new_axes,'Children');
      new_kids = [];
      for i1=1:size(kids,1);
         del_kid = 0;
         for j=1:size(re_p,1);
            if kids(i1,1)==re_p(j,1);
               del_kid = 1;
               break;
            end;
         end;
         if del_kid==0;
            new_kids = [new_kids;kids(i1,1)];
         end;
      end;
      set(new_axes,'Children',[re_p;new_kids]);
   end;
   %
   if curr_ini.ytick==1;
      fixytix(new_axes);
   end;
   if curr_ini.xtick==1;
      fixxtix(new_axes);
   end;
   %
   these_axes = [these_axes new_axes];
   set(myaxes(1,i),'Units',old_axes_units);
end;

%
% deal with legends
%

for i=1:size(myaxes,2);
   new_leg = [];
   if isempty(get(myaxes(1,i),'UserData'))==0;
      if ishandle(get(myaxes(1,i),'UserData'))==1;
         leg_handle = get(myaxes(1,i),'UserData');
      else;
         leg_handle = find_legend(myaxes(1,i));
      end;
      if (isempty(leg_handle)==0)&(strcmp(get(leg_handle,'Visible'),'on')==1);
         old_leg_units = get(leg_handle,'Units');
         set(leg_handle,'Units','normalized');
         leg_pos = get(leg_handle,'Position');
         real_leg_pos = leg_pos;
         %
         % deal with axes width and height
         %
         leg_pos(3) = gui_pos(3)*leg_pos(3);
         leg_pos(4) = gui_pos(4)*leg_pos(4);
         %
         % deal with left and bottom
         %
         leg_pos(1) = gui_pos(1)+(gui_pos(3)*leg_pos(1));
         leg_pos(2) = gui_pos(2)+(gui_pos(4)*leg_pos(2));
         %
         % resize legend based on x_scaling and y_scaling
         % need to determine relative position
         %
         leg_ud = get(leg_handle,'UserData');
         real_axes_handle = leg_ud.PlotHandle;
         old_real_axes_units = get(real_axes_handle,'Units');
         set(real_axes_handle,'Units','normalized');
         real_axes_pos = get(real_axes_handle,'Position');
         set(real_axes_handle,'Units',old_real_axes_units);
         %
         % now we can compare positions (treat outside as lower-left
         %
         if real_leg_pos(1)-real_axes_pos(1)<(real_axes_pos(1)+real_axes_pos(3))-(real_leg_pos(1)+real_leg_pos(3));
            left = 1;
         else;
            left = 0;
         end;
         if real_leg_pos(2)-real_axes_pos(2)<(real_axes_pos(2)+real_axes_pos(4))-(real_leg_pos(2)+real_leg_pos(4));
            lower_c = 1;
         else;
            lower_c = 0;
         end;
         %
         % now we adjust the size of leg_pos
         %
         if (left==1)&(lower_c==0);
            leg_pos(2) = leg_pos(2)+((1-y_fig_scaling)*leg_pos(4));
         elseif (left==0)&(lower_c==0);
            leg_pos(1) = leg_pos(1)+((1-x_fig_scaling)*leg_pos(3));
            leg_pos(2) = leg_pos(2)+((1-y_fig_scaling)*leg_pos(4));
         elseif (left==0)&(lower_c==1);
            leg_pos(1) = leg_pos(1)+((1-x_fig_scaling)*leg_pos(3));
         end;
         leg_pos(3) = x_fig_scaling*leg_pos(3);
         leg_pos(4) = y_fig_scaling*leg_pos(4);
         %
         % colors
         %
         leg_color = get(leg_handle,'Color');
         leg_xcolor = get(leg_handle,'XColor');
         leg_ycolor = get(leg_handle,'YColor');
         if strcmp(inv_hardcopy,'on')==1;
            leg_color = [1 1 1];
            leg_xcolor = [0 0 0];
            leg_ycolor = [0 0 0];
         end;
         new_leg = axes('Units','normalized', ...
            'Position',leg_pos, ...
            'Color',leg_color, ...
            'XColor',leg_xcolor, ...
            'YColor',leg_ycolor, ...
            'AmbientLightColor',get(leg_handle,'AmbientLightColor'), ...
            'CLim',get(leg_handle,'CLim'), ...
            'CLimMode',get(leg_handle,'CLimMode'), ...
            'ColorOrder',get(leg_handle,'ColorOrder'), ...
            'Box','on', ...
            'UIContextMenu',my_context, ...
            'XLim',get(leg_handle,'XLim'), ...
            'YLim',get(leg_handle,'YLim'), ...
            'TickLength',get(leg_handle,'TickLength'), ...
            'XTickLabel',[], ...
            'YTickLabel',[], ...
            'XScale',get(leg_handle,'XScale'), ...
            'YScale',get(leg_handle,'YScale'), ...
            'XTick',get(leg_handle,'XTick'), ...
            'YTick',get(leg_handle,'YTick'), ...
            'XTickMode','manual', ...
            'YTickMode','manual');
         %
         % dealing with lines and patches in legends
         %
         leg_linehandles = sort(findobj(leg_handle,'Type','line')');
         leg_patchhandles = sort(findobj(leg_handle,'Type','patch')');
         old_leg_objects = sort([leg_linehandles leg_patchhandles]);
         leg_ud = get(leg_handle,'UserData');
         if isempty(old_leg_objects)==0;
            num_leg_lines = 0;
            num_leg_patches = 0;
            for j=1:size(old_leg_objects,2);
               if strcmp(get(old_leg_objects(1,j),'Type'),'line')==1;
                  num_leg_lines = num_leg_lines+1;
                  line_color = get(leg_linehandles(1,num_leg_lines),'Color');
                  if strcmp(inv_hardcopy,'on')==1;
                     line_color = mean(line_color)*ones(1,3);
                  end;
                  my_userdata.handle = leg_linehandles(1,num_leg_lines);
                  line('XData',get(leg_linehandles(1,num_leg_lines),'XData'), ...
                     'YData',get(leg_linehandles(1,num_leg_lines),'YData'), ...
                     'Zdata',get(leg_linehandles(1,num_leg_lines),'ZData'), ...
                     'Parent',new_leg, ...
                     'UIContextMenu',my_context, ...
                     'UserData',my_userdata, ...
                     'Color',line_color, ...
                     'LineStyle',get(leg_linehandles(1,num_leg_lines),'LineStyle'), ...
                     'LineWidth',get(leg_linehandles(1,num_leg_lines),'LineWidth')*x_scaling, ...
                     'Marker',get(leg_linehandles(1,num_leg_lines),'Marker'), ...
                     'MarkerSize',max(round(get(leg_linehandles(1,num_leg_lines),'MarkerSize')*x_scaling),1));
               elseif strcmp(get(old_leg_objects(1,j),'Type'),'patch')==1;
                  num_leg_patches = num_leg_patches+1;
                  patch_face_color = get(leg_patchhandles(1,num_leg_patches),'FaceColor');
                  patch_edge_color = get(leg_patchhandles(1,num_leg_patches),'EdgeColor');
                  patch_marker_face_color = get(leg_patchhandles(1,num_leg_patches),'MarkerFaceColor');
                  patch_marker_edge_color = get(leg_patchhandles(1,num_leg_patches),'MarkerEdgeColor');
                  if strcmp(inv_hardcopy,'on')==1;
                     if isnumeric(patch_face_color(1))==1;
                        patch_face_color = mean(patch_face_color)*ones(1,3);
                     end;
                     if isnumeric(patch_edge_color(1))==1;
                        patch_edge_color = mean(patch_edge_color)*ones(1,3);
                     end;
                     if isnumeric(patch_marker_face_color(1))==1;
                        patch_marker_face_color = mean(patch_marker_face_color)*ones(1,3);
                     end;
                     if isnumeric(patch_marker_edge_color(1))==1;
                        patch_marker_edge_color = mean(patch_marker_edge_color)*ones(1,3);
                     end;
                  end;
                  if isnumeric(patch_marker_face_color(1))==1;
                     if patch_marker_face_color(1)>1;
                        patch_marker_face_color = (1/255)*patch_marker_face_color;
                     end;
                  end;
                  if isnumeric(patch_marker_edge_color(1))==1;
                     if patch_marker_edge_color(1)>1;
                        patch_marker_edge_color = (1/255)*patch_marker_edge_color;
                     end;
                  end;
                  my_userdata.handle = leg_patchhandles(1,num_leg_patches);
                  this_patch = patch('XData',get(leg_patchhandles(1,num_leg_patches),'XData'), ...
                     'YData',get(leg_patchhandles(1,num_leg_patches),'YData'), ...
                     'Parent',new_leg, ...
                     'UIContextMenu',my_context, ...
                     'UserData',my_userdata, ...
                     'FaceColor',patch_face_color, ...
                     'EdgeColor',patch_edge_color, ...
                     'CData',get(leg_patchhandles(1,num_leg_patches),'CData'), ...
                     'CDataMapping',get(leg_patchhandles(1,num_leg_patches),'CDataMapping'), ...
                     'AmbientStrength',get(leg_patchhandles(1,num_leg_patches),'AmbientStrength'), ...
                     'BackFaceLighting',get(leg_patchhandles(1,num_leg_patches),'BackFaceLighting'), ...
                     'DiffuseStrength',get(leg_patchhandles(1,num_leg_patches),'DiffuseStrength'), ...
                     'EdgeLighting',get(leg_patchhandles(1,num_leg_patches),'EdgeLighting'), ...
                     'FaceLighting',get(leg_patchhandles(1,num_leg_patches),'FaceLighting'), ...
                     'SpecularColorReflectance',get(leg_patchhandles(1,num_leg_patches),'SpecularColorReflectance'), ...
                     'SpecularExponent',get(leg_patchhandles(1,num_leg_patches),'SpecularExponent'), ...
                     'SpecularStrength',get(leg_patchhandles(1,num_leg_patches),'SpecularStrength'), ...
                     'Clipping',get(leg_patchhandles(1,num_leg_patches),'Clipping'), ...
                     'LineStyle',get(leg_patchhandles(1,num_leg_patches),'LineStyle'), ...
                     'LineWidth',get(leg_patchhandles(1,num_leg_patches),'LineWidth')*x_scaling, ...
                     'Marker',get(leg_patchhandles(1,num_leg_patches),'Marker'), ...
                     'MarkerFaceColor',patch_marker_face_color, ...
                     'MarkerEdgeColor',patch_marker_edge_color, ...
                     'MarkerSize',max(round(get(leg_patchhandles(1,num_leg_patches),'MarkerSize')*x_scaling),1));
               end;
            end;
         end;
         %
         % include text in legend
         %
         leg_texthandles = sort(findobj(leg_handle,'Type','text')');
         if isempty(leg_texthandles)==0;
            for j=1:size(leg_texthandles,2);
               old_text_units = get(leg_texthandles(1,j),'Units');
               set(leg_texthandles(1,j),'Units','data');
               text_color = get(leg_texthandles(1,j),'Color');
               if strcmp(inv_hardcopy,'on')==1;
                  text_color = mean(text_color)*ones(1,3);
               end;
               my_userdata.handle = leg_texthandles(1,j);
               text('Units','data', ...
                  'Position',get(leg_texthandles(1,j),'Position'), ...
                  'String',get(leg_texthandles(1,j),'String'), ...
                  'HorizontalAlignment',get(leg_texthandles(1,j),'HorizontalAlignment'), ...
                  'VerticalAlignment',get(leg_texthandles(1,j),'VerticalAlignment'), ...
                  'UserData',my_userdata, ...
                  'Color',text_color, ...
                  'Parent',new_leg, ...
                  'UIContextMenu',my_context, ...
                  'FontName',get(leg_texthandles(1,j),'FontName'), ...
                  'FontSize',round(get(leg_texthandles(1,j),'FontSize')*font_scaling), ...
                  'FontWeight',get(leg_texthandles(1,j),'FontWeight'), ...
                  'FontUnits',get(leg_texthandles(1,j),'FontUnits'), ...
                  'FontAngle',get(leg_texthandles(1,j),'FontAngle'));
               set(leg_texthandles(1,j),'Units',old_text_units);
            end;
         end;
         set(leg_handle,'Units',old_leg_units);
      end;
   end;
   these_axes = [these_axes new_leg];
end;

%
% locate a potential colorbar
%

this_colorbar = findobj(fig,'Type','axes','Tag','colorbar')';

if isempty(this_colorbar)==0;
   if strcmp(get(this_colorbar,'Visible'),'on')==1;
      for i=1:size(this_colorbar,2);
         old_axes_units = get(this_colorbar(1,i),'Units');
         set(this_colorbar(1,i),'Units','normalized');
         axes_pos = get(this_colorbar(1,i),'Position');
         %
         % deal with axes width and height
         %
         axes_pos(3) = gui_pos(3)*axes_pos(3);
         axes_pos(4) = gui_pos(4)*axes_pos(4);
         %
         % deal with left and bottom
         %
         axes_pos(1) = gui_pos(1)+(gui_pos(3)*axes_pos(1));
         axes_pos(2) = gui_pos(2)+(gui_pos(4)*axes_pos(2));
         ax_box = get(this_colorbar(1,i),'Box');
         ax_xgrid = get(this_colorbar(1,i),'XGrid');
         ax_ygrid = get(this_colorbar(1,i),'YGrid');
         ax_zgrid = get(this_colorbar(1,i),'ZGrid');
         ax_fontangle = get(this_colorbar(1,i),'FontAngle');
         ax_fontname = get(this_colorbar(1,i),'FontName');
         ax_fontsize = round(get(this_colorbar(1,i),'FontSize')*font_scaling);
         ax_fontunits = get(this_colorbar(1,i),'FontUnits');
         ax_fontweight = get(this_colorbar(1,i),'FontWeight');
         ax_xlim = get(this_colorbar(1,i),'XLim');
         ax_ylim = get(this_colorbar(1,i),'YLim');
         ax_zlim = get(this_colorbar(1,i),'ZLim');
         ax_xscale = get(this_colorbar(1,i),'XScale');
         ax_yscale = get(this_colorbar(1,i),'YScale');
         ax_zscale = get(this_colorbar(1,i),'ZScale');
         ax_xtick = get(this_colorbar(1,i),'XTick');
         ax_ytick = get(this_colorbar(1,i),'YTick');
         ax_ztick = get(this_colorbar(1,i),'ZTick');
         ax_xtickmode = get(this_colorbar(1,i),'XTickMode');
         ax_ytickmode = get(this_colorbar(1,i),'YTickMode');
         ax_ztickmode = get(this_colorbar(1,i),'ZTickMode');
         ax_color = get(this_colorbar(1,i),'Color');
         ax_xcolor = get(this_colorbar(1,i),'XColor');
         ax_ycolor = get(this_colorbar(1,i),'YColor');
         ax_zcolor = get(this_colorbar(1,i),'ZColor');
         ax_layer = get(this_colorbar(1,i),'Layer');
         ax_ambientlightcolor = get(this_colorbar(1,i),'AmbientLightColor');
         ax_clim = get(this_colorbar(1,i),'CLim');
         ax_climmode = get(this_colorbar(1,i),'CLimMode');
         ax_colororder = get(this_colorbar(1,i),'ColorOrder');
         ax_xaxislocation = get(this_colorbar(1,i),'XAxisLocation');
         ax_yaxislocation = get(this_colorbar(1,i),'YAxisLocation');
         ax_view = get(this_colorbar(1,i),'View');
         %
         % create the axes
         %
         new_axes = axes('Units','normalized', ...
            'Position',axes_pos, ...
            'Box',ax_box, ...
            'AmbientLightColor',ax_ambientlightcolor, ...
            'CLim',ax_clim, ...
            'CLimMode',ax_climmode, ...
            'ColorOrder',ax_colororder, ...
            'UIContextMenu',my_context, ...
            'XGrid',ax_xgrid, ...
            'YGrid',ax_ygrid, ...
            'ZGrid',ax_zgrid, ...
            'FontAngle',ax_fontangle, ...
            'FontName',ax_fontname, ...
            'FontSize',ax_fontsize, ...
            'FontUnits',ax_fontunits, ...
            'FontWeight',ax_fontweight, ...
            'XLim',ax_xlim, ...
            'YLim',ax_ylim, ...
            'ZLim',ax_zlim, ...
            'XScale',ax_xscale, ...
            'YScale',ax_yscale, ...
            'ZScale',ax_zscale, ...
            'XTick',ax_xtick, ...
            'YTick',ax_ytick, ...
            'ZTick',ax_ztick, ...
            'XTickMode','manual', ...
            'YTickMode','manual', ...
            'ZTickMode','manual', ...
            'XAxisLocation',ax_xaxislocation, ...
            'YAxisLocation',ax_yaxislocation, ...
            'View',ax_view, ...
            'Tag',get(this_colorbar(1,i),'Tag'), ...
            'UserData',this_colorbar(1,i), ...
            'Color',ax_color, ...
            'Layer',ax_layer, ...
            'XColor',ax_xcolor, ...
            'YColor',ax_ycolor, ...
            'ZColor',ax_zcolor);
         %
         % recreate the image
         %
         imagehandles = findobj(this_colorbar(1,i),'Type','image')';
         for j=1:size(imagehandles,2);
            image('CData',get(imagehandles(1,j),'CData'), ...
               'CDataMapping',get(imagehandles(1,j),'CDataMapping'), ...
               'UserData',imagehandles(1,j), ...
               'Parent',new_axes, ...
               'UIContextMenu',my_context, ...
               'XData',get(imagehandles(1,j),'XData'), ...
               'YData',get(imagehandles(1,j),'YData'));
         end;
         these_axes = [these_axes new_axes];
         set(this_colorbar(1,i),'Units',old_axes_units);
      end;
   end;
end;
hold('off');

set(this_gui,'Units',old_gui_units);

%
% end of create_preview_plots_fcn.m
%
