function delete_legend_fcn(this_axes)

if nargin==0;
   this_axes = gca;
end;

h = gcf;
old_leg = get(this_axes,'UserData');

if ishandle(old_leg)==0;
   old_leg = find_legend(this_axes);
end;

set(this_axes,'UserData',[]);
toolbar = get(h,'UserData');
myaxes = get(toolbar.print,'UserData');

%
% delete old legend
%

delete_legend(old_leg);

%
% delete user data in toolbar.new if gca corresponds to axes in that user data
%

myfonts = get(toolbar.new,'UserData');
if isempty(myfonts)==0;
   if isfield(myfonts,'parent')==1;
      num_parents = size(myfonts.parent,2);
      fontpos = 0;
      for i=1:num_parents;
         if myfonts.parent(i)==this_axes;
            fontpos = i;
            break;
         end;
      end;
      if fontpos>0;
         if num_parents==1;
            newfonts = [];
         else;
            count = 0;
            for i=1:num_parents;
               if (i<fontpos)|(i>fontpos);
                  count = count+1;
                  newfonts.parent(count) = myfonts.parent(i);
                  newfonts.font(count).fontname = myfonts.font(i).fontname;
                  newfonts.font(count).fontsize = myfonts.font(i).fontsize;
                  newfonts.font(count).fontangle = myfonts.font(i).fontangle;
                  newfonts.font(count).fontweight = myfonts.font(i).fontweight;
                  newfonts.font(count).fontunits = myfonts.font(i).fontunits;
               end;
            end;
         end;
         set(toolbar.new,'UserData',newfonts);
      end;
   else;
      set(toolbar.new,'UserData',[]);
   end;
end;

%
% delete old context menu and create a new one
%

create_axes_contextmenu_fcn(this_axes);

%
% make sure that uimenu allows us to show legend once a new one has been created
%

leg_toolbar_label = get(toolbar.legend,'Label');
if strcmp(leg_toolbar_label,'Hide &Legend')==0;
   toolbar_legend_fcn;
end;

%
% reset legend positions data for toolbar.edit UserData info (legpos new variable)
%

if isempty(get(toolbar.edit,'UserData'))==1;
   set(toolbar.legend,'Enable','off');
else;
   all_leg_handles = [];
   for i=1:size(myaxes,2);
      new_leg_handle = get(myaxes(1,i),'UserData');
      if isempty(new_leg_handle)==0;
         if ishandle(new_leg_handle)==1;
            all_leg_handles = [all_leg_handles new_leg_handle];
         end;
      end;
   end;
   thislegpos = [];
   for i=1:size(all_leg_handles,2);
      old_units = get(all_leg_handles(1,i),'Units');
      set(all_leg_handles(1,i),'Units','pixels');
      newlegpos = get(all_leg_handles(1,i),'Position');
      thislegpos = [thislegpos;newlegpos];
      set(all_leg_handles(1,i),'Units',old_units);
      set(toolbar.edit,'UserData',thislegpos);
   end;
   if isempty(thislegpos)==1;
      set(toolbar.legend,'Enable','off');
   end;
end;

%
% end of delete_legend_fcn.m
%
