function [pos,spec_ploti] = dist_plot(pos,fig_tag,fig_name,p_title,tm,curr_ini,my_structure,as_sorted,as_series,do_bart,fix_ax_pos,fix_leg_pos,col,my_80,my_90,my_95,my_975,my_99,numcells,df,bart_c,sim_str)

if nargin<21;
   bart_c = [];
end;
if nargin<22;
   sim_str = '';
end;

rep = size(as_sorted,1);

%
% plotting the distributions
%

spec_ploti = figure('Units','pixels', ...
   'Position',[pos 600 400], ...
   'Menubar','none', ...
   'Toolbar','none', ...
   'Tag',fig_tag, ...
   'NumberTitle','off', ...
   'Visible','off', ...
   'Name',fig_name);
%
pos = [pos(1)+22 pos(2)-22];
if pos(1,1)>(tm.realscrsz(3)-600);
   pos = [0 tm.realscrsz(4)-470];
end;
%
if (gcbo==my_structure.histogram)|(gcbo==my_structure.histogrammenu);
   if pos(1,2)>(tm.realscrsz(4)-470);
      pos = [0 tm.realscrsz(4)-470];
   elseif pos(1,2)<32;
      pos = [0 tm.realscrsz(4)-470];
   end;
else;
   if isfield(my_structure,'pqplot')==1;
      check_pqplot = get(my_structure.pqplot,'Value');
   else;
      check_pqplot = 0;
   end;
   if check_pqplot==1;
      b_lim = 132;
   else;
      b_lim = 32;
   end;
   if pos(1,2)>(tm.realscrsz(4)-470);
      pos = [0 tm.realscrsz(4)-470];
   elseif pos(1,2)<b_lim;
      pos = [0 tm.realscrsz(4)-470];
   end;
end;
%
% obey centering and filling defaults
%
setfigureproperties(spec_ploti);
%
[n1,n2] = hist(as_sorted,numcells);
n1 = n1/rep;
ylabelstr = 'Frequency';
if fix_leg_pos==0;
   leg_pos = 1;
else;
   leg_pos = 2;
end;
cdf_value = get(my_structure.cdf,'Value');
if (gcbo==my_structure.histogram)|(gcbo==my_structure.histogrammenu);
   if cdf_value==1;
      n1 = cumsum(n1);
      set(spec_ploti,'Name',strrep(get(spec_ploti,'Name'),'Density','Distribution'));
   end;
   %
   n3 = bar(n2,n1,0.75);
   if curr_ini.colors==1;
      set(n3,'FaceColor',[0 0 0.8],'EdgeColor','k','LineWidth',1,'Tag','autopatch');
   else;
      set(n3,'FaceColor',[0.5 0.5 0.5],'EdgeColor','k','LineWidth',1,'Tag','autopatch');
   end;
   myleg = [];
   if cdf_value==1;
      set(gca,'YLim',[0 1.1],'XLim',[0 max(n2)+n2(1,2)-n2(1,1)]);
   end;
else;
   ylabelstr = 'Density';
   %
   if (strcmp(tm.interpolate,'nearest')==1)|(strcmp(tm.interpolate,'linear')==1)|(strcmp(tm.interpolate,'spline')==1)|(strcmp(tm.interpolate,'cubic')==1);
      x_v = [];
      xsep = (n2(2)-n2(1))/100;
      for i=1:size(n2,2);
         x_v = [x_v n2(i)];
         if i<size(n2,2);
            for j=1:99;
               x_v = [x_v (n2(i)+(j*xsep))];
            end;
         end;
      end;
      x_v = sort(x_v);
      n3 = interp1(n2,n1,x_v,tm.interpolate);
      cdf_n3 = cdf(x_v,n3);
      n3 = (1/max(cdf_n3))*n3;
      if isempty(as_series)==0;
         [t1,t2] = hist(as_series,numcells);
         t1 = t1/10000;
         t_v = [];
         tsep = (t2(2)-t2(1))/100;
         for i=1:size(t2,2);
            t_v = [t_v t2(i)];
            if i<size(t2,2);
               for j=1:99;
                  t_v = [t_v (t2(i)+(j*tsep))];
               end;
            end;
         end;
         t_v = sort(t_v);
         t3 = interp1(t2,t1,t_v,tm.interpolate);
         cdf_t3 = cdf(t_v,t3);
         t3 = (1/max(cdf_t3))*t3;
         if cdf_value==1;
            t3 = cdf(t_v,t3);
         end;
      end;
   else;
      xmin = min(as_sorted);
      xmax = max(as_sorted);
      xrange = xmax-xmin;
      ax = xmin-xrange/4;
      bx = xmax+xrange/4;
      if strcmp(tm.interpolate,'knorm')==1;
         h = 0;
      else;
         h = hns(as_sorted,tm.interpolate);
      end;
      if get(my_structure.adaptive,'Value')==1;
         [x_v,xa,n3,h,hl] = kdadapt(as_sorted,tm.interpolate,512,h);
      else;
         [x_v,n3] = kdfft1(as_sorted,tm.interpolate,512,h,0,[ax,bx]);
      end;
      n3 = (1/max(cdf(x_v,n3)))*n3;
      if isempty(as_series)==0;
         xmin = min(as_series);
         xmax = max(as_series);
         xrange = xmax-xmin;
         ax = xmin-xrange/4;
         bx = xmax+xrange/4;
         if strcmp(tm.interpolate,'knorm')==1;
            h = 0;
         else;
            h = hns(as_series,tm.interpolate);
         end;
         if get(my_structure.adaptive,'Value')==1;
            [t_v,xa,t3,h,hl] = kdadapt(as_series,tm.interpolate,512,h);
         else;
            [t_v,t3] = kdfft1(as_series,tm.interpolate,512,h,0,[ax,bx]);
         end;
         t3 = (1/max(cdf(t_v,t3)))*t3;
         if cdf_value==1;
            t3 = cdf(t_v,t3);
         end;
      end;
   end;
   if cdf_value==1;
      ylabelstr = 'Frequency';
      n3 = cdf(x_v,n3);
      if fix_leg_pos==0;
         leg_pos = 4;
      end;
      set(spec_ploti,'Name',strrep(get(spec_ploti,'Name'),'Density','Distribution'));
   end;
   %
   y_lim = [0 1.1*max(n3)];
   if isempty(as_series)==0;
      if max(t3)>max(n3);
         y_lim = [0 1.1*max(t3)];
      end;
      plot(t_v,t3,'LineWidth',1,'Color',col.vec_7,'LineStyle','--','Tag','asymp-dist');
      hold('on');
   end;
   plot(x_v,n3,'LineWidth',1,'Color',col.vec_1,'Tag','boot-dist');
   hold('on');
   %
   % if bootstrapped Bartlett correction is selected
   %
   if isfield(my_structure,'bart')==1;
      check_bart = get(my_structure.bart,'Value');
   else;
      check_bart = 0;
   end;
   %
   if (isempty(as_series)==0)&(check_bart==1)&(do_bart==1);
      if isempty(bart_c)==1;
         if (curr_ini.sscorrect==1)&(size(df,2)>1);
            mean_as = (1/size(as_series,1))*sum(as_series);
         else;
            mean_as = df(1,1);
         end;
         bart_c = (mean_as*size(as_sorted,1)/sum(as_sorted));
      end;
      new_x_v = bart_c*x_v;
      new_cdf = cdf(new_x_v,n3);
      if cdf_value==0;
         new_n3 = (1/max(new_cdf))*n3;
      else;
         new_n3 = n3;
      end;
      if isempty(as_series)==0;
         if max(new_n3)>max(max(t3),max(n3));
            y_lim = [0 1.1*max(new_n3)];
         end;
      else;
         if max(new_n3)>max(n3);
            y_lim = [0 1.1*max(new_n3)];
         end;
      end;
      plot(new_x_v,new_n3,'LineWidth',1,'Color',col.vec_8,'LineStyle','--','Tag','bart-boot-dist');
      hold('on');
   end;
   %
   set(gca,'YLim',y_lim);
   set(gca,'XLim',[0 max(x_v)]);
   %
   % check if we should correct X limits
   %
   if isempty(as_series)==0;
      if max(t_v)>max(x_v);
         set(gca,'XLim',[0 max(t_v)]);
      end;
   end;
   %
   % plotting quantiles
   %
   plot(as_sorted(my_80,1)*ones(1,2),y_lim,'Color',col.vec_2,'LineStyle',':','LineWidth',1);
   hold('on');
   plot(as_sorted(my_90,1)*ones(1,2),y_lim,'Color',col.vec_3,'LineStyle','-.','LineWidth',1);
   hold('on');
   plot(as_sorted(my_95,1)*ones(1,2),y_lim,'Color',col.vec_4,'LineStyle','-','LineWidth',1);
   hold('on');
   plot(as_sorted(my_975,1)*ones(1,2),y_lim,'Color',col.vec_5,'LineStyle','-.','LineWidth',1);
   hold('on');
   plot(as_sorted(my_99,1)*ones(1,2),y_lim,'Color',col.vec_6,'LineStyle',':','LineWidth',1);
   hold('off');
   %
   if (check_bart==1)&(do_bart==1);
      if isempty(as_series)==1;
         myleg = legend_fcn([sim_str 'Bootstrap'],['Bartlett Bootstrap (corr=' num2str(1/bart_c,'%0.3f') ')'],'80%','90%','95%','98%','99%',leg_pos);
      else;
         myleg = legend_fcn('Asymptotic',[sim_str 'Bootstrap'],['Bartlett Bootstrap (corr=' num2str(1/bart_c,'%0.3f') ')'],'80%','90%','95%','98%','99%',leg_pos);
      end;
   else;
      if isempty(as_series)==1;
         myleg = legend_fcn([sim_str 'Bootstrap'],'80%','90%','95%','98%','99%',leg_pos);
      else;
         myleg = legend_fcn('Asymptotic',[sim_str 'Bootstrap'],'80%','90%','95%','98%','99%',leg_pos);
      end;
   end;
end;
if fix_ax_pos==1;
   set(spec_ploti,'Position',get(spec_ploti,'Position')+[0 -10 0 10]);
end;
setaxesfonts('Title',p_title,'XLabel','Value','YLabel',ylabelstr);
if isempty(myleg)==0;
   setaxesfonts(myleg);
   myleg = update_legend(myleg);
end;
set(gca,'UserData',myleg);
toolbar_fcn(gca);
hold('off');

%
% end of dist_plot.m
%
