function [lnL_hA,beta,alpha,Psi,Omega,epsilon] = estimate_nyblomalt_alt(tm,boot_n,curr_ini,r,T,Rmat_a,rvec_a,Rmat_Ca,rvec_Ca,d_parm,d_coint,d_corel,d_coidet)

%
% estimate unrestricted beta
%
[S_00,S_01,S_10,S_11,M_02,M_22,M_12,beta_a,lambda,my_trace] = mlcointbasic(boot_n.Z0,boot_n.Z1,boot_n.Z2,r);
%
if tm.restrict(1,2)==1;
   [beta_a,dfbeta,con_rest] = beta_alt_estimate(S_00,S_11,S_01,S_10,beta_a,T,tm.modelsdir,tm.modelfile,tm.dcoint,tm.q1,d_coint,d_corel,d_coidet);
end;
%
alpha_a = (S_01*beta_a)*inverse(beta_a'*S_11*beta_a);
if isempty(boot_n.Z2)==0;
   Psi_a = (M_02*inverse(M_22))-(alpha_a*beta_a'*M_12*inverse(M_22));
   Z3 = [boot_n.Z2;beta_a'*boot_n.Z1];
else;
   Psi_a = [];
   Z3 = beta_a'*boot_n.Z1;
end;
Theta_a = [Psi_a alpha_a];
epsilon_a = boot_n.Z0-(Theta_a*Z3);
Omega_a = (1/T)*epsilon_a*epsilon_a';
%
% if there are alpha restrictions
%
if tm.restrict(1,1)==1;
   if curr_ini.reestbeta==0;
      [theta_a,Sigma_theta,infomat,newabort] = linrest(boot_n.Z0,Z3,Theta_a,Rmat_a,rvec_a,0);
   else;
      %
      % re-estimate beta under alpha restrictions
      %
      [theta_a,beta_a,Z3] = alpha_beta_alt_estimate(boot_n.Z0,boot_n.Z1,boot_n.Z2,Z3,beta_a,Theta_a,Rmat_a,rvec_a,tm.dcoint,tm.q1,tm.modelsdir,tm.modelfile,d_coint,d_corel,d_coidet);
   end;
   g2 = size(theta_a,2);
   alpha_a = theta_a(:,g2-tm.r+1:g2);
   if g2>tm.r;
      Psi_a = theta_a(:,1:g2-tm.r);
   else;
      Psi_a = [];
   end;
   epsilon_a = boot_n.Z0-(theta_a*Z3);
   Omega_a = (1/T)*epsilon_a*epsilon_a';
   Theta_a = theta_a;
end;
%
% consider restrictions on C
%
if (size(tm.restrict,2)==3)&(tm.restrict(1,3)==1);
   [theta_a,beta_a] = c_alt_restrict(boot_n.Z0,boot_n.Z1,boot_n.Z2,tm.restrict,beta_a,Theta_a,Rmat_Ca,rvec_Ca,tm.p,tm.pe,d_parm,tm.dcoint,tm.q0,tm.q1,tm.modelsdir,tm.modelfile,curr_ini.reestbeta,d_coint,d_corel,d_coidet);
   Z3 = [];
   if tm.r>0;
      Z3 = beta_a'*boot_n.Z1;
   end;
   Z3 = [boot_n.Z2;Z3];
   g2 = size(theta_a,2);
   alpha_a = theta_a(:,g2-tm.r+1:g2);
   if g2>tm.r;
      Psi_a = theta_a(:,1:g2-tm.r);
   else;
      Psi_a = [];
   end;
   %
   % fix all the other parameters
   %
   epsilon_a = boot_n.Z0-(theta_a*Z3);
   Omega_a = (1/T)*epsilon_a*epsilon_a';
end;
%
% Compute the LR-test
%
lnL_hA = loglike(epsilon_a);

if nargout>1;
   beta = beta_a;
   alpha = alpha_a;
   Psi = Psi_a;
   Omega = (1/T)*epsilon_a*epsilon_a';
   epsilon = epsilon_a;
end;

%
% end of estimate_nyblomalt_alt.m
%
