function export_data_fcn

h = get(0,'CurrentFigure');
this_axes = gca;
%
% looking for lines
%
linehandles = findobj(this_axes,'Type','line')';
if isempty(linehandles)==0;
   %
   % Remove zero lines from linehandles
   %
   fixhandles = [];
   for j=1:size(linehandles,2);
      checkvec = get(linehandles(1,j),'YData');
      checkvec2 = sum(get(linehandles(1,j),'XData'));
      checkstyle = get(linehandles(1,j),'LineStyle');
      %
      % need to remove those with nolegend-, varline-, 2dlines-, 3dlines- tags
      %
      checktag = get(linehandles(1,j),'Tag');
      if size(checktag,2)>8;
         checktag = checktag(1,1:8);
      end;
      if (isalmostequal(checkvec,get(linehandles(1,j),'XData'))==1)|(((checkvec==zeros(size(checkvec,1),1))|(checkvec2==zeros(size(checkvec2,1),1)))&((strcmp(checkstyle,'none')==0)|(isempty(get(linehandles(1,j),'UserData'))==0))|(strcmp(get(linehandles(1,j),'Tag'),'light')==1))|(strcmp(checktag,'varline-')==1)|(strcmp(checktag,'nolegend')==1)|(strcmp(checktag,'2dlines-')==1)|(strcmp(checktag,'3dlines-')==1)|(min(checkvec)==max(checkvec));
         fixhandles = [fixhandles 0];
      else;
         fixhandles = [fixhandles 1];
      end;
   end;
   linehandles = linehandles(fixhandles==1);
end;
%
if (size(linehandles,1)==0)|(size(linehandles,2)==0);
   linehandles = [];
end;
%
% Looking for patches
%
patchhandles = findobj(this_axes,'Type','patch')';
if isempty(patchhandles)==0;
   %
   % remove rectangles and confidence intervals
   %
   fixhandles = [];
   for i=1:size(patchhandles,2);
      if (strcmp(lower(get(patchhandles(1,i),'Tag')),'rectpatch')==1)|(strcmp(lower(get(patchhandles(1,i),'Tag')),'rectpatch-new')==1);
         fixhandles = [fixhandles 0];
      else;
         fixhandles = [fixhandles 1];
      end;
   end;
   patchhandles = patchhandles(fixhandles==1);
end;
%
if (size(patchhandles,1)==0)|(size(patchhandles,2)==0);
   patchhandles = [];
end;
if (isempty(linehandles)==1)&(isempty(patchhandles)==1);
   about('Structural VAR didn''t find any relevant data to save.','information','Bad Data...',120,350);
   return;
end;
%
% determine the output directory
%
fix_fig = findobj('Tag','StructuralVAR');
model = get(fix_fig,'UserData');
outputdir = getpath(get(model.outputfile,'String'));
num = 1;
check = 0;
while check==0;
   myfile = [outputdir 'export-data-' num2str(num,'%0.0f') '.data'];
   if fileexist(myfile)==0;
      check = 1;
   else;
      num = num+1;
   end;
end;
[savefile,savepath] = uiputfile(myfile,'Save As');
drawnow;
if isnumeric(savefile)==0;
   if strcmp(getext(savefile),'.mat')==1;
      savefile = [getname(savefile) '.data'];
   end;
   curr_ini = find_inisettings;
   prt_str = ['%0.' num2str(curr_ini.exportdata+3,'%0.0f') 'f'];
   setlogtext(['Exporting data to ' savefile '...']);
   txt = strvcat(' ',['Exporting data to "' savefile '". Please hold!']);
   mywait = waitdlg(txt,'information','Data Export',350,80);
   waitf = get(mywait,'UserData');
   %
   savefile = strcat(savepath,savefile);
   %
   % deal with lines
   %
   fid = fopen(savefile,'wt');
   if isempty(linehandles)==0;
      for i=1:size(linehandles,2);
         %
         % collect the data into column vectors
         %
         x_data = get(linehandles(1,i),'XData');
         if size(x_data,2)>size(x_data,1);
            x_data = x_data';
         end;
         y_data = get(linehandles(1,i),'YData');
         if size(y_data,2)>size(y_data,1);
            y_data = y_data';
         end;
         %
         % check the frequency of the data
         %
         ch_freq = x_data(2,1)-x_data(1,1);
         if isalmostequal(ch_freq,1)==1;
            this_freq = 1;
         elseif isalmostequal(ch_freq,1/4)==1;
            this_freq = 4;
         elseif isalmostequal(ch_freq,1/12)==1;
            this_freq = 12;
         else;
            this_freq = 0;
         end;
         %
         % fix the x_data and y_data into string matrices
         %
         if this_freq==1;
            if isalmostequal(x_data(1,1),0)==0;
               label_str = 'DATE';
               add_str = ':1';
            else;
               label_str = 'Period';
               add_str = '';
            end;
            x_str = [num2str(x_data(1,1),'%0.0f') add_str];
            y_str = ['   ' num2str(y_data(1,1),prt_str)];
            for j=2:size(x_data,1);
               x_str = strvcat(x_str,[num2str(x_data(j,1),'%0.0f') add_str]);
               y_str = strvcat(y_str,['   ' num2str(y_data(j,1),prt_str)]);
            end;
         elseif this_freq==4;
            x_str = getdate(x_data(1,1),x_data(size(x_data,1),1),'q',1/size(x_data,1));
            y_str = ['   ' num2str(y_data(1,1),prt_str)];
            for j=2:size(x_data,1);
               x_str = strvcat(x_str,getdate(x_data(1,1),x_data(size(x_data,1),1),'q',j/size(x_data,1)));
               y_str = strvcat(y_str,['   ' num2str(y_data(j,1),prt_str)]);
            end;
            label_str = 'DATE';
         elseif this_freq==12;
            x_str = getdate(x_data(1,1),x_data(size(x_data,1),1),'m',1/size(x_data,1));
            y_str = ['   ' num2str(y_data(1,1),prt_str)];
            for j=2:size(x_data,1);
               x_str = strvcat(x_str,getdate(x_data(1,1),x_data(size(x_data,1),1),'m',j/size(x_data,1)));
               y_str = strvcat(y_str,['   ' num2str(y_data(j,1),prt_str)]);
            end;
            label_str = 'DATE';
         else;
            x_str = num2str(x_data(1,1),prt_str);
            y_str = ['   ' num2str(y_data(1,1),prt_str)];
            for j=2:size(x_data,1);
               x_str = strvcat(x_str,num2str(x_data(j,1),prt_str));
               y_str = strvcat(y_str,['   ' num2str(y_data(j,1),prt_str)]);
            end;
            label_str = 'X-axis';
         end;
         %
         % try to determine a name for y_data variable
         %
         tag_str = get(linehandles(1,i),'Tag');
         if strcmp(tag_str,'')==0;
            label_str = [label_str '      ' tag_str];
         else;
            line_ud = get(linehandles(1,i),'UserData');
            if (isempty(line_ud)==0)&(ishandle(line_ud)==1);
               leg = get(line_ud,'Parent');
               leg_ud = get(leg,'UserData');
               chk = 0;
               if size(leg_ud.handles,2)>size(leg_ud.handles,1);
                  leg_ud.handles = leg_ud.handles';
               end;
               for i1=1:size(leg_ud.handles,1);
                  if leg_ud.handles(i1,1)==linehandles(1,i);
                     num = i1;
                     chk = 1;
                     break;
                  end;
               end;
               if chk==1;
                  if iscellstr(leg_ud.lstrings)==1;
                     label_str = [label_str '      ' leg_ud.lstrings{num}];
                  else;
                     if size(leg_ud.lstrings,1)>=num;
                        label_str = [label_str '      ' strtrim(leg_ud.lstrings(num,:))];
                     end;
                  end;
               else;
                  label_str = [label_str '      Y-axis data'];
               end;
            else;
               label_str = [label_str '      Y-axis data'];
            end;
         end;
         %
         % print to file
         %
         fprintf(fid,'%s\n',label_str);
         for j=1:size(x_str,1);
            fprintf(fid,'%s%s\n',x_str(j,:),y_str(j,:));
         end;
         fprintf(fid,'\n');
      end;
   end;
   %
   % deal with patches
   %
   if isempty(patchhandles)==0;
      for i=1:size(patchhandles,2);
         %
         % collect the data into column vectors
         %
         x_data = get(patchhandles(1,i),'XData');
         if size(x_data,2)>size(x_data,1);
            x_data = x_data';
         end;
         y_data = get(patchhandles(1,i),'YData');
         if size(y_data,2)>size(y_data,1);
            y_data = y_data';
         end;
         valid_p = 0;
         %
         % need to fix the y_data depending on the type of patch we have
         %
         if (strcmp(get(patchhandles(1,i),'Tag'),'confpatch')==1)|(strcmp(get(patchhandles(1,i),'Tag'),'confpatch-new')==1);
            %
            % we have a confidence region patch
            %
            y_data = [y_data(1:size(x_data,1)/2,1) reverse(y_data((size(x_data,1)/2)+1:size(x_data,1),1))];
            x_data = x_data(1:size(x_data,1)/2,1);
            valid_p = 1;
         elseif (strcmp(get(patchhandles(1,i),'Tag'),'autopatch')==1)|(strcmp(get(patchhandles(1,i),'Tag'),'autopatch-new')==1)|(strcmp(get(patchhandles(1,i),'Tag'),'distpatch')==1)|(strcmp(get(patchhandles(1,i),'Tag'),'distpatch-new')==1)|(strcmp(get(patchhandles(1,i),'Tag'),'import-data')==1)|(strcmp(get(patchhandles(1,i),'Tag'),'import-data-new')==1);
            %
            % we have a bar patch
            %
            x_data = (1/size(x_data,2))*sum(x_data,2);
            y_data = y_data(:,2);
            valid_p = 1;
         end;
         %
         if valid_p==1;
            %
            % check the frequency of the data
            %
            ch_freq = x_data(2,1)-x_data(1,1);
            if isalmostequal(ch_freq,1)==1;
               this_freq = 1;
            elseif isalmostequal(ch_freq,1/4)==1;
               this_freq = 4;
            elseif isalmostequal(ch_freq,1/12)==1;
               this_freq = 12;
            else;
               this_freq = 0;
            end;
            %
            % fix the x_data and y_data into string matrices
            %
            if this_freq==1;
               x_str_add = '';
               label_str = 'PERIOD';
               if x_data(1,1)>1;
                  x_str_add = ':1';
                  label_str = 'DATE';
               end;
               x_str = [num2str(x_data(1,1),'%0.0f') x_str_add];
               if size(y_data,2)==1;
                  y_str = ['   ' num2str(y_data(1,1),prt_str)];
               else;
                  y_str = ['   ' num2str(y_data(1,1),prt_str) '   ' num2str(y_data(1,2),prt_str)];
               end;
               for j=2:size(x_data,1);
                  x_str = strvcat(x_str,[num2str(x_data(j,1),'%0.0f') x_str_add]);
                  if size(y_data,2)==1;
                     y_str = strvcat(y_str,['   ' num2str(y_data(j,1),prt_str)]);
                  else;
                     y_str = strvcat(y_str,['   ' num2str(y_data(j,1),prt_str) '   ' num2str(y_data(j,2),prt_str)]);
                  end;
               end;
            elseif this_freq==4;
               x_str = getdate(x_data(1,1),x_data(size(x_data,1),1),'q',1/size(x_data,1));
               if size(y_data,2)==1;
                  y_str = ['   ' num2str(y_data(1,1),prt_str)];
               else;
                  y_str = ['   ' num2str(y_data(1,1),prt_str) '   ' num2str(y_data(1,2),prt_str)];
               end;
               for j=2:size(x_data,1);
                  x_str = strvcat(x_str,getdate(x_data(1,1),x_data(size(x_data,1),1),'q',j/size(x_data,1)));
                  if size(y_data,2)==1;
                     y_str = strvcat(y_str,['   ' num2str(y_data(j,1),prt_str)]);
                  else;
                     y_str = strvcat(y_str,['   ' num2str(y_data(j,1),prt_str) '   ' num2str(y_data(j,2),prt_str)]);
                  end;
               end;
               label_str = 'DATE';
            elseif this_freq==12;
               x_str = getdate(x_data(1,1),x_data(size(x_data,1),1),'m',1/size(x_data,1));
               if size(y_data,2)==1;
                  y_str = ['   ' num2str(y_data(1,1),prt_str)];
               else;
                  y_str = ['   ' num2str(y_data(1,1),prt_str) '   ' num2str(y_data(1,2),prt_str)];
               end;
               for j=2:size(x_data,1);
                  x_str = strvcat(x_str,getdate(x_data(1,1),x_data(size(x_data,1),1),'m',j/size(x_data,1)));
                  if size(y_data,2)==1;
                     y_str = strvcat(y_str,['   ' num2str(y_data(j,1),prt_str)]);
                  else;
                     y_str = strvcat(y_str,['   ' num2str(y_data(j,1),prt_str) '   ' num2str(y_data(j,2),prt_str)]);
                  end;
               end;
               label_str = 'DATE';
            else;
               x_str = num2str(x_data(1,1),prt_str);
               if size(y_data,2)==1;
                  y_str = ['   ' num2str(y_data(1,1),prt_str)];
               else;
                  y_str = ['   ' num2str(y_data(1,1),prt_str) '   ' num2str(y_data(1,2),prt_str)];
               end;
               for j=2:size(x_data,1);
                  x_str = strvcat(x_str,num2str(x_data(j,1),prt_str));
                  if size(y_data,2)==1;
                     y_str = strvcat(y_str,['   ' num2str(y_data(j,1),prt_str)]);
                  else;
                     y_str = strvcat(y_str,['   ' num2str(y_data(j,1),prt_str) '   ' num2str(y_data(j,2),prt_str)]);
                  end;
               end;
               label_str = 'X-axis';
            end;
            %
            %
            % try to determine a name for y_data variable
            %
            if size(y_data,2)==1;
               line_ud = get(patchhandles(1,i),'UserData');
               if (isempty(line_ud)==0)&(ishandle(line_ud)==1);
                  leg = get(line_ud,'Parent');
                  leg_ud = get(leg,'UserData');
                  chk = 0;
                  if size(leg_ud.handles,2)>size(leg_ud.handles,1);
                     leg_ud.handles = leg_ud.handles';
                  end;
                  for i1=1:size(leg_ud.handles,1);
                     if leg_ud.handles(i1,1)==patchhandles(1,i);
                        num = i1;
                        chk = 1;
                        break;
                     end;
                  end;
                  if chk==1;
                     if iscellstr(leg_ud.lstrings)==1;
                        label_str = [label_str '      ' leg_ud.lstrings{num}];
                     else;
                        if size(leg_ud.lstrings,1)>=num;
                           label_str = [label_str '      ' strtrim(leg_ud.lstrings(num,:))];
                        end;
                     end;
                  else;
                     label_str = [label_str '      ' get(patchhandles(1,i),'Tag')];
                  end;
               else;
                  label_str = [label_str '      ' get(patchhandles(1,i),'Tag')];
               end;
            else;
               label_str = [label_str '         upper         lower'];
            end;
            %
            % print to file
            %
            fprintf(fid,'%s\n',label_str);
            for j=1:size(x_str,1);
               fprintf(fid,'%s%s\n',x_str(j,:),y_str(j,:));
            end;
            fprintf(fid,'\n');
            %
         end;
      end;
   end;
   fclose(fid);
   set(waitf.text,'UserData','done');
   delete(mywait);
   drawnow;
end;


%
% end of export_data_fcn.m
%
