function [c,ceq,GC,GCeq] = fiml_con_fcn(phi,tm,type_var,Z0,Z1,Z2,beta,r,Nn,Rmat_alpha,rvec_alpha,Rmat_lr,rvec_lr,Rmat_sr,rvec_sr)

c = [];
ceq = [];

[n T] = size(Z0);

Theta = vecinv(phi,n);
theta = phi(1:size(phi,1)-(n*n),1);

if isempty(Z2)==0;
   Psi = Theta(:,1:size(Z2,1));
   if r>0;
      alpha = Theta(:,size(Theta,2)-(n+r)+1:size(Theta,2)-n);
   else;
      alpha = [];
   end;
else;
   alpha = Theta(:,1:r);
   Psi = [];
end;
B = Theta(:,size(Theta,2)-n+1:size(Theta,2));

if (isempty(Z2)==0)&(r>0);
  epsilon = Z0-(Psi*Z2)-(alpha*beta'*Z1);
elseif (isempty(Z2)==0)&(r==0);
  epsilon = Z0-(Psi*Z2);
elseif (isempty(Z2)==1)&(r>0);
  epsilon = Z0-(alpha*beta'*Z1);
else;
  epsilon = Z0;
end;

%
% evaluate restrictions
%

if isempty(Rmat_alpha)==0;
   ceq = (Rmat_alpha*theta)-rvec_alpha;
end;

if strcmp(type_var,'short_run')==0;
   if r<n;
      C = cmat(Psi,alpha,beta,epsilon,Z1,Z2,tm.p,tm.d,0);
   else;
      C = cmat_stat(Psi,alpha,beta,epsilon,Z1,Z2,tm.p,tm.d,0,[]);
   end;
   xi = xi_mat(C,Psi,alpha,tm.p,tm.pe,r,tm.d,tm.q1,tm.q0);
   lr_ceq = (Rmat_lr*vec(C*B))-rvec_lr;
   ceq = [ceq;lr_ceq];
end;

if isempty(Rmat_sr)==0;
   sr_ceq = (Rmat_sr*vec(B))-rvec_sr;
   ceq = [ceq;sr_ceq];
end;

if nargout>2;
   GC = [];
   GCeq = [];
   if isempty(Rmat_alpha)==0;
      GCeq = [Rmat_alpha zeros(size(Rmat_alpha,1),n*n)];
   end;
   if strcmp(type_var,'short_run')==0;
      lr_GCeq = Rmat_lr*[kron(B'*xi',C) kron(eye(n),C)];
      GCeq = [GCeq;lr_GCeq];
   end;
   if isempty(Rmat_sr)==0;
      sr_GCeq = [zeros(size(Rmat_sr,1),size(theta,1)) Rmat_sr];
      GCeq = [GCeq;sr_GCeq];
   end;
   GCeq = GCeq';
end;

%
% end of fiml_con_fcn.m
%
