function [omega,p] = ml_omega(cm)

omega = [];

%
% check if we can use the suggested lag order
%

p = cm.amat_lag-1;
check_lag = 0;

while check_lag==0;
   if isempty(cm.x2)==1;
      [X0,X1] = vardata(cm.x0,p,[cm.x1 cm.x1_r]);
   else;
      [X0,X1] = vardata(cm.x0,p,[cm.x1 cm.x1_r],cm.x2,cm.q1,cm.pe);
   end;
   T = size(X0,2);
   n_test = size(X1,1);
   if T>n_test;
      check_lag = 1;
   else;
      p = p-1;
      if p==0;
         check_lag = 1;
      end;
   end;
end;

if p==0;
   return;
end;

%
% estimate the residual covariance matrix for p lags
%

B = X0*X1'*inverse(X1*X1');
epsilon = X0-(B*X1);
omega = (1/T)*epsilon*epsilon';

%
% end of ml_omega.m
%
