function msg = nargoutchk(low,high,number)
%NARGOUTCHK Validate number of output arguments. 
%   MSG = NARGOUTCHK(LOW,HIGH,N) returns an appropriate error message if
%   N is not between low and high. If it is, return empty matrix.
%
%   See also NARGIN, NARGOUT, NARGCHK, INPUTNAME.

msg = [];
if (number < low)
    msg = 'Not enough output arguments.';
elseif (number > high)
    msg = 'Too many output arguments.';
end
