function openfig_fcn(file,new_pos)

if nargin==1;
   new_pos = [];
end;
if (strcmp(lower(getname(file)),'figuretoolbar')==1)|(strcmp(lower(getname(file)),'figuremenubar')==1)|(strcmp(lower(getname(file)),'studentfiguremenubar')==1);
   my_text = ['The file "' getfilename(file) '" cannot be opened by Structural VAR.'];
   about(my_text,'information','Invalid file...',120,350);
   return;
else;
   if (matlabnumber>=6)&(strcmp(computer,'PCWIN')==1);
      %
      % to be on the safe side we cd to file directory, open it from there and cd back to current directory
      %
      old_path = pwd;
      new_path = getpath(file);
      file = getfilename(file);
      cd(new_path);
      open(file);
      cd(old_path);
      file = [new_path file];
   else;
      open(file);
   end;
end;

curr_ini = find_inisettings;

if (curr_ini.use_toolbar_bgcolor==1)&(strcmp(get(gcf,'Renderer'),'zbuffer')==1);
   figcolor = (1/255)*(round(255*get(0,'defaultuicontrolbackgroundcolor'))-[8 4 8]);
   figcolor(1) = max(0,figcolor(1));
   figcolor(2) = max(0,figcolor(2));
   figcolor(3) = max(0,figcolor(3));
else;
   figcolor = get(0,'defaultuicontrolbackgroundcolor');
end;

set(gcf,'Visible','off');
pos = get(gcf,'Position');
%realscrsz = get(0,'ScreenSize');

fig_name = get(gcf,'Name');
if size(fig_name,2)>=12;
   check_figname = fig_name(1,1:12);
else;
   check_figname = '';
end;
if strcmp(lower(check_figname),'figeditor - ')==1;
   fig_name = fig_name(1,13:size(fig_name,2));
   set(gcf,'Name',fig_name);
end;
maingui = findobj('Type','figure','Tag','StructuralVAR');
if (isempty(maingui)==0)&(ishandle(maingui)==1)&(strcmp(get(maingui,'Visible'),'off')==1);
   set(gcf,'Name',['FigEditor - ' fig_name]);
end;

if iscompiled==1;
   toolbar = get(gcf,'UserData');
   if (isempty(toolbar)==0)&(isfield(toolbar,'print')==1)&(ishandle(toolbar.print)==1)&(isfield(toolbar,'box1')==1)&(ishandle(toolbar.box1)==1);
      toolbar_fields = fieldnames(toolbar);
      if isempty(get(toolbar.print,'UserData'))==0;
         myaxes = get(toolbar.print,'UserData');
      else;
         myaxes = [];
      end;
      %
      % delete old toolbar, but store user data from toolbar fields into old_toolbar structure.
      % these values are then reset into user data of new toolbar
      %
      old_toolbar = [];
      for i=1:size(toolbar_fields,1);
         if ishandle(getfield(toolbar,toolbar_fields{i}))==1;
            if isempty(get(getfield(toolbar,toolbar_fields{i}),'UserData'))==0;
               old_toolbar = setfield(old_toolbar,toolbar_fields{i},get(getfield(toolbar,toolbar_fields{i}),'UserData'));
            end;
            delete(getfield(toolbar,toolbar_fields{i}));
         end;
      end;
      %
      % delete uimenus
      %
      my_tools = findobj(gcf,'Tag','ToolsMenu')';
      my_files = findobj(gcf,'Tag','FileMenu')';
      my_edits = findobj(gcf,'Tag','EditMenu')';
      my_helps = findobj(gcf,'Tag','HelpMenu')';
      if isempty(my_files)==0;
         for i=1:size(my_files,2);
            delete(my_files(1,i));
         end;
      end;
      if isempty(my_tools)==0;
         for i=1:size(my_tools,2);
            delete(my_tools(1,i));
         end;
      end;
      if isempty(my_edits)==0;
         for i=1:size(my_edits,2);
            delete(my_edits(1,i));
         end;
      end;
      if isempty(my_helps)==0;
         for i=1:size(my_helps,2);
            delete(my_helps(1,i));
         end;
      end;
      old_myaxes = myaxes;
      %
      % dealing with legends and moving axes to match
      % with new toolbar
      %
      this_colorbar = findobj(gcf,'Type','axes','Tag','colorbar')';
      if isempty(this_colorbar)==0;
         if strcmp(get(this_colorbar,'Visible'),'on')==1;
            old_axes_handle = get(this_colorbar,'UserData');
            set(this_colorbar,'UserData',[]);
            myaxes = [myaxes this_colorbar];
         end;
      end;
      old_units = get(myaxes(1,1),'Units');
      set(myaxes(1,1),'Units','pixels');
      ax_pos = get(myaxes(1,1),'Position');
      set(myaxes(1,1),'Units',old_units);
      ref_point = ax_pos(1:2);
      num_rows = 1;
      for i=2:size(myaxes,2);
         old_units = get(myaxes(1,i),'Units');
         set(myaxes(1,i),'Units','pixels');
         ax_pos = get(myaxes(1,i),'Position');
         set(myaxes(1,i),'Units',old_units);
         new_point = ax_pos(1:2);
         if (new_point(1)==ref_point(1))&(new_point(2)<ref_point(2));
            num_rows = num_rows+1;
            ref_point = new_point;
         end;
      end;
      num_cols = ceil(size(myaxes,2)/num_rows);
      %
      % now we now the number of rows and columns of axes that exist
      % in the current figure. it remains to fix the axes such
      % they are in combination 40 pixels smaller in height
      %
      adj_height = 40/num_rows;
      count = 0;
      for i=1:num_rows;
         for j=1:num_cols;
            count = count+1;
            if count<=size(myaxes,2);
               %
               % fix all the in-between rows of axes in the graph
               %
               old_units = get(myaxes(1,count),'Units');
               set(myaxes(1,count),'Units','pixels');
               axpos = get(myaxes(1,count),'Position')+[0 (num_rows-i)*adj_height 0 adj_height];
%               set(myaxes(1,count),'Position',axpos);
               set(myaxes(1,count),'Units','normalized');
               if isempty(get(myaxes(1,count),'UserData'))==0;
                  myleg = get(myaxes(1,count),'UserData');
                  set(myleg,'Units','pixels');
                  legpos = get(myleg,'Position');
                  if (legpos(2)+legpos(4)<axpos(2)+axpos(4))&((axpos(4)+axpos(2))-(legpos(4)+legpos(2))<legpos(2)-axpos(2));
                     legpos = legpos+[0 (num_rows-i+1)*adj_height 0 0];
%                     set(myleg,'Position',legpos);
                  end;
                  set(myleg,'Units','normalized');
                  leg_ud = get(myleg,'UserData');
%                  leg_ud.AxesPosition = get(myaxes(1,count),'Position');
%                  leg_ud.PlotPosition = get(myaxes(1,count),'Position');
%                  leg_ud.LegendPosition = get(myleg,'Position');
                  set(myleg,'UserData',leg_ud);
               end;
               set(myaxes(1,count),'Units',old_units);
            end;
         end;
      end;
      if isempty(this_colorbar)==0;
         if strcmp(get(this_colorbar,'Visible'),'on')==1;
            set(this_colorbar,'UserData',old_axes_handle);
         end;
      end;
      %
      % set up new toolbar
      %
      toolbar_fcn(old_myaxes);
      toolbar = get(gcf,'UserData');
      for i=1:size(toolbar_fields,1);
         if isfield(old_toolbar,toolbar_fields{i})==1;
            if (isempty(getfield(old_toolbar,toolbar_fields{i}))==0)&(strcmp(toolbar_fields{i},'saveas')==0)&(isfield(toolbar,toolbar_fields{i})==1)&(strcmp(toolbar_fields{i},'alignment')==0)&(strcmp(toolbar_fields{i},'about')==0);
               set(getfield(toolbar,toolbar_fields{i}),'UserData',getfield(old_toolbar,toolbar_fields{i}))
            end;
         end;
      end;
   else;
      this_axes = sort(findobj(gcf,'Type','axes')');
      if isempty(this_axes)==0
         my_axes = [];
         for j=1:size(this_axes,2);
            if strcmp(get(get(this_axes(1,j),'Title'),'string'),'')==0;
               my_axes = [my_axes this_axes(1,j)];
            end;
         end;
         if isempty(my_axes)==0;
            toolbar_fcn(my_axes);
         else;
            my_text = ['The file "' getfilename(file) '" cannot be opened by Structural VAR.'];
            about(my_text,'information','Invalid file...',120,350);
            return;
         end;
      end;
   end;
   if (isempty(new_pos)==0)&(size(new_pos,1)==1)&(size(new_pos,2)==4);
      pos = new_pos;
   end;
   set(gcf,'Menubar','none','Toolbar','none','Visible','on','Color',figcolor,'Position',pos,'Pointer','arrow');
else;
   my_tools = findobj(gcf,'Tag','ToolsMenu')';
   my_files = findobj(gcf,'Tag','FileMenu')';
   my_edits = findobj(gcf,'Tag','EditMenu')';
   my_helps = findobj(gcf,'Tag','HelpMenu')';
   if isempty(my_files)==0;
      for i=1:size(my_files,2);
         delete(my_files(1,i));
      end;
   end;
   if isempty(my_tools)==0;
      for i=1:size(my_tools,2);
         delete(my_tools(1,i));
      end;
   end;
   if isempty(my_edits)==0;
      for i=1:size(my_edits,2);
         delete(my_edits(1,i));
      end;
   end;
   if isempty(my_helps)==0;
      for i=1:size(my_helps,2);
         delete(my_helps(1,i));
      end;
   end;
   %
   % try to see if a toolbar from the stand-alone release
   % is hidden. if it is, it should be deleted
   %
   toolbar = get(gcf,'UserData');
   if (isempty(toolbar)==0)&(isfield(toolbar,'print')==1)&(ishandle(toolbar.print)==1)&(isfield(toolbar,'box1')==1)&(ishandle(toolbar.box1)==1);
      set(gcf,'ResizeFcn','');
      if isempty(get(toolbar.print,'UserData'))==0;
         axeshandles = get(toolbar.print,'UserData');
         if ishandle(axeshandles(1,1))==0;
            axeshandles = [];
         end;
      else;
         axeshandles = [];
      end;
      if isempty(axeshandles)==0;
         %
         % delete old toolbar
         %
         toolbar_fields = fieldnames(toolbar);
         for i=1:size(toolbar_fields,1);
            if ishandle(getfield(toolbar,toolbar_fields{i}))==1;
               delete(getfield(toolbar,toolbar_fields{i}));
            end;
         end;
         %
         % dealing with legends and moving axes to match
         % with new toolbar
         %
         this_colorbar = findobj(gcf,'Type','axes','Tag','colorbar')';
         if isempty(this_colorbar)==0;
            if strcmp(get(this_colorbar,'Visible'),'on')==1;
               old_axes_handle = get(this_colorbar,'UserData');
               set(this_colorbar,'UserData',[]);
               axeshandles = [axeshandles this_colorbar];
            end;
         end;
         old_units = get(axeshandles(1,1),'Units');
         set(axeshandles(1,1),'Units','pixels');
         ax_pos = get(axeshandles(1,1),'Position');
         set(axeshandles(1,1),'Units',old_units);
         ref_point = ax_pos(1:2);
         num_rows = 1;
         for i=2:size(axeshandles,2);
            old_units = get(axeshandles(1,i),'Units');
            set(axeshandles(1,i),'Units','pixels');
            ax_pos = get(axeshandles(1,i),'Position');
            set(axeshandles(1,i),'Units',old_units);
            new_point = ax_pos(1:2);
            if (new_point(1)==ref_point(1))&(new_point(2)<ref_point(2));
               num_rows = num_rows+1;
               ref_point = new_point;
            end;
         end;
         num_cols = ceil(size(axeshandles,2)/num_rows);
         %
         % now we now the number of rows and columns of axes that exist
         % in the current figure. it remains to fix the axes such
         % they are in combination 40 pixels smaller in height
         %
         adj_height = 40/num_rows;
         count = 0;
         for i=1:num_rows;
            for j=1:num_cols;
               count = count+1;
               if count<=size(axeshandles,2);
                  %
                  % fix all the in-between rows of axes in the graph
                  %
                  old_units = get(axeshandles(1,count),'Units');
                  set(axeshandles(1,count),'Units','pixels');
                  axpos = get(axeshandles(1,count),'Position')+[0 (num_rows-i)*adj_height 0 adj_height];
%                  set(axeshandles(1,count),'Position',axpos);
                  set(axeshandles(1,count),'Units','normalized');
                  if isempty(get(axeshandles(1,count),'UserData'))==0;
                     myleg = get(axeshandles(1,count),'UserData');
                     set(myleg,'Units','pixels');
                     legpos = get(myleg,'Position');
                     if (legpos(2)+legpos(4)<axpos(2)+axpos(4))&((axpos(4)+axpos(2))-(legpos(4)+legpos(2))<legpos(2)-axpos(2));
                        legpos = legpos+[0 (num_rows-i+1)*adj_height 0 0];
%                        set(myleg,'Position',legpos);
                     end;
                     set(myleg,'Units','normalized');
                     leg_ud = get(myleg,'UserData');
%                     leg_ud.AxesPosition = get(axeshandles(1,count),'Position');
%                     leg_ud.PlotPosition = get(axeshandles(1,count),'Position');
%                     leg_ud.LegendPosition = get(myleg,'Position');
                     legcontext = uicontextmenu('Callback','set(gcf,''Pointer'',''arrow'')');
                     uimenu('Parent',legcontext,'Label','Font','Callback','change_legend_font');
                     uimenu('Parent',legcontext,'Label','Text Color','Separator','on','Callback','change_legend_text_color');
                     uimenu('Parent',legcontext,'Label','Background Color','Callback','change_axes_color');
                     uimenu('Parent',legcontext,'Label','Border Color','Callback','change_legend_color');
                     leg_ud.UIContextMenu = legcontext;
                     set(myleg,'UIContextMenu',legcontext,'UserData',leg_ud);
                     set(get(myleg,'Children'),'UIContextMenu',legcontext);
                  end;
                  set(axeshandles(1,count),'Units',old_units);
               end;
            end;
         end;
         if isempty(this_colorbar)==0;
            if strcmp(get(this_colorbar,'Visible'),'on')==1;
               set(this_colorbar,'UserData',old_axes_handle);
            end;
         end;
         %
         % delete any context menus and button down functions linked
         % with titles and labels
         %
         mylines = [];
         mypatches = [];
         mysurf = [];
         for i=1:size(axeshandles,2);
            set(axeshandles(1,i),'UIContextMenu','');
            set(get(axeshandles(1,i),'Title'),'UIContextMenu','','ButtonDownFcn','');
            set(get(axeshandles(1,i),'XLabel'),'UIContextMenu','','ButtonDownFcn','');
            set(get(axeshandles(1,i),'YLabel'),'UIContextMenu','','ButtonDownFcn','');
            set(get(axeshandles(1,i),'ZLabel'),'UIContextMenu','','ButtonDownFcn','');
            linehandles = findobj(axeshandles(1,i),'Type','line')';
            mylines = [mylines linehandles];
            patchhandles = findobj(axeshandles(1,i),'Type','patch')';
            mypatches = [mypatches patchhandles];
            mysurf = [mysurf findobj(axeshandles(1,i),'Type','surface')'];
         end;
         %
         % delete context menus linked with lines and patches
         %
         if isempty(mylines)==0;
            for j=1:size(mylines,2);
               if strcmp(get(mylines(1,j),'Tag'),'light')==0;
                  set(mylines(1,j),'UIContextMenu','');
               end;
            end;
         end;
         if isempty(mypatches)==0;
            for j=1:size(mypatches,2);
               set(mypatches(1,j),'UIContextMenu','');
            end;
         end;
         %
         % edit context menu's related to surfaces
         %
         if isempty(mysurf)==0;
            for j=1:size(mysurf,2);
               this_context = get(mysurf(1,j),'UIContextMenu');
               kids = sort(get(this_context,'Children')');
               num_del_kids = 0;
               for j1=1:size(kids,2);
                  if (strcmp(lower(get(kids(1,j1),'Label')),'cut')==1)|(strcmp(lower(get(kids(1,j1),'Label')),'copy')==1);
                     delete(kids(1,j1));
                     num_del_kids = num_del_kids+1;
                  end;
               end;
               if num_del_kids==size(kids,2);
                  set(mysurf(1,j),'UIContextMenu',[]);
               else;
                  set(mysurf(1,j),'UIContextMenu',this_context);
               end;
            end;
         end;
         toolbar_fcn(axeshandles);
      end;
   else;
      %
      % check to make sure that gcf is not a Structural VAR figure
      %
      this_tag = get(gcf,'Tag');
      if size(this_tag,2)>=14;
         this_tag = this_tag(1,1:14);
      end;
      if strcmp(this_tag,'Structural VAR')==1;
         my_text = ['The file "' getfilename(file) '" cannot be opened by Structural VAR.'];
         about(my_text,'information','Invalid file...',120,350);
         return;
      end;
   end;
   if strcmp(get(gcf,'Menubar'),'figure')==0;
      set(gcf,'Menubar','figure','Toolbar','auto');
   end;
   if (isempty(new_pos)==0)&(size(new_pos,1)==1)&(size(new_pos,2)==4);
      set(gcf,'Position',new_pos);
   end;
   set(gcf,'Visible','on','Color',figcolor,'ResizeFcn','','Pointer','arrow');
end;

%
% end of openfig_fcn.m
%
