function paste_line_fcn

fix_fig = findobj('Tag','StructuralVAR');
model = get(fix_fig,'UserData');
copy = get(model.run,'UserData');
if isempty(copy)==0;
   if isfield(copy,'line_properties')==1;
      if strcmp(get(gca,'XLimMode'),'manual')==1;
         old_xlim = get(gca,'XLim');
         copy_xlim = [min(copy.line_properties.xdata) max(copy.line_properties.xdata)];
         if old_xlim==[0 1];
            new_xlim = copy_xlim;
         else;
            new_xlim = [min(old_xlim(1),copy_xlim(1)) max(old_xlim(2),copy_xlim(2))];
         end;
         if new_xlim(1)==new_xlim(2);
            new_xlim = [new_xlim(1)-0.1 new_xlim(2)+0.1];
         end;
      end;
      if strcmp(get(gca,'YLimMode'),'manual')==1;
         old_ylim = get(gca,'YLim');
         copy_ylim = [min(copy.line_properties.ydata) max(copy.line_properties.ydata)];
         if old_ylim==[0 1];
            new_ylim = copy_ylim;
         else;
            new_ylim = [min(old_ylim(1),copy_ylim(1)) max(old_ylim(2),copy_ylim(2))];
         end;
         if new_ylim(1)==new_ylim(2);
            new_ylim = [new_ylim(1)-0.1 new_ylim(2)+0.1];
         end;
      end;
      if strcmp(get(gca,'ZLimMode'),'manual')==1;
         old_zlim = get(gca,'ZLim');
         if isempty(copy.line_properties.zdata)==0;
            copy_zlim = [min(copy.line_properties.zdata) max(copy.line_properties.zdata)];
            if old_zlim==[0 1];
               new_zlim = copy_zlim;
            else;
               new_zlim = [min(old_zlim(1),copy_zlim(1)) max(old_zlim(2),copy_zlim(2))];
            end;
         else;
            new_zlim = old_zlim;
         end;
         if new_zlim(1)==new_zlim(2);
            new_zlim = [new_zlim(1)-0.1 new_zlim(2)+0.1];
         end;
      end;
      %
      % create a new line
      %
      this_line = line('XData',copy.line_properties.xdata, ...
         'YData',copy.line_properties.ydata, ...
         'Zdata',copy.line_properties.zdata, ...
         'Color',copy.line_properties.color, ...
         'LineStyle',copy.line_properties.linestyle, ...
         'LineWidth',copy.line_properties.linewidth, ...
         'Marker',copy.line_properties.marker, ...
         'MarkerSize',copy.line_properties.markersize, ...
         'MarkerEdgeColor',copy.line_properties.markeredgecolor, ...
         'MarkerFaceColor',copy.line_properties.markerfacecolor, ...
         'Tag',[copy.line_properties.tag '-new']);
      %
      if strcmp(get(gca,'XLimMode'),'manual')==1;
         set(gca,'XLim',new_xlim);
      end;
      if strcmp(get(gca,'YLimMode'),'manual')==1;
         set(gca,'YLim',new_ylim);
      end;
      if strcmp(get(gca,'ZLimMode'),'manual')==1;
         set(gca,'ZLim',new_zlim);
      end;
      %
      curr_ini = find_inisettings;
      if curr_ini.ytick==1;
         fixytix(gca);
      end;
      if curr_ini.xtick==1;
         fixxtix(gca);
      end;
      %
      % add a context menu to the new line
      %
      if strcmp(get(this_line,'LineStyle'),'-')==1;
         solidon = 'on';
      else;
         solidon = 'off';
      end;
      if strcmp(get(this_line,'LineStyle'),'--')==1;
         dashon = 'on';
      else;
         dashon = 'off';
      end;
      if strcmp(get(this_line,'LineStyle'),':')==1;
         doton = 'on';
      else;
         doton = 'off';
      end;
      if strcmp(get(this_line,'LineStyle'),'-.')==1;
         dashdoton = 'on';
      else;
         dashdoton = 'off';
      end;
      if strcmp(get(this_line,'LineStyle'),'none')==1;
         noneon = 'on';
      else;
         noneon = 'off';
      end;
      lines_context_menu = uicontextmenu('Callback','set(gcf,''Pointer'',''arrow'')');
      tag_str = get(this_line,'Tag');
      if size(tag_str,2)>=8;
         tag_str = tag_str(1,1:8);
      end;
      tag_str = strtrim(tag_str);
      if strcmp(tag_str,'scatter-')==0;
         uimenu('Parent',lines_context_menu,'Label','Color','Callback','lines_color_fcn');
         line_type_menu = uimenu('Parent',lines_context_menu,'Separator','on','Label','Type');
            uimenu('Parent',line_type_menu,'Label','Solid','Checked',solidon,'Callback','set(gco,''LineStyle'',''-''); lines_type_fcn; uimenu_check_fcn');
            uimenu('Parent',line_type_menu,'Label','Dash','Checked',dashon,'Callback','set(gco,''LineStyle'',''--''); lines_type_fcn; uimenu_check_fcn');
            uimenu('Parent',line_type_menu,'Label','Dot','Checked',doton,'Callback','set(gco,''LineStyle'','':''); lines_type_fcn; uimenu_check_fcn');
            uimenu('Parent',line_type_menu,'Label','Dash-Dot','Checked',dashdoton,'Callback','set(gco,''LineStyle'',''-.''); lines_type_fcn; uimenu_check_fcn');
            uimenu('Parent',line_type_menu,'Label','None','Checked',noneon,'Callback','set(gco,''LineStyle'',''none''); lines_type_fcn; uimenu_check_fcn');
         pt1 = 'off';
         pt2 = 'off';
         pt3 = 'off';
         pt4 = 'off';
         pt5 = 'off';
         pt6 = 'off';
         pt7 = 'off';
         pt8 = 'off';
         pt9 = 'off';
         pt10 = 'off';
         if get(this_line,'LineWidth')==1;
            pt1 = 'on';
         elseif get(this_line,'LineWidth')==2;
            pt2 = 'on';
         elseif get(this_line,'LineWidth')==3;
            pt3 = 'on';
         elseif get(this_line,'LineWidth')==4;
            pt4 = 'on';
         elseif get(this_line,'LineWidth')==5;
            pt5 = 'on';
         elseif get(this_line,'LineWidth')==6;
            pt6 = 'on';
         elseif get(this_line,'LineWidth')==7;
            pt7 = 'on';
         elseif get(this_line,'LineWidth')==8;
            pt8 = 'on';
         elseif get(this_line,'LineWidth')==9;
            pt9 = 'on';
         elseif get(this_line,'LineWidth')==10;
            pt10 = 'on';
         end;
         line_width_menu = uimenu('Parent',lines_context_menu,'Label','Width');
            uimenu('Parent',line_width_menu,'Label','1 pt','Checked',pt1,'Callback','set(gco,''LineWidth'',1); lines_type_fcn; uimenu_check_fcn');
            uimenu('Parent',line_width_menu,'Label','2 pts','Checked',pt2,'Callback','set(gco,''LineWidth'',2); lines_type_fcn; uimenu_check_fcn');
            uimenu('Parent',line_width_menu,'Label','3 pts','Checked',pt3,'Callback','set(gco,''LineWidth'',3); lines_type_fcn; uimenu_check_fcn');
            uimenu('Parent',line_width_menu,'Label','4 pts','Checked',pt4,'Callback','set(gco,''LineWidth'',4); lines_type_fcn; uimenu_check_fcn');
            uimenu('Parent',line_width_menu,'Label','5 pts','Checked',pt5,'Callback','set(gco,''LineWidth'',5); lines_type_fcn; uimenu_check_fcn');
            uimenu('Parent',line_width_menu,'Label','6 pts','Checked',pt6,'Callback','set(gco,''LineWidth'',6); lines_type_fcn; uimenu_check_fcn');
            uimenu('Parent',line_width_menu,'Label','7 pts','Checked',pt7,'Callback','set(gco,''LineWidth'',7); lines_type_fcn; uimenu_check_fcn');
            uimenu('Parent',line_width_menu,'Label','8 pts','Checked',pt8,'Callback','set(gco,''LineWidth'',8); lines_type_fcn; uimenu_check_fcn');
            uimenu('Parent',line_width_menu,'Label','9 pts','Checked',pt9,'Callback','set(gco,''LineWidth'',9); lines_type_fcn; uimenu_check_fcn');
            uimenu('Parent',line_width_menu,'Label','10 pts','Checked',pt10,'Callback','set(gco,''LineWidth'',10); lines_type_fcn; uimenu_check_fcn');
         sep_str = 'off';
      else;
         uimenu('Parent',lines_context_menu,'Label','Color','Callback','scatter_color_fcn');
         sep_str = 'on';
      end;
      %
      mark_none = 'off';
      mark_plus = 'off';
      mark_circle = 'off';
      mark_asterisk = 'off';
      mark_point = 'off';
      mark_cross = 'off';
      mark_square = 'off';
      mark_diamond = 'off';
      mark_up = 'off';
      mark_down = 'off';
      mark_right = 'off';
      mark_left = 'off';
      mark_pentagram = 'off';
      mark_hexagram = 'off';
      if strcmp(get(this_line,'Marker'),'none')==1;
         mark_none = 'on';
      elseif strcmp(get(this_line,'Marker'),'+')==1;
         mark_plus = 'on';
      elseif strcmp(get(this_line,'Marker'),'o')==1;
         mark_circle = 'on';
      elseif strcmp(get(this_line,'Marker'),'*')==1;
         mark_asterisk = 'on';
      elseif strcmp(get(this_line,'Marker'),'.')==1;
         mark_point = 'on';
      elseif strcmp(get(this_line,'Marker'),'x')==1;
         mark_cross = 'on';
      elseif strcmp(get(this_line,'Marker'),'s')==1;
         mark_square = 'on';
      elseif strcmp(get(this_line,'Marker'),'d')==1;
         mark_diamond = 'on';
      elseif strcmp(get(this_line,'Marker'),'^')==1;
         mark_up = 'on';
      elseif strcmp(get(this_line,'Marker'),'v')==1;
         mark_down = 'on';
      elseif strcmp(get(this_line,'Marker'),'>')==1;
         mark_right = 'on';
      elseif strcmp(get(this_line,'Marker'),'<')==1;
         mark_left = 'on';
      elseif strcmp(get(this_line,'Marker'),'p')==1;
         mark_pentagram = 'on';
      elseif strcmp(get(this_line,'Marker'),'h')==1;
         mark_hexagram = 'on';
      end;
      line_marker_menu = uimenu('Parent',lines_context_menu,'Label','Marker','Separator',sep_str);
         if strcmp(tag_str,'scatter-')==0;
            uimenu('Parent',line_marker_menu,'Label','none','Checked',mark_none,'Callback','set(gco,''Marker'',''none''); lines_type_fcn; uimenu_check_fcn');
         end;
         uimenu('Parent',line_marker_menu,'Label','plus sign','Checked',mark_plus,'Callback','set(gco,''Marker'',''+''); lines_type_fcn; uimenu_check_fcn');
         uimenu('Parent',line_marker_menu,'Label','circle','Checked',mark_circle,'Callback','set(gco,''Marker'',''o''); lines_type_fcn; uimenu_check_fcn');
         uimenu('Parent',line_marker_menu,'Label','asterisk','Checked',mark_asterisk,'Callback','set(gco,''Marker'',''*''); lines_type_fcn; uimenu_check_fcn');
         uimenu('Parent',line_marker_menu,'Label','point','Checked',mark_point,'Callback','set(gco,''Marker'',''.''); lines_type_fcn; uimenu_check_fcn');
         uimenu('Parent',line_marker_menu,'Label','cross','Checked',mark_cross,'Callback','set(gco,''Marker'',''x''); lines_type_fcn; uimenu_check_fcn');
         uimenu('Parent',line_marker_menu,'Label','square','Checked',mark_square,'Callback','set(gco,''Marker'',''s''); lines_type_fcn; uimenu_check_fcn');
         uimenu('Parent',line_marker_menu,'Label','diamond','Checked',mark_diamond,'Callback','set(gco,''Marker'',''d''); lines_type_fcn; uimenu_check_fcn');
         uimenu('Parent',line_marker_menu,'Label','up triangle','Checked',mark_up,'Callback','set(gco,''Marker'',''^''); lines_type_fcn; uimenu_check_fcn');
         uimenu('Parent',line_marker_menu,'Label','down triangle','Checked',mark_down,'Callback','set(gco,''Marker'',''v''); lines_type_fcn; uimenu_check_fcn');
         uimenu('Parent',line_marker_menu,'Label','right triangle','Checked',mark_right,'Callback','set(gco,''Marker'',''>''); lines_type_fcn; uimenu_check_fcn');
         uimenu('Parent',line_marker_menu,'Label','left triangle','Checked',mark_left,'Callback','set(gco,''Marker'',''<''); lines_type_fcn; uimenu_check_fcn');
         uimenu('Parent',line_marker_menu,'Label','pentagram','Checked',mark_pentagram,'Callback','set(gco,''Marker'',''p''); lines_type_fcn; uimenu_check_fcn');
         uimenu('Parent',line_marker_menu,'Label','hexagram','Checked',mark_hexagram,'Callback','set(gco,''Marker'',''h''); lines_type_fcn; uimenu_check_fcn');
      pt1 = 'off';
      pt2 = 'off';
      pt3 = 'off';
      pt4 = 'off';
      pt5 = 'off';
      pt6 = 'off';
      pt7 = 'off';
      pt8 = 'off';
      pt9 = 'off';
      pt10 = 'off';
      pt11 = 'off';
      pt12 = 'off';
      pt13 = 'off';
      pt14 = 'off';
      pt15 = 'off';
      pt16 = 'off';
      if get(this_line,'MarkerSize')==1;
         pt1 = 'on';
      elseif get(this_line,'MarkerSize')==2;
         pt2 = 'on';
      elseif get(this_line,'MarkerSize')==3;
         pt3 = 'on';
      elseif get(this_line,'MarkerSize')==4;
         pt4 = 'on';
      elseif get(this_line,'MarkerSize')==5;
         pt5 = 'on';
      elseif get(this_line,'MarkerSize')==6;
         pt6 = 'on';
      elseif get(this_line,'MarkerSize')==7;
         pt7 = 'on';
      elseif get(this_line,'MarkerSize')==8;
         pt8 = 'on';
      elseif get(this_line,'MarkerSize')==9;
         pt9 = 'on';
      elseif get(this_line,'MarkerSize')==10;
         pt10 = 'on';
      elseif get(this_line,'MarkerSize')==11;
         pt11 = 'on';
      elseif get(this_line,'MarkerSize')==12;
         pt12 = 'on';
      elseif get(this_line,'MarkerSize')==13;
         pt13 = 'on';
      elseif get(this_line,'MarkerSize')==14;
         pt14 = 'on';
      elseif get(this_line,'MarkerSize')==15;
         pt15 = 'on';
      elseif get(this_line,'MarkerSize')==16;
         pt16 = 'on';
      end;
      line_markersize_menu = uimenu('Parent',lines_context_menu,'Label','Marker Size');
         uimenu('Parent',line_markersize_menu,'Label','1 pt','Checked',pt1,'Callback','set(gco,''MarkerSize'',1); lines_type_fcn; uimenu_check_fcn');
         uimenu('Parent',line_markersize_menu,'Label','2 pts','Checked',pt2,'Callback','set(gco,''MarkerSize'',2); lines_type_fcn; uimenu_check_fcn');
         uimenu('Parent',line_markersize_menu,'Label','3 pts','Checked',pt3,'Callback','set(gco,''MarkerSize'',3); lines_type_fcn; uimenu_check_fcn');
         uimenu('Parent',line_markersize_menu,'Label','4 pts','Checked',pt4,'Callback','set(gco,''MarkerSize'',4); lines_type_fcn; uimenu_check_fcn');
         uimenu('Parent',line_markersize_menu,'Label','5 pts','Checked',pt5,'Callback','set(gco,''MarkerSize'',5); lines_type_fcn; uimenu_check_fcn');
         uimenu('Parent',line_markersize_menu,'Label','6 pts','Checked',pt6,'Callback','set(gco,''MarkerSize'',6); lines_type_fcn; uimenu_check_fcn');
         uimenu('Parent',line_markersize_menu,'Label','7 pts','Checked',pt7,'Callback','set(gco,''MarkerSize'',7); lines_type_fcn; uimenu_check_fcn');
         uimenu('Parent',line_markersize_menu,'Label','8 pts','Checked',pt8,'Callback','set(gco,''MarkerSize'',8); lines_type_fcn; uimenu_check_fcn');
         uimenu('Parent',line_markersize_menu,'Label','9 pts','Checked',pt9,'Callback','set(gco,''MarkerSize'',9); lines_type_fcn; uimenu_check_fcn');
         uimenu('Parent',line_markersize_menu,'Label','10 pts','Checked',pt10,'Callback','set(gco,''MarkerSize'',10); lines_type_fcn; uimenu_check_fcn');
         uimenu('Parent',line_markersize_menu,'Label','11 pts','Checked',pt11,'Callback','set(gco,''MarkerSize'',11); lines_type_fcn; uimenu_check_fcn');
         uimenu('Parent',line_markersize_menu,'Label','12 pts','Checked',pt12,'Callback','set(gco,''MarkerSize'',12); lines_type_fcn; uimenu_check_fcn');
         uimenu('Parent',line_markersize_menu,'Label','13 pts','Checked',pt13,'Callback','set(gco,''MarkerSize'',13); lines_type_fcn; uimenu_check_fcn');
         uimenu('Parent',line_markersize_menu,'Label','14 pts','Checked',pt14,'Callback','set(gco,''MarkerSize'',14); lines_type_fcn; uimenu_check_fcn');
         uimenu('Parent',line_markersize_menu,'Label','15 pts','Checked',pt15,'Callback','set(gco,''MarkerSize'',15); lines_type_fcn; uimenu_check_fcn');
         uimenu('Parent',line_markersize_menu,'Label','16 pts','Checked',pt16,'Callback','set(gco,''MarkerSize'',16); lines_type_fcn; uimenu_check_fcn');
      line_tag = get(this_line,'Tag');
      if size(line_tag,2)>8;
         line_tag = line_tag(1,1:8);
      end;
      if strcmp(line_tag,'3dlines-')==0;
         uimenu('Parent',lines_context_menu,'Separator','on','Label','Edit Data','Callback','toolbar_editdata_fcn');
         uimenu('Parent',lines_context_menu,'Label','Edit Name','Callback','toolbar_editname_fcn');
         if islinetimeseries(this_line)==1;
            uimenu('Parent',lines_context_menu,'Separator','on','Label','De-Mean','Callback','toolbar_demean_fcn');
         end;
      end;
      uimenu('Parent',lines_context_menu,'Label','Cut','Separator','on','Callback','delete_line_patch_fcn');
      uimenu('Parent',lines_context_menu,'Label','Copy','Callback','copy_line_fcn');
      set(this_line,'UIContextMenu',lines_context_menu);
      if isempty(get(gca,'UserData'))==0;
         if ishandle(get(gca,'UserData'))==1;
            update_legend_fcn;
         end;
      end;
      %
      % update the axes context menu
      %
      create_axes_contextmenu_fcn;
   else;
      my_text = 'You must copy a line before you can paste it!';
      about(my_text,'information','Bad paste operation...',120,400);
   end;
else;
   my_text = 'You must copy a line before you can paste it!';
   about(my_text,'information','Bad paste operation...',120,400);
end;

%
% end of paste_line_fcn.m
%
