function paste_surface_fcn

fix_fig = findobj('Tag','StructuralVAR');
model = get(fix_fig,'UserData');
copy = get(model.run,'UserData');
if isempty(copy)==0;
   if isfield(copy,'surface_properties')==1;
      %
      if strcmp(get(gca,'XLimMode'),'manual')==1;
         old_xlim = get(gca,'XLim');
         copy_xlim = [min(min(copy.surface_properties.xdata)) max(max(copy.surface_properties.xdata))];
         if old_xlim==[0 1];
            new_xlim = copy_xlim;
         else;
            new_xlim = [min(old_xlim(1),copy_xlim(1)) max(old_xlim(2),copy_xlim(2))];
         end;
         if new_xlim(1)==new_xlim(2);
            new_xlim = [new_xlim(1)-0.1 new_xlim(2)+0.1];
         end;
      end;
      if strcmp(get(gca,'YLimMode'),'manual')==1;
         old_ylim = get(gca,'YLim');
         copy_ylim = [min(min(copy.surface_properties.ydata)) max(max(copy.surface_properties.ydata))];
         if old_ylim==[0 1];
            new_ylim = copy_ylim;
         else;
            new_ylim = [min(old_ylim(1),copy_ylim(1)) max(old_ylim(2),copy_ylim(2))];
         end;
         if new_ylim(1)==new_ylim(2);
            new_ylim = [new_ylim(1)-0.1 new_ylim(2)+0.1];
         end;
      end;
      if strcmp(get(gca,'ZLimMode'),'manual')==1;
         old_zlim = get(gca,'ZLim');
         if isempty(copy.surface_properties.zdata)==0;
            copy_zlim = [min(min(copy.surface_properties.zdata)) max(max(copy.surface_properties.zdata))];
            if old_zlim==[0 1];
               new_zlim = copy_zlim;
            else;
               new_zlim = [min(old_zlim(1),copy_zlim(1)) max(old_zlim(2),copy_zlim(2))];
            end;
         else;
            new_zlim = old_zlim;
         end;
         if new_zlim(1)==new_zlim(2);
            new_zlim = [new_zlim(1)-0.1 new_zlim(2)+0.1];
         end;
      end;
      %
      % create a new surface
      %
      this_surface = surface('XData',copy.surface_properties.xdata, ...
         'YData',copy.surface_properties.ydata, ...
         'ZData',copy.surface_properties.zdata, ...
         'UserData',copy.surface_properties.userdata, ...
         'CData',copy.surface_properties.cdata, ...
         'CDataMapping',copy.surface_properties.cdatamapping, ...
         'AmbientStrength',copy.surface_properties.ambientstrength, ...
         'BackFaceLighting',copy.surface_properties.backfacelighting, ...
         'DiffuseStrength',copy.surface_properties.diffusestrength, ...
         'EdgeLighting',copy.surface_properties.edgelighting, ...
         'FaceLighting',copy.surface_properties.facelighting, ...
         'SpecularColorReflectance',copy.surface_properties.specularcolorreflectance, ...
         'SpecularExponent',copy.surface_properties.specularexponent, ...
         'SpecularStrength',copy.surface_properties.specularstrength, ...
         'FaceColor',copy.surface_properties.facecolor, ...
         'EdgeColor',copy.surface_properties.edgecolor, ...
         'LineStyle',copy.surface_properties.linestyle, ...
         'LineWidth',copy.surface_properties.linewidth, ...
         'Marker',copy.surface_properties.marker, ...
         'MarkerSize',copy.surface_properties.markersize, ...
         'MarkerEdgeColor',copy.surface_properties.markeredgecolor, ...
         'MarkerFaceColor',copy.surface_properties.markerfacecolor, ...
         'Tag',[copy.surface_properties.tag '-new']);
      %
      if strcmp(get(gca,'XLimMode'),'manual')==1;
         set(gca,'XLim',new_xlim);
      end;
      if strcmp(get(gca,'YLimMode'),'manual')==1;
         set(gca,'YLim',new_ylim);
      end;
      if strcmp(get(gca,'ZLimMode'),'manual')==1;
         set(gca,'ZLim',new_zlim);
      end;
      %
      if get(gca,'View')==[0 90];
         set(gca,'View',copy.surface_properties.axesview);
      end;
      %
      if get(gcf,'Colormap')~=copy.surface_properties.colormap;
         set(gcf,'Colormap',copy.surface_properties.colormap);
      end;
      %
      % create a light if needed
      %
      this_light = findobj(gca,'Type','light')';
      if isempty(this_light)==1;
         if copy.surface_properties.self==copy.surface_properties.light.userdata;
            this_light = light('Color',copy.surface_properties.light.color, ...
               'Position',copy.surface_properties.light.position, ...
               'Style',copy.surface_properties.light.style, ...
               'UserData',this_surface, ...
               'Parent',gca);
            %
            % create a line to represent the light
            %
            light_pos = get(this_light,'Position');
            %
            light_line = line('XData',light_pos(1), ...
                              'YData',light_pos(2), ...
                              'ZData',light_pos(3), ...
                              'Parent',gca, ...
                              'UserData','light', ...
                              'Tag','light', ...
                              'Visible','off', ...
                              'LineStyle','-', ...
                              'LineWidth',1, ...
                              'Marker','o', ...
                              'MarkerEdgeColor',get(gca,'AmbientLightColor'), ...
                              'MarkerFaceColor',get(this_light,'Color'), ...
                              'MarkerSize',10);
            %
            % setting up a context menu
            %
            light_context_menu = uicontextmenu('Callback','set(gcf,''Pointer'',''arrow'')');
            uimenu('Parent',light_context_menu,'Label','Ambient Light Color','Callback','change_ambientlight_color');
            uimenu('Parent',light_context_menu,'Label','Light Color','Callback','change_light_color');
            light_lightstyle_menu = uimenu('Parent',light_context_menu,'Label','Light Style');
            if strcmp(get(this_light,'Style'),'infinite')==1;
               uimenu('Parent',light_lightstyle_menu,'Label','Infinite','Checked','on','Callback','change_light_style');
               uimenu('Parent',light_lightstyle_menu,'Label','Local','Checked','off','Callback','change_light_style');
            else;
               uimenu('Parent',light_lightstyle_menu,'Label','Infinite','Checked','off','Callback','change_light_style');
               uimenu('Parent',light_lightstyle_menu,'Label','Local','Checked','on','Callback','change_light_style');
            end;
            uimenu('Parent',light_context_menu,'Label','Unlock Light','Separator','on','Callback','light_lock_fcn');
            set(light_line,'UIContextMenu',light_context_menu);
            %
            % create a context menu for all surface objects that don't have one
            %
            all_surf = sort(findobj(gca,'Type','surface')');
            all_surf = [all_surf this_surface];
            for i=1:size(all_surf,2);
               if (isempty(get(all_surf(1,i),'UIContextMenu'))==1)|(ischar(get(all_surf(1,i),'UserData'))==0);
                  surface_context = import_surface_context(this_surface);
                  set(all_surf(1,i),'UIContextMenu',surface_context);
               end;
            end;
         elseif ischar(get(this_surface,'UserData'))==0;
            surface_context = uicontextmenu('Callback','set(gcf,''Pointer'',''arrow'')');
            uimenu('Parent',surface_context,'label','Cut','Callback','delete_surface_fcn');
            set(this_surface,'UIContextMenu',surface_context);
         end;
      else;
         %
         % update light to make sure it's the last object
         %
         this_line = findobj(gca,'Type','line','UserData','light')';
         if isempty(this_line)==0;
            line_visible = get(this_line,'Visible');
            line_context = get(this_line,'UIContextMenu')';
         else;
            line_visible = 'off';
         end;
         light_pos = get(this_light,'Position');
         %
         light_line = line('XData',light_pos(1), ...
                           'YData',light_pos(2), ...
                           'ZData',light_pos(3), ...
                           'Parent',gca, ...
                           'UserData','light', ...
                           'Tag','light', ...
                           'Visible',line_visible, ...
                           'LineStyle','-', ...
                           'LineWidth',1, ...
                           'Marker','o', ...
                           'MarkerEdgeColor',get(gca,'AmbientLightColor'), ...
                           'MarkerFaceColor',get(this_light,'Color'), ...
                           'MarkerSize',10);
         %
         % setting up a context menu
         %
         light_context_menu = uicontextmenu('Callback','set(gcf,''Pointer'',''arrow'')');
         uimenu('Parent',light_context_menu,'Label','Ambient Light Color','Callback','change_ambientlight_color');
         uimenu('Parent',light_context_menu,'Label','Light Color','Callback','change_light_color');
         light_lightstyle_menu = uimenu('Parent',light_context_menu,'Label','Light Style');
         if strcmp(get(this_light,'Style'),'infinite')==1;
            uimenu('Parent',light_lightstyle_menu,'Label','Infinite','Checked','on','Callback','change_light_style');
            uimenu('Parent',light_lightstyle_menu,'Label','Local','Checked','off','Callback','change_light_style');
         else;
            uimenu('Parent',light_lightstyle_menu,'Label','Infinite','Checked','off','Callback','change_light_style');
            uimenu('Parent',light_lightstyle_menu,'Label','Local','Checked','on','Callback','change_light_style');
         end;
         if isempty(this_line)==0;
            lock_label_str = findobj(line_context,'Label','Unlock Light')';
            if isempty(lock_label_str)==0;
               uimenu('Parent',light_context_menu,'Label','Unlock Light','Separator','on','Callback','light_lock_fcn');
            else;
               uimenu('Parent',light_context_menu,'Label','Lock Light','Separator','on','Callback','light_lock_fcn');
            end;
         else;
            uimenu('Parent',light_context_menu,'Label','Unlock Light','Separator','on','Callback','light_lock_fcn');
         end;
         set(light_line,'UIContextMenu',light_context_menu);
         if isempty(this_line)==0;
            delete(this_line);
         end;
         this_line = light_line;
         %
         % create a context menu for surface object that are not planes and those that are
         %
         if ischar(get(this_surface,'UserData'))==1;
            %
            % Setting up a Context menu for the main surface
            %
            surface_context = import_surface_context(this_surface);
            set(this_surface,'UIContextMenu',surface_context);
         else;
            %
            % Setting up a Context menu for surface planes, when a real surface already exists
            %
            all_surf = sort(findobj(gca,'Type','surface')');
            for i=1:size(all_surf,2);
               if all_surf(1,i)==get(this_light,'UserData');
                  set(this_surface,'UIContextMenu',get(all_surf(1,i),'UIContextMenu'));
                  break;
               end;
            end;
         end;
      end;
      %
      % dealing with legends
      %
      if isempty(get(gca,'UserData'))==0;
         if ishandle(get(gca,'UserData'))==1;
            update_legend_fcn;
         end;
      end;
      %
      % check if we should delete old toolbar
      %
      toolbar = get(gcf,'UserData');
      if isfield(toolbar,'rotate3d')==0;
         if ischar(get(this_surface,'UserData'))==1;
            fix_toolbar_fcn;
         end;
      else;
         if ischar(get(this_surface,'UserData'))==1;
            create_axes_contextmenu_fcn;
         end;
         if isfield(toolbar,'showhidesurface')==0;
            if ischar(get(this_surface,'UserData'))==0;
               toolsmenu = findobj(gcf,'Tag','ToolsMenu')';
               toolbar.showhidesurface = uimenu('Parent',toolsmenu, ...
                  'Label','Hide Plane', ...
                  'Callback','toolbar_show_hide_surface_fcn', ...
                  'Enable','on', ...
                  'Position',4, ...
                  'UserData',1, ...
                  'Tag','ShowHideSurface');
               set(gcf,'UserData',toolbar);
            end;
         end;
      end;
      if isfield(toolbar,'rotate_default')==1;
         myaxes = get(toolbar.print,'UserData');
         this_azel = [];
         for i1=1:size(myaxes,2);
            this_azel = [this_azel;get(myaxes(1,i1),'View')];
         end;
         old_azel = get(toolbar.rotate_default,'UserData');
         for i1=1:size(myaxes,2);
            if gca==myaxes(1,i1);
               if i1<=size(old_azel,1);
                  if get(myaxes(1,i1),'View')~=[0 90];
                     this_azel(i1,:) = old_azel(i1,:);
                  end;
               end;
            else;
               if i1<=size(old_azel,1);
                  this_azel(i1,:) = old_azel(i1,:);
               else;
                  this_azel(i1,:) = [0 90];
               end;
            end;
         end;
         set(toolbar.rotate_default,'UserData',this_azel);
      end;
   else;
      my_text = 'You must copy a surface before you can paste it!';
      about(my_text,'information','Bad paste operation...',120,400);
   end;
else;
   my_text = 'You must copy a surface before you can paste it!';
   about(my_text,'information','Bad paste operation...',120,400);
end;

%
% end of paste_surface_fcn.m
%
