function printpreview_fcn(selector)

if nargin==0;
   selector = gcf;
end;

if (nargin==0)|((ishandle(selector)==1)&(strcmp(get(selector,'Type'),'figure')==1));
   my_exit = 1;
   if isempty(selector)==0;
      figname = get(selector,'Name');
      fig = selector;
      selector = 'init';
   end;
   mycons = getstoredimages;
   curr_ini = find_inisettings;
   if curr_ini.use_toolbar_bgcolor==1;
      bgcolor = (1/255)*(round(255*get(0,'defaultuicontrolbackgroundcolor'))-[8 4 8]);
      bgcolor(1) = max(0,bgcolor(1));
      bgcolor(2) = max(0,bgcolor(2));
      bgcolor(3) = max(0,bgcolor(3));
   else;
      bgcolor = [NaN NaN NaN];
   end;
   btn_images.print = maketrans(mycons.print_image,[160 160 164],bgcolor);
   btn_images.close = maketrans(mycons.close_image,[160 160 164],bgcolor);
   btn_images.pagesetup = maketrans(mycons.page_setup_image,[160 160 164],bgcolor);
   btn_images.zoomin = maketrans(mycons.zoomin_image,[160 160 164],bgcolor);
   btn_images.zoomout = maketrans(mycons.zoomout_image,[160 160 164],bgcolor);
   %
   % figure info for page layout
   %
   set(fig,'Visible','off');
   drawnow;
   drawnow;
   figinfo.fig = fig;
   figinfo.oldname = figname;
   figinfo.inverthardcopy = get(fig,'InvertHardcopy');
   figinfo.paperorientation = get(fig,'PaperOrientation');
   figinfo.paperposition = get(fig,'PaperPosition');
   figinfo.manualpaperposition = figinfo.paperposition;
   figinfo.paperpositionmode = get(fig,'PaperPositionMode');
   figinfo.papertype = get(fig,'PaperType');
   figinfo.paperunits = get(fig,'PaperUnits');
   figinfo.papersize = get(fig,'PaperSize');
   paper_size_str = [num2str(figinfo.papersize(1),'%0.2f') 'x' num2str(figinfo.papersize(2),'%0.2f')];
   old_figunits = get(fig,'Units');
   set(fig,'Units','pixels');
   figsize = get(fig,'Position');
   set(fig,'Units',old_figunits);
   figinfo.figsize = figsize;
   [pagepos,axespos,figinfo] = shadow_figure(figinfo);
   old_pagepos = pagepos;
   pagepos = 2*pagepos;
   pagepos(2) = ((460-pagepos(4))/2)+28;
   pagepos(1) = ((558-pagepos(3))/2)+14;
   old_axespos = axespos;
   axespos = 2*axespos;
   axespos(1) = pagepos(1)+2*(old_axespos(1)-old_pagepos(1));
   axespos(2) = pagepos(2)+2*(old_axespos(2)-old_pagepos(2));
   %
   % background color for "figure"
   %
   toolbar = get(fig,'UserData');
   myaxes = get(toolbar.print,'UserData');
   if strcmp(figinfo.inverthardcopy,'on')==1;
      fig_color = [1 1 1];
      fig_colormap = gray;
   else;
      fig_color = get(myaxes(1,1),'Color');
      fig_colormap = get(fig,'Colormap');
   end;
   %
   % Set screen size directly instead of using
   % get(0,'ScreenSize')!
   %
   realscrsz = get(0,'ScreenSize');
else;
   my_exit = 0;
   printpreview_gui = sort(findobj('Tag','PrintPreview')');
   if size(printpreview_gui,2)>1;
      test_gui = get(0,'CurrentFigure');
      test = 0;
      for i=1:size(printpreview_gui,2);
         if test_gui==printpreview_gui(1,i);
            test = i;
            break;
         end;
      end;
      if test>0;
         printpreview_gui = printpreview_gui(1,test);
      else;
         printpreview_gui = printpreview_gui(1,1);
      end;
   end;
   print_preview = get(printpreview_gui,'UserData');
   btn_images = get(print_preview.background,'UserData');
end;

switch selector
case 'init'
   printpreview_gui = figure('Color',get(0,'defaultuicontrolbackgroundcolor'), ...
         'FileName','printpreview_fcn.m', ...
         'MenuBar','none', ...
         'PaperUnits','points', ...
         'Units','pixels', ...
         'Position',[(realscrsz(3)-600)/2 (realscrsz(4)-515)/2 600 515], ...
         'Tag','PrintPreview', ...
         'Colormap',fig_colormap, ...
         'Visible','off', ...
         'Name',['Print Preview - ' figname], ...
         'NumberTitle','off', ...
         'DoubleBuffer','on', ...
         'WindowStyle','normal', ...
         'WindowButtonDownFcn','printpreview_fcn check_zoom', ...
         'WindowButtonMotionFcn','printpreview_fcn pointer', ...
         'ResizeFcn','printpreview_fcn resize', ...
         'CloseRequestFcn','printpreview_fcn done', ...
         'ToolBar','none');

   if matlabnumber>=7.0;
      set(printpreview_gui,'DockControl','off');
   end;

   %
   % a context menu for various objects
   %

   my_context = uicontextmenu('Callback','set(gcf,''Pointer'',''arrow'')');
   uimenu('Parent',my_context,'Label','125%','Callback','printpreview_fcn(''scaling'')');
   uimenu('Parent',my_context,'Label','150%','Callback','printpreview_fcn(''scaling'')');
   uimenu('Parent',my_context,'Label','200%','Callback','printpreview_fcn(''scaling'')');
   uimenu('Parent',my_context,'Label','300%','Checked','on','Callback','printpreview_fcn(''scaling'')');
   uimenu('Parent',my_context,'Label','400%','Callback','printpreview_fcn(''scaling'')');
   uimenu('Parent',my_context,'Label','500%','Callback','printpreview_fcn(''scaling'')');

   %
   % The actual print preview display
   %

   print_preview.background = axes('Units','pixels', ...
         'Color',[0.4 0.4 0.4], ...
         'XColor',[0.4 0.4 0.4], ...
         'YColor',[0.4 0.4 0.4], ...
         'Box','on', ...
         'TickLength',[0 0], ...
         'XTickLabel',[], ...
         'YTickLabel',[], ...
         'XTick',[0 1], ...
         'YTick',[0 1], ...
         'XLim',[14 572], ...
         'YLim',[28 488], ...
         'Position',[14 28 558 460], ...
         'Visible','on', ...
         'UserData',btn_images, ...
         'UIContextMenu',my_context, ...
         'Tag','FrameBack');

   print_preview.page = axes('Units','pixels', ...
         'Color',[1 1 1], ...
         'XColor',[0 0 0], ...
         'YColor',[0 0 0], ...
         'Box','on', ...
         'TickLength',[0 0], ...
         'XTickLabel',[], ...
         'YTickLabel',[], ...
         'XTick',[0 1], ...
         'YTick',[0 1], ...
         'Position',pagepos, ...
         'Visible','on', ...
         'UIContextMenu',my_context, ...
         'Tag','DataPage');

   print_preview.axesdata = axes('Units','pixels', ...
         'Color',fig_color, ...
         'XColor',fig_color, ...
         'YColor',fig_color, ...
         'Box','on', ...
         'TickLength',[0 0], ...
         'XTickLabel',[], ...
         'YTickLabel',[], ...
         'XTick',[0 1], ...
         'YTick',[0 1], ...
         'Position',axespos, ...
         'Visible','on', ...
         'UIContextMenu',my_context, ...
         'Tag','DataAxes');

   %
   % data to be displayed in this axes
   %

   these_axes = create_preview_plots_fcn(fig,print_preview.axesdata);
   set(print_preview.axesdata,'UserData',these_axes);

   %
   % cover areas
   %

   print_preview.background_bottom = axes('Units','pixels', ...
         'Color',[0.4 0.4 0.4], ...
         'XColor',[0.4 0.4 0.4], ...
         'YColor',[0.4 0.4 0.4], ...
         'Box','on', ...
         'TickLength',[0 0], ...
         'XTickLabel',[], ...
         'YTickLabel',[], ...
         'XTick',[0 1], ...
         'YTick',[0 1], ...
         'Position',[1 1 600 pagepos(2)-1], ...
         'Visible','on', ...
         'UIContextMenu',my_context, ...
         'Tag','FrameBackgroundBottom');

   print_preview.background_top = axes('Units','pixels', ...
         'Color',[0.4 0.4 0.4], ...
         'XColor',[0.4 0.4 0.4], ...
         'YColor',[0.4 0.4 0.4], ...
         'Box','on', ...
         'TickLength',[0 0], ...
         'XTickLabel',[], ...
         'YTickLabel',[], ...
         'XTick',[0 1], ...
         'YTick',[0 1], ...
         'Position',[1 pagepos(2)+pagepos(4) 600 550-(pagepos(2)+pagepos(4))], ...
         'Visible','on', ...
         'UIContextMenu',my_context, ...
         'Tag','FrameBackgroundTop');

   print_preview.background_left = axes('Units','pixels', ...
         'Color',[0.4 0.4 0.4], ...
         'XColor',[0.4 0.4 0.4], ...
         'YColor',[0.4 0.4 0.4], ...
         'Box','on', ...
         'TickLength',[0 0], ...
         'XTickLabel',[], ...
         'YTickLabel',[], ...
         'XTick',[0 1], ...
         'YTick',[0 1], ...
         'Position',[1 1 pagepos(1)-1 550], ...
         'Visible','on', ...
         'UIContextMenu',my_context, ...
         'Tag','FrameBackgroundLeft');

   print_preview.background_right = axes('Units','pixels', ...
         'Color',[0.4 0.4 0.4], ...
         'XColor',[0.4 0.4 0.4], ...
         'YColor',[0.4 0.4 0.4], ...
         'Box','on', ...
         'TickLength',[0 0], ...
         'XTickLabel',[], ...
         'YTickLabel',[], ...
         'XTick',[0 1], ...
         'YTick',[0 1], ...
         'Position',[pagepos(1)+pagepos(3) 1 600-(pagepos(1)+pagepos(3)) 550], ...
         'Visible','on', ...
         'UIContextMenu',my_context, ...
         'Tag','FrameBackgroundRight');

   print_preview.page_bottom = axes('Units','pixels', ...
         'Color',[1 1 1], ...
         'XColor',[1 1 1], ...
         'YColor',[1 1 1], ...
         'Box','on', ...
         'TickLength',[0 0], ...
         'XTickLabel',[], ...
         'YTickLabel',[], ...
         'XTick',[0 1], ...
         'YTick',[0 1], ...
         'Position',[1 1 600 pagepos(2)-1], ...
         'Visible','off', ...
         'UIContextMenu',my_context, ...
         'Tag','FramePageBottom');

   if axespos(2)>pagepos(2);
      set(print_preview.page_bottom,'Position',[pagepos(1)+1 pagepos(2)+1 pagepos(3)-2 axespos(2)-pagepos(2)-2],'Visible','on');
   end;

   print_preview.page_top = axes('Units','pixels', ...
         'Color',[1 1 1], ...
         'XColor',[1 1 1], ...
         'YColor',[1 1 1], ...
         'Box','on', ...
         'TickLength',[0 0], ...
         'XTickLabel',[], ...
         'YTickLabel',[], ...
         'XTick',[0 1], ...
         'YTick',[0 1], ...
         'Position',[1 1 600 pagepos(2)-1], ...
         'Visible','off', ...
         'UIContextMenu',my_context, ...
         'Tag','FramePageTop');

   if pagepos(2)+pagepos(4)>axespos(2)+axespos(4)+2;
      set(print_preview.page_top,'Position',[pagepos(1)+1 axespos(2)+axespos(4)+1 pagepos(3)-2 pagepos(2)+pagepos(4)-(axespos(2)+axespos(4)+2)],'Visible','on');
   end;

   print_preview.page_left = axes('Units','pixels', ...
         'Color',[1 1 1], ...
         'XColor',[1 1 1], ...
         'YColor',[1 1 1], ...
         'Box','on', ...
         'TickLength',[0 0], ...
         'XTickLabel',[], ...
         'YTickLabel',[], ...
         'XTick',[0 1], ...
         'YTick',[0 1], ...
         'Position',[1 1 600 pagepos(2)-1], ...
         'Visible','off', ...
         'UIContextMenu',my_context, ...
         'Tag','FramePageLeft');

   if axespos(1)>pagepos(1)+2;
      set(print_preview.page_left,'Position',[pagepos(1)+1 pagepos(2)+1 axespos(1)-pagepos(1)-2 pagepos(4)-2],'Visible','on');
   end;

   print_preview.page_right = axes('Units','pixels', ...
         'Color',[1 1 1], ...
         'XColor',[1 1 1], ...
         'YColor',[1 1 1], ...
         'Box','on', ...
         'TickLength',[0 0], ...
         'XTickLabel',[], ...
         'YTickLabel',[], ...
         'XTick',[0 1], ...
         'YTick',[0 1], ...
         'Position',[1 1 600 pagepos(2)-1], ...
         'Visible','off', ...
         'UIContextMenu',my_context, ...
         'Tag','FramePageRight');

   if pagepos(1)+pagepos(3)>axespos(1)+axespos(3)+2;
      set(print_preview.page_right,'Position',[axespos(1)+axespos(3)+1 pagepos(2)+1 pagepos(1)+pagepos(3)-(axespos(1)+axespos(3)+2) pagepos(4)-2],'Visible','on');
   end;

   %
   % pagelines
   %

   print_preview.pageline_bottom = axes('Units','pixels', ...
         'Color',[0 0 0], ...
         'XColor',[0 0 0], ...
         'YColor',[0 0 0], ...
         'Box','on', ...
         'TickLength',[0 0], ...
         'XTickLabel',[], ...
         'YTickLabel',[], ...
         'XTick',[0 1], ...
         'YTick',[0 1], ...
         'Position',[pagepos(1:3) 1], ...
         'Visible','on', ...
         'UIContextMenu',my_context, ...
         'Tag','PageLineBottom');

   print_preview.pageline_top = axes('Units','pixels', ...
         'Color',[0 0 0], ...
         'XColor',[0 0 0], ...
         'YColor',[0 0 0], ...
         'Box','on', ...
         'TickLength',[0 0], ...
         'XTickLabel',[], ...
         'YTickLabel',[], ...
         'XTick',[0 1], ...
         'YTick',[0 1], ...
         'Position',[pagepos(1) pagepos(2)+pagepos(4)-1 pagepos(3) 1], ...
         'Visible','on', ...
         'UIContextMenu',my_context, ...
         'Tag','PageLineTop');

   print_preview.pageline_left = axes('Units','pixels', ...
         'Color',[0 0 0], ...
         'XColor',[0 0 0], ...
         'YColor',[0 0 0], ...
         'Box','on', ...
         'TickLength',[0 0], ...
         'XTickLabel',[], ...
         'YTickLabel',[], ...
         'XTick',[0 1], ...
         'YTick',[0 1], ...
         'Position',[pagepos(1:2) 1 pagepos(4)], ...
         'Visible','on', ...
         'UIContextMenu',my_context, ...
         'Tag','PageLineLeft');

   print_preview.pageline_right = axes('Units','pixels', ...
         'Color',[0 0 0], ...
         'XColor',[0 0 0], ...
         'YColor',[0 0 0], ...
         'Box','on', ...
         'TickLength',[0 0], ...
         'XTickLabel',[], ...
         'YTickLabel',[], ...
         'XTick',[0 1], ...
         'YTick',[0 1], ...
         'Position',[pagepos(1)+pagepos(3)-1 pagepos(2) 1 pagepos(4)], ...
         'Visible','on', ...
         'UIContextMenu',my_context, ...
         'Tag','PageLineRight');


   print_preview.top = axes('Units','pixels', ...
         'Color',get(0,'defaultuicontrolbackgroundcolor'), ...
         'XColor',get(0,'defaultuicontrolbackgroundcolor'), ...
         'YColor',get(0,'defaultuicontrolbackgroundcolor'), ...
         'ZColor',get(0,'defaultuicontrolbackgroundcolor'), ...
         'Box','on', ...
         'TickLength',[0 0], ...
         'XTickLabel',[], ...
         'YTickLabel',[], ...
         'XTick',[0 1], ...
         'YTick',[0 1], ...
         'Position',[1 489 600 515-489], ...
         'Visible','on', ...
         'Tag','FrameTop');

   print_preview.topline = axes('Units','pixels', ...
         'Color',[0 0 0], ...
         'XColor',[0 0 0], ...
         'YColor',[0 0 0], ...
         'ZColor',[0 0 0], ...
         'Box','on', ...
         'TickLength',[0 0], ...
         'XTickLabel',[], ...
         'YTickLabel',[], ...
         'XTick',[0 1], ...
         'YTick',[0 1], ...
         'Position',[14 488 558 1], ...
         'Visible','on', ...
         'Tag','LineTop');

   print_preview.bottom = axes('Units','pixels', ...
         'Color',get(0,'defaultuicontrolbackgroundcolor'), ...
         'XColor',get(0,'defaultuicontrolbackgroundcolor'), ...
         'YColor',get(0,'defaultuicontrolbackgroundcolor'), ...
         'ZColor',get(0,'defaultuicontrolbackgroundcolor'), ...
         'Box','on', ...
         'TickLength',[0 0], ...
         'XTickLabel',[], ...
         'YTickLabel',[], ...
         'XTick',[0 1], ...
         'YTick',[0 1], ...
         'Position',[1 1 600 13], ...
         'Visible','on', ...
         'Tag','FrameBottom');

   print_preview.bottomline = axes('Units','pixels', ...
         'Color',[0 0 0], ...
         'XColor',[0 0 0], ...
         'YColor',[0 0 0], ...
         'ZColor',[0 0 0], ...
         'Box','on', ...
         'TickLength',[0 0], ...
         'XTickLabel',[], ...
         'YTickLabel',[], ...
         'XTick',[0 1], ...
         'YTick',[0 1], ...
         'Position',[14 28 558 1], ...
         'Visible','on', ...
         'Tag','LineBottom');

   print_preview.left = axes('Units','pixels', ...
         'Color',get(0,'defaultuicontrolbackgroundcolor'), ...
         'XColor',get(0,'defaultuicontrolbackgroundcolor'), ...
         'YColor',get(0,'defaultuicontrolbackgroundcolor'), ...
         'ZColor',get(0,'defaultuicontrolbackgroundcolor'), ...
         'Box','on', ...
         'TickLength',[0 0], ...
         'XTickLabel',[], ...
         'YTickLabel',[], ...
         'XTick',[0 1], ...
         'YTick',[0 1], ...
         'Position',[1 1 13 489], ...
         'Visible','on', ...
         'Tag','FrameLeft');

   print_preview.leftline = axes('Units','pixels', ...
         'Color',[0 0 0], ...
         'XColor',[0 0 0], ...
         'YColor',[0 0 0], ...
         'ZColor',[0 0 0], ...
         'Box','on', ...
         'TickLength',[0 0], ...
         'XTickLabel',[], ...
         'YTickLabel',[], ...
         'XTick',[0 1], ...
         'YTick',[0 1], ...
         'Position',[14 28 1 460], ...
         'Visible','on', ...
         'Tag','LineLeft');

   print_preview.right = axes('Units','pixels', ...
         'Color',get(0,'defaultuicontrolbackgroundcolor'), ...
         'XColor',get(0,'defaultuicontrolbackgroundcolor'), ...
         'YColor',get(0,'defaultuicontrolbackgroundcolor'), ...
         'ZColor',get(0,'defaultuicontrolbackgroundcolor'), ...
         'Box','on', ...
         'TickLength',[0 0], ...
         'XTickLabel',[], ...
         'YTickLabel',[], ...
         'XTick',[0 1], ...
         'YTick',[0 1], ...
         'Position',[573 1 27 489], ...
         'Visible','on', ...
         'Tag','FrameRight');

   print_preview.rightline = axes('Units','pixels', ...
         'Color',[0 0 0], ...
         'XColor',[0 0 0], ...
         'YColor',[0 0 0], ...
         'ZColor',[0 0 0], ...
         'Box','on', ...
         'TickLength',[0 0], ...
         'XTickLabel',[], ...
         'YTickLabel',[], ...
         'XTick',[0 1], ...
         'YTick',[0 1], ...
         'Position',[572 28 1 460], ...
         'Visible','on', ...
         'Tag','LineTop');

   %
   % Main control buttons
   %

   %
   % x-axes lines
   %

%   print_preview.xbox1 = xline([1 547 600],[0.5 1]);

   print_preview.xbox2 = xline([1 514 600],[0.5 1]);


   print_preview.icon = uitoolbar('Parent',printpreview_gui, ...
                     'HandleVisibility','off', ...
                     'Interruptible','on', ...
                     'Clipping','on');

   print_preview.print = uipushtool('Parent',print_preview.icon, ...
                         'TooltipString','Print', ...
                         'CData',btn_images.print, ...
                         'ClickedCallback','printpreview_fcn print', ...
                         'Separator','off', ...
                         'Interruptible','on', ...
                         'Clipping','on', ...
                         'UserData',fig, ...
                         'Enable','on', ...
                         'Tag','Print');

   print_preview.pagesetup = uipushtool('Parent',print_preview.icon, ...
                         'TooltipString','Page Setup', ...
                         'CData',btn_images.pagesetup, ...
                         'ClickedCallback','printpreview_fcn pagesetup', ...
                         'Separator','off', ...
                         'Interruptible','on', ...
                         'Clipping','on', ...
                         'UserData','waiting', ...
                         'Enable','on', ...
                         'Tag','PageSetup');

   print_preview.zoomfactor = uicontrol('Units','pixels', ...
         'BackgroundColor',[1 1 1], ...
         'ForegroundColor',[0 0 0], ...
         'Position',[60 520 60 22], ...
         'String',strvcat('125%','150%','200%','300%','400%','500%'), ...
         'FontSize',curr_ini.gui_fontsize, ...
         'FontName',curr_ini.gui_fontname, ...
         'FontWeight',curr_ini.gui_fontweight, ...
         'FontAngle',curr_ini.gui_fontangle, ...
         'TooltipString','Zoom Factor', ...
         'Value',4, ...
         'UserData',3, ...
         'Style','popupmenu', ...
         'Visible','off', ...
         'Callback','printpreview_fcn zoom_factor', ...
         'Enable','on', ...
         'Tag','ZoomFactor');

   print_preview.zoomin = uipushtool('Parent',print_preview.icon, ...
                         'TooltipString','Zoom In', ...
                         'CData',btn_images.zoomin, ...
                         'ClickedCallback','printpreview_fcn fix_zoom', ...
                         'Separator','on', ...
                         'Interruptible','on', ...
                         'Clipping','on', ...
                         'UserData',1, ...
                         'Enable','off', ...
                         'Tag','Zoomin');

   print_preview.zoomout = uipushtool('Parent',print_preview.icon, ...
                         'TooltipString','Zoom Out', ...
                         'CData',btn_images.zoomout, ...
                         'ClickedCallback','printpreview_fcn fix_zoom', ...
                         'Separator','off', ...
                         'Interruptible','on', ...
                         'Clipping','on', ...
                         'Enable','on', ...
                         'Tag','Zoomout');

   print_preview.close = uipushtool('Parent',print_preview.icon, ...
                         'TooltipString','Close', ...
                         'CData',btn_images.close, ...
                         'ClickedCallback','printpreview_fcn done', ...
                         'Separator','on', ...
                         'Interruptible','on', ...
                         'Clipping','on', ...
                         'UserData','waiting', ...
                         'Enable','on', ...
                         'Tag','Done');

   print_preview.showbox = axesbox([2 2 598 500],'Print Preview',65,[0.5 1]);

   print_preview.slidervertical = uicontrol('Units','pixels', ...
         'BackgroundColor',(get(0,'defaultuicontrolbackgroundcolor')+[1 1 1])/2, ...
         'Position',[574 28 14 460], ...
         'Style','slider', ...
         'Min',0, ...
         'Max',1, ...
         'Value',0.5, ...
         'UserData',0.5, ...
         'Callback','printpreview_fcn slider', ...
         'Enable','on', ...
         'Tag','Vertical');

   print_preview.sliderhorizontal = uicontrol('Units','pixels', ...
         'BackgroundColor',(get(0,'defaultuicontrolbackgroundcolor')+[1 1 1])/2, ...
         'Position',[14 14 558 14], ...
         'Style','slider', ...
         'Min',0, ...
         'Max',1, ...
         'Value',0.5, ...
         'UserData',0.5, ...
         'Callback','printpreview_fcn slider', ...
         'Enable','on', ...
         'Tag','Horizontal');

   set(printpreview_gui,'UserData',print_preview,...
         'HandleVisibility','callback');
case 'scaling'
   curr_obj = gcbo;
   curr_par = get(gcbo,'Parent');
   kids = get(curr_par,'Children')';
   for i=1:size(kids,2);
      set(kids(1,i),'Checked','off');
   end;
   set(gcbo,'Checked','on');
   scale_value = get(gcbo,'Label');
   this_str = get(print_preview.zoomfactor,'String');
   for i=1:size(this_str,1);
      new_str = strtrim(this_str(i,:));
      if strcmp(new_str,scale_value)==1;
         set(print_preview.zoomfactor,'Value',i);
         break;
      end;
   end;
   scale_value = mystr2num(scale_value(1,1:3))/100;
   set(print_preview.zoomfactor,'UserData',scale_value);
   set(printpreview_gui,'UserData',print_preview);
case 'zoom_factor'
   factor_value = get(print_preview.zoomfactor,'Value');
   this_context = get(print_preview.page,'UIContextMenu');
   kids = sort(get(this_context,'Children')');
   for i=1:size(kids,2);
      set(kids(1,i),'Checked','off');
   end;
   set(kids(1,factor_value),'Checked','on');
   this_str = get(print_preview.zoomfactor,'String');
   scale_value = this_str(factor_value,:);
   scale_value = mystr2num(scale_value(1,1:3))/100;
   set(print_preview.zoomfactor,'UserData',scale_value);
   set(printpreview_gui,'UserData',print_preview);
case 'check_zoom'
   old_back_units = get(print_preview.background,'Units');
   set(print_preview.background,'Units','pixels');
   back_pos = get(print_preview.background,'Position');
   set(print_preview.background,'Units',old_back_units);
   old_fig_units = get(printpreview_gui,'Units');
   old_paper_units = get(printpreview_gui,'PaperUnits');
   set(printpreview_gui,'Units','pixels','PaperUnits','points');
   curr_point = get(printpreview_gui,'CurrentPoint');
   set(printpreview_gui,'Units',old_fig_units,'PaperUnits',old_paper_units);
   click_type = get(printpreview_gui,'SelectionType');
   set(printpreview_gui,'UserData',print_preview);
   if (curr_point(1)>back_pos(1))&(curr_point(2)>back_pos(2))&(curr_point(1)<back_pos(1)+back_pos(3))&(curr_point(2)<back_pos(2)+back_pos(4));
      if strcmp(click_type,'open')==1;
         %
         % return to original size and position
         %
         set(print_preview.zoomin,'UserData',1);
         set(print_preview.sliderhorizontal,'Value',0.5);
         set(print_preview.slidervertical,'Value',0.5);
         %
         % now we can slide and fix pointer
         %
         printpreview_fcn('slider');
         printpreview_fcn('pointer');
      elseif strcmp(click_type,'normal')==1;
         %
         % adjust sliders
         %
         old_page_units = get(print_preview.page,'Units');
         set(print_preview.page,'Units','pixels');
         page_pos = get(print_preview.page,'Position');
         set(print_preview.page,'Units',old_page_units);
         curr_point_normalized = [(curr_point(1)-page_pos(1))/page_pos(3) (curr_point(2)-page_pos(2))/page_pos(4)];
         if curr_point_normalized(1)>1;
            curr_point_normalized(1) = 1;
         elseif curr_point_normalized(1)<0;
            curr_point_normalized(1) = 0;
         end;
         if curr_point_normalized(2)>1;
            curr_point_normalized(2) = 1;
         elseif curr_point_normalized(2)<0;
            curr_point_normalized(2) = 0;
         end;
         set(print_preview.sliderhorizontal,'Value',1-curr_point_normalized(1));
         set(print_preview.slidervertical,'Value',1-curr_point_normalized(2));
         %
         % now we can zoom and fix pointer
         %
         printpreview_fcn('zoom');
         printpreview_fcn('pointer');
      end;
   end;
case 'pointer'
   old_back_units = get(print_preview.background,'Units');
   set(print_preview.background,'Units','pixels');
   back_pos = get(print_preview.background,'Position');
   set(print_preview.background,'Units',old_back_units);
   old_fig_units = get(printpreview_gui,'Units');
   old_paper_units = get(printpreview_gui,'PaperUnits');
   set(printpreview_gui,'Units','pixels','PaperUnits','points');
   curr_point = get(printpreview_gui,'CurrentPoint');
   set(printpreview_gui,'Units',old_fig_units,'PaperUnits',old_paper_units);
   if (curr_point(1)>back_pos(1))&(curr_point(2)>back_pos(2))&(curr_point(1)<back_pos(1)+back_pos(3))&(curr_point(2)<back_pos(2)+back_pos(4));
      %
      % show zoom in pointer
      %
      if strcmp(get(print_preview.zoomin,'Enable'),'off');
         my_pointer = zoomin_pointer;
      %
      % show zoom out pointer
      %
      else;
         my_pointer = zoomout_pointer;
      end;
      set(printpreview_gui,'Pointer','custom','PointerShapeCData',my_pointer);
   else;
      set(printpreview_gui,'Pointer','arrow');
   end;
   set(printpreview_gui,'UserData',print_preview);
case 'slider'
   fig = get(print_preview.print,'UserData');
   figinfo.fig = fig;
   figinfo.inverthardcopy = get(fig,'InvertHardcopy');
   figinfo.paperorientation = get(fig,'PaperOrientation');
   figinfo.paperposition = get(fig,'PaperPosition');
   figinfo.manualpaperposition = figinfo.paperposition;
   figinfo.paperpositionmode = get(fig,'PaperPositionMode');
   figinfo.papertype = get(fig,'PaperType');
   figinfo.paperunits = get(fig,'PaperUnits');
   figinfo.papersize = get(fig,'PaperSize');
   paper_size_str = [num2str(figinfo.papersize(1),'%0.2f') 'x' num2str(figinfo.papersize(2),'%0.2f')];
   old_figunits = get(fig,'Units');
   old_paperunits = get(fig,'PaperUnits');
   set(fig,'Units','pixels','PaperUnits','points');
   figsize = get(fig,'Position');
   set(fig,'Units',old_figunits,'PaperUnits',old_paperunits);
   figinfo.figsize = figsize;
   [pagepos,axespos,figinfo] = shadow_figure(figinfo);
   new_pagepos = pagepos;
   new_axespos = axespos;
   old_pagepos = pagepos;
   pagepos = 2*pagepos;
   back_pos1 = get(print_preview.background,'Position');
   back_pos = back_pos1;
   pagepos(2) = ((back_pos(4)-pagepos(4))*(1-get(print_preview.slidervertical,'Value')))+28;
   pagepos(1) = ((1-get(print_preview.sliderhorizontal,'Value'))*(back_pos(3)-pagepos(3)))+14;
   new_pagepos = [pagepos(1:2) 2*new_pagepos(3:4)];
   old_axespos = axespos;
   zoom_value = get(print_preview.zoomin,'UserData');
   new_axespos = 2*new_axespos;
   new_axespos(1) = new_pagepos(1)+2*(old_axespos(1)-old_pagepos(1));
   new_axespos(2) = new_pagepos(2)+2*(old_axespos(2)-old_pagepos(2));
   %
   pagepos(3:4) = zoom_value*pagepos(3:4);
   pagepos(2) = ((back_pos(4)-pagepos(4))*(1-get(print_preview.slidervertical,'Value')))+28;
   pagepos(1) = ((1-get(print_preview.sliderhorizontal,'Value'))*(back_pos(3)-pagepos(3)))+14;
   %
   axespos = 2*zoom_value*axespos;
   axespos(1) = pagepos(1)+2*zoom_value*(old_axespos(1)-old_pagepos(1));
   axespos(2) = pagepos(2)+2*zoom_value*(old_axespos(2)-old_pagepos(2));
   set(print_preview.page,'Position',pagepos);
   set(print_preview.axesdata,'Position',axespos);
   move_preview_plots_fcn(fig,print_preview.axesdata);
   %
   % fix inside cover areas
   %
   mypos = get(printpreview_gui,'Position');
   width = mypos(1,3);
   height = mypos(1,4);
   if pagepos(2)>1;
      set(print_preview.background_bottom,'Position',[1 1 width pagepos(2)-1],'Visible','on');
   else;
      set(print_preview.background_bottom,'Visible','off');
   end;
   if height>pagepos(2)+pagepos(4);
      set(print_preview.background_top,'Position',[1 pagepos(2)+pagepos(4) width height-(pagepos(2)+pagepos(4))],'Visible','on');
   else;
      set(print_preview.background_top,'Visible','off');
   end;
   if pagepos(1)>1;
      set(print_preview.background_left,'Position',[1 1 pagepos(1)-1 height],'Visible','on');
   else;
      set(print_preview.background_left,'Visible','off');
   end;
   if width>pagepos(1)+pagepos(3);
      set(print_preview.background_right,'Position',[pagepos(1)+pagepos(3) 1 width-(pagepos(1)+pagepos(3)) height],'Visible','on');
   else;
      set(print_preview.background_right,'Visible','off');
   end;
   if axespos(2)>pagepos(2);
      set(print_preview.page_bottom,'Position',[pagepos(1)+1 pagepos(2)+1 pagepos(3)-2 axespos(2)-pagepos(2)-2],'Visible','on');
   else;
      set(print_preview.page_bottom,'Visible','off');
   end;
   if pagepos(2)+pagepos(4)>axespos(2)+axespos(4)+2;
      set(print_preview.page_top,'Position',[pagepos(1)+1 axespos(2)+axespos(4)+1 pagepos(3)-2 pagepos(2)+pagepos(4)-(axespos(2)+axespos(4)+2)],'Visible','on');
   else;
      set(print_preview.page_top,'Visible','off');
   end;
   if axespos(1)>pagepos(1)+2;
      set(print_preview.page_left,'Position',[pagepos(1)+1 pagepos(2)+1 axespos(1)-pagepos(1)-2 pagepos(4)-2],'Visible','on');
   else;
      set(print_preview.page_left,'Visible','off');
   end;
   if pagepos(1)+pagepos(3)>axespos(1)+axespos(3)+2;
      set(print_preview.page_right,'Position',[axespos(1)+axespos(3)+1 pagepos(2)+1 pagepos(1)+pagepos(3)-(axespos(1)+axespos(3)+2) pagepos(4)-2],'Visible','on');
   else;
      set(print_preview.page_right,'Visible','off');
   end;
   set(print_preview.pageline_bottom,'Position',[pagepos(1:3) 1]);
   set(print_preview.pageline_top,'Position',[pagepos(1) pagepos(2)+pagepos(4)-1 pagepos(3) 1]);
   set(print_preview.pageline_left,'Position',[pagepos(1:2) 1 pagepos(4)]);
   set(print_preview.pageline_right,'Position',[pagepos(1)+pagepos(3)-1 pagepos(2) 1 pagepos(4)]);
   set(printpreview_gui,'UserData',print_preview);
case 'fix_zoom'
   if strcmp(get(print_preview.zoomin,'Enable'),'on')==1;
      set(print_preview.zoomout,'Enable','on');
      set(print_preview.zoomin,'Enable','off');
   else;
      set(print_preview.zoomout,'Enable','off');
      set(print_preview.zoomin,'Enable','on');
   end;
   set(printpreview_gui,'UserData',print_preview);
case 'zoom'
   %
   % check if we should zoom in or out
   %
   zoom_factor = get(print_preview.zoomfactor,'UserData');
   if strcmp(get(print_preview.zoomin,'Enable'),'off')==1;
      if get(print_preview.zoomin,'UserData')<=100;
         zoom_value = zoom_factor*get(print_preview.zoomin,'UserData');
      else;
         zoom_value = get(print_preview.zoomin,'UserData');
      end;
   else;
      zoom_value = get(print_preview.zoomin,'UserData')/zoom_factor;
      if zoom_value<=0.25;
         zoom_value = 0.25;
      end;
   end;
   set(print_preview.zoomin,'UserData',zoom_value);
   set(printpreview_gui,'UserData',print_preview);
   printpreview_fcn('slider');
case 'resize'
   mypos = get(printpreview_gui,'Position');
   width = mypos(1,3);
   height = mypos(1,4);
   %
   % make sure window is not too small
   %
   if height<=90;
      set(printpreview_gui,'Position',[mypos(1:3) 91]);
      return;
   end;
   %
   % dealing with the toolbar
   %
%   set(print_preview.print,'Position',[2 height-30 22 22]);
%   set(print_preview.pagesetup,'Position',[24 height-30 22 22]);
%   set(print_preview.zoomfactor,'Position',[60 height-30 60 22]);
%   set(print_preview.zoomin,'Position',[125 height-30 22 22]);
%   set(print_preview.zoomout,'Position',[147 height-30 22 22]);
%   set(print_preview.close,'Position',[183 height-30 22 22]);
%   xbox1 = print_preview.xbox1;
   xbox2 = print_preview.xbox2;
%   boxy1 = print_preview.ybox1;
%   boxy2 = print_preview.ybox2;
   if matlabnumber>=6.0;
%      delete(xbox1(1,1));
%      delete(xbox1(1,2));
%      delete(xbox1(1,3));
      delete(xbox2(1,1));
      delete(xbox2(1,2));
      delete(xbox2(1,3));
%      delete(boxy1(1,1));
%      delete(boxy1(1,2));
%      delete(boxy1(1,3));
%      delete(boxy2(1,1));
%      delete(boxy2(1,2));
%      delete(boxy2(1,3));
   else;
%      delete(xbox1(1,1));
%      delete(xbox1(1,2));
      delete(xbox2(1,1));
      delete(xbox2(1,2));
%      delete(boxy1(1,1));
%      delete(boxy1(1,2));
%      delete(boxy2(1,1));
%      delete(boxy2(1,2));
   end;
   for i=1:size(print_preview.showbox,2);
      delete(print_preview.showbox(1,i));
   end;
   %
   % creating new vertical and horizontal lines for the toolbar
   %
%   print_preview.xbox1 = xline([1 height-3 width],[0.5 1]);
%   print_preview.ybox1 = yline([52 height-30 22],[0.5 1]);
%   print_preview.ybox2 = yline([175 height-30 22],[0.5 1]);
   %
   % main box
   %
   print_preview.showbox = axesbox([2 2 width-2 height-15],'Print Preview',70,[0.5 1]);
   set(print_preview.sliderhorizontal,'Position',[14 14 width-42 14]);
   set(print_preview.slidervertical,'Position',[width-26 28 14 height-55]);
   set(print_preview.background,'Position',[14 28 width-42 height-50],'XLim',[14 width-28],'YLim',[28 height-47]);
   set(print_preview.top,'Position',[1 height-26 width 26]);
   set(print_preview.left,'Position',[1 1 13 height-26]);
   set(print_preview.right,'Position',[width-27 1 27 height-26]);
   set(print_preview.bottom,'Position',[1 1 width 13]);
   set(print_preview.topline,'Position',[14 height-27 width-42 1]);
   set(print_preview.bottomline,'Position',[14 28 width-42 1]);
   set(print_preview.leftline,'Position',[14 28 1 height-55]);
   set(print_preview.rightline,'Position',[width-28 28 1 height-55]);
   print_preview.xbox2 = xline([1 height-1 width],[0.5 1]);
   set(printpreview_gui,'UserData',print_preview);
   printpreview_fcn('slider');
case 'pagesetup'
   set(printpreview_gui,'Visible','off');
   drawnow;
   drawnow;
   curr_fig = get(print_preview.print,'UserData');
   toolbar = get(curr_fig,'UserData');
   h = pagesetup_fcn(curr_fig);
   pagesetup = get(h,'UserData');
   figinfo = get(pagesetup.apply,'UserData');
   my_crop_image = get(pagesetup.cropimage,'Value');
   set(pagesetup.page,'UserData','done');
   killguipid(h);
   drawnow;
   set(curr_fig,'InvertHardcopy',figinfo.inverthardcopy, ...
      'PaperOrientation',figinfo.paperorientation, ...
      'PaperType',figinfo.papertype, ...
      'PaperUnits',figinfo.paperunits, ...
      'PaperPositionMode',figinfo.paperpositionmode);
   if strcmp(figinfo.paperpositionmode,'manual')==1;
      set(curr_fig,'PaperPosition',figinfo.paperposition);
   end;
   if my_crop_image==1;
      set(toolbar.open,'UserData',1);
   else;
      set(toolbar.open,'UserData',[]);
   end;
   %
   % background color for "figure"
   %
   myaxes = get(toolbar.print,'UserData');
   if strcmp(figinfo.inverthardcopy,'on')==1;
      fig_color = [1 1 1];
      fig_colormap = gray;
   else;
      fig_color = get(myaxes(1,1),'Color');
      fig_colormap = get(curr_fig,'Colormap');
   end;
   set(printpreview_gui,'Colormap',fig_colormap);
   set(print_preview.axesdata,'Color',fig_color,'XColor',fig_color,'YColor',fig_color);
   %
   % update print preview
   %
   [pagepos,axespos,figinfo] = shadow_figure(figinfo);
   new_pagepos = pagepos;
   new_axespos = axespos;
   old_pagepos = pagepos;
   pagepos = 2*pagepos;
   back_pos = get(print_preview.background,'Position');
   pagepos(2) = ((back_pos(4)-pagepos(4))*(1-get(print_preview.slidervertical,'Value')))+28;
   pagepos(1) = ((1-get(print_preview.sliderhorizontal,'Value'))*(back_pos(3)-pagepos(3)))+14;
   new_pagepos = [pagepos(1:2) 2*new_pagepos(3:4)];
   old_axespos = axespos;
   zoom_value = get(print_preview.zoomin,'UserData');
   new_axespos = 2*new_axespos;
   new_axespos(1) = new_pagepos(1)+2*(old_axespos(1)-old_pagepos(1));
   new_axespos(2) = new_pagepos(2)+2*(old_axespos(2)-old_pagepos(2));
   %
   pagepos(3:4) = zoom_value*pagepos(3:4);
   pagepos(2) = ((back_pos(4)-pagepos(4))*(1-get(print_preview.slidervertical,'Value')))+28;
   pagepos(1) = ((1-get(print_preview.sliderhorizontal,'Value'))*(back_pos(3)-pagepos(3)))+14;
   %
   axespos = 2*zoom_value*axespos;
   axespos(1) = pagepos(1)+2*zoom_value*(old_axespos(1)-old_pagepos(1));
   axespos(2) = pagepos(2)+2*zoom_value*(old_axespos(2)-old_pagepos(2));
   set(print_preview.page,'Position',pagepos);
   set(print_preview.axesdata,'Position',axespos);
   move_preview_plots_fcn(curr_fig,print_preview.axesdata);
   %
   % fix inside cover areas
   %
   mypos = get(printpreview_gui,'Position');
   width = mypos(1,3);
   height = mypos(1,4);
   if pagepos(2)>1;
      set(print_preview.background_bottom,'Position',[1 1 width pagepos(2)-1],'Visible','on');
   else;
      set(print_preview.background_bottom,'Visible','off');
   end;
   if height>pagepos(2)+pagepos(4);
      set(print_preview.background_top,'Position',[1 pagepos(2)+pagepos(4) width height-(pagepos(2)+pagepos(4))],'Visible','on');
   else;
      set(print_preview.background_top,'Visible','off');
   end;
   if pagepos(1)>1;
      set(print_preview.background_left,'Position',[1 1 pagepos(1)-1 height],'Visible','on');
   else;
      set(print_preview.background_left,'Visible','off');
   end;
   if width>pagepos(1)+pagepos(3);
      set(print_preview.background_right,'Position',[pagepos(1)+pagepos(3) 1 width-(pagepos(1)+pagepos(3)) height],'Visible','on');
   else;
      set(print_preview.background_right,'Visible','off');
   end;
   if axespos(2)>pagepos(2);
      set(print_preview.page_bottom,'Position',[pagepos(1)+1 pagepos(2)+1 pagepos(3)-2 axespos(2)-pagepos(2)-2],'Visible','on');
   else;
      set(print_preview.page_bottom,'Visible','off');
   end;
   if pagepos(2)+pagepos(4)>axespos(2)+axespos(4)+2;
      set(print_preview.page_top,'Position',[pagepos(1)+1 axespos(2)+axespos(4)+1 pagepos(3)-2 pagepos(2)+pagepos(4)-(axespos(2)+axespos(4)+2)],'Visible','on');
   else;
      set(print_preview.page_top,'Visible','off');
   end;
   if axespos(1)>pagepos(1)+2;
      set(print_preview.page_left,'Position',[pagepos(1)+1 pagepos(2)+1 axespos(1)-pagepos(1)-2 pagepos(4)-2],'Visible','on');
   else;
      set(print_preview.page_left,'Visible','off');
   end;
   if pagepos(1)+pagepos(3)>axespos(1)+axespos(3)+2;
      set(print_preview.page_right,'Position',[axespos(1)+axespos(3)+1 pagepos(2)+1 pagepos(1)+pagepos(3)-(axespos(1)+axespos(3)+2) pagepos(4)-2],'Visible','on');
   else;
      set(print_preview.page_right,'Visible','off');
   end;
   set(print_preview.pageline_bottom,'Position',[pagepos(1:3) 1]);
   set(print_preview.pageline_top,'Position',[pagepos(1) pagepos(2)+pagepos(4)-1 pagepos(3) 1]);
   set(print_preview.pageline_left,'Position',[pagepos(1:2) 1 pagepos(4)]);
   set(print_preview.pageline_right,'Position',[pagepos(1)+pagepos(3)-1 pagepos(2) 1 pagepos(4)]);
   set(printpreview_gui,'UserData',print_preview,'Visible','on');
   drawnow;
   refresh(printpreview_gui);
case 'print'
   printpreview_fcn('done');
   toolbar_print_fcn;
case 'done'
   curr_fig = get(print_preview.print,'UserData');
   set(print_preview.close,'UserData','done');
   killguipid(printpreview_gui);
   drawnow;
   set(curr_fig,'Visible','on');
   drawnow;
   drawnow;
end;

if strcmp(selector,'init')==1;
   if (iswinnt==1)&(iscompiled==1)&(curr_ini.loadguiicon==1);
      prog = ['bin\runwindow.exe ' fix_path([pwd '\bin\seticon.exe']) ' ' get(printpreview_gui,'Name') ' ' fix_filepath([pwd '\icons\printfigure.ico'])];
      dos(prog);
      if (strcmp(curr_ini.pstoolsdir,'')==0)&(appexist([curr_ini.pstoolsdir 'pslist.exe'])==1);
         %
         % now we need to determine the pid
         %
         pid = getpid('seticon');
         set(print_preview.icon,'UserData',pid);
      end;
   end;
   set(printpreview_gui,'Visible','on');
end;

if my_exit==1;
   set(printpreview_gui,'Pointer','custom','PointerShapeCData',zoomin_pointer);
   waitfor(print_preview.close,'UserData','done');
end;

%
% end of printpreview_fcn.m
%
