function s = getstrings(c)
%GETSTRINGS Get strings from legend input
%   S = GETSTRINGS(C) where C is a cell array containing the legend
%   input arguments.  Handles three cases:
%      (1) legend_fcn(M) -- string matrix
%      (2) legend_fcn(C) -- cell array of strings
%      (3) legend_fcn(string1,string2,string3,...)
%   Returns a cell array of strings
if length(c)==1 % legend_fcn(M) or legend_fcn(C)
  s = cellstr(c{1});
elseif iscellstr(c)
  s = c;
else
  error('Legend labels must be strings.');
end

%
% end of getstrings.m
%
