function pj = preparepointers_fcn( pj )
%PREPAREPOINTERS Set Pointers of all open Figures to Watch. 
%   Saves current value for restoration by RESTOREPOINTERS.
%
%   See also RESTOREPOINTER

%   Copyright 1984-2001 The MathWorks, Inc. 
%   $Revision: 1.3 $  $Date: 2001/04/15 11:59:46 $

%Let user know we are working and get rid of XOR cross hair cursor
if strcmp( pj.Driver, 'mfile' )
    pj.AllFigures = [];
    return
end

pj.AllFigures = findall(0,'type','figure');
if length(pj.AllFigures) > 0
    pj.AllPointers = get( pj.AllFigures, 'pointer');
    set( pj.AllFigures, 'pointer', 'watch')
end
