function [hl,objh] = update_legend(legh)
%UPDATE_LEGEND Update an existing legend
if isempty(legh),
  hl = [];
  objh = [];
  return
end
if length(legh)~=1,
  error('Can only update one legend at a time.')
end

ud = get(legh,'userdata');
if ~isfield(ud,'LegendPosition')
  warning('No legend to update.')
  hl = []; objh = [];
  return
end

moved = DidLegendMove(legh);

units = get(legh,'units');
set(legh,'units','points')
oldpos = get(legh,'position');

%
% find patches in legend
%

old_patches = sort(findobj(legh,'Type','patch')');
if isempty(old_patches)==0;
   for i=1:size(old_patches,2);
      oldpatch(i).facecolor = get(old_patches(1,i),'FaceColor');
      oldpatch(i).edgecolor = get(old_patches(1,i),'EdgeColor');
   end;
end;

% Delete old legend
delete_legend(legh)

% Make a new one
if moved | length(ud.legendpos)==4
  [hl,objh] = make_legend(legh,ud.PlotHandle,ud.handles,ud.lstrings,oldpos);
else
  [hl,objh] = make_legend(legh,ud.PlotHandle,ud.handles,ud.lstrings,ud.legendpos);
end
set(hl,'units',units);

new_patches = sort(findobj(hl,'Type','patch')');
if isempty(old_patches)==0;
   if size(old_patches)==size(new_patches);
      for i=1:size(new_patches,2);
         set(new_patches(1,i),'FaceColor',oldpatch(i).facecolor);
         set(new_patches(1,i),'EdgeColor',oldpatch(i).edgecolor);
      end;
   end;
end;

%
% end of update_legend.m
%
