function [traceT,bart_corr,abort] = rec_trace(Z0,Z1,Z2,d,p,q1,q0,cointvalue,dd,ds,T0,deterselect,waitbar)

curr_ini = find_inisettings;

[n T] = size(Z0);

%
% Ensuring that all input variables are set
%

if T0<0;
   T1 = round(2*T/3);
elseif T0>0.95;
   T1 = round(2*T/3);
else;
   T1 = round(T*T0);
end;

if T1<=size(Z1,1)+size(Z2,1);
   T1 = size(Z1,1)+size(Z2,1)+1;
end;

if nargin<13;
   waitbar = 0;
end;

dcoint = 0;
if ((deterselect(1,2)==1)|(deterselect(1,4)==1));
   dcoint = 1;
end;

bart_corr = 'off';

if T1>T;
   traceT = [];
   abort = '';
   return;
end;

if waitbar==1;
   realscrsz = get(0,'ScreenSize');
   input_var.title = ['Progress for ' int2str(T-T1+1) ' recursive estimates'];
   input_var.facecolor = curr_ini.progress_facecolor;
   input_var.startfacecolor = curr_ini.progress_startfacecolor;
   input_var.edgecolor = curr_ini.progress_edgecolor;
   input_var.bgcolor = curr_ini.progress_bgcolor;
   input_var.label = 'Recursion number:';
   input_var.stop = 0;
   input_var.clock = 0;
   input_var.name = 'Recursive Estimation of Trace Test';
   mywait = progressdlg(0,input_var);
%   set(mywait,'Name','Recursive Estimation of Trace Test');
   set(mywait,'Color',get(0,'defaultuicontrolbackgroundcolor'));
   drawnow;
   progressdlg([(1/(T-T1+1)) 1]);
end;

%
% compute full sample estimates
%

[S_00,S_01,S_10,S_11,M_02,M_22,M_12,beta,lambda,traceT] = mlcointbasic(Z0,Z1,Z2,n);
if ((q1+q0==0)&(curr_ini.tracebart==1)&(dd-ds<2)&(cointvalue==1));
   bart_corr = 'on';
   bartcorr = barttr(S_00,S_01,S_10,S_11,M_02,M_22,M_12,beta,d,p,T,deterselect);
   traceT = traceT./bartcorr;
end;

abort = '';
t = T-1;
while t>=T1;
   if waitbar==1;
      abort = get(mywait,'UserData');
      if strcmp(abort,'cancel')==1;
         break;
      else;
         progressdlg([((T-t+1)/(T-T1+1)) (T-t+1)]);
      end;
   end;
   %
   % Checking for affinely dependent deterministic variables
   %
   if d>0;
      [Z2t,dfix] = fixdet(Z1(:,1:t),Z2(:,1:t),d,dcoint);
   else;
      dfix = 0;
      if isempty(Z2)==0;
         Z2t = Z2(:,1:t);
      else;
         Z2t = [];
      end;
   end;
   %
   % Reestimating the unrestricted beta for period t
   %
   [S_00,S_01,S_10,S_11,M_02,M_22,M_12,beta,lambda,tracet] = mlcointbasic(Z0(:,1:t),Z1(:,1:t),Z2t,n);
   %
   if strcmp(bart_corr,'on')==1;
      bartcorr = barttr(S_00,S_01,S_10,S_11,M_02,M_22,M_12,beta,d,p,t,deterselect);
      tracet = tracet./bartcorr;
   end;
   %
   traceT = [tracet traceT];
   t = t-1;
end;

if waitbar==1;
   set(mywait,'UserData','done');
   close(mywait);
   drawnow;
end;

%
% End of function rec_trace.m
%
