function reorder_legend_fcn

myleg = gca;
ud = get(myleg,'UserData');

if size(ud.lstrings,2)==1;
   return;
end;

oldorder = '';
for i=1:size(ud.lstrings,2);
   oldorder = strvcat(oldorder,ud.lstrings{i});
end;

fig_handle = reorder_fcn('init',oldorder,'Reorder Legend Strings','Current Legend Strings',110);
reorder = get(fig_handle,'UserData');
neworder = get(reorder.cancel,'UserData');
set(reorder.apply,'UserData','down');
killguipid(fig_handle);

%
% impose new order if different from oldorder
%

if isequal(oldorder,neworder)==0;
   %
   % reorder ud.handles
   %
   oldhandles = ud.handles;
   if size(oldhandles,1)<size(oldhandles,2);
      oldhandles = oldhandles';
   end;
   newhandles = [];
   for i=1:size(neworder,1);
      for j=1:size(neworder,1);
         if strcmp(strtrim(neworder(i,:)),strtrim(oldorder(j,:)))==1;
            newhandles = [newhandles;oldhandles(j,1)];
         end;
      end;
   end;
   %
   % reorder axes children
   %
   this_axes = get(oldhandles(1,1),'Parent');
   kids = get(this_axes,'Children');
   %
   % locate positions among kids
   %
   positions = [];
   for j=1:size(oldhandles,1);
      for i=1:size(kids,1);
         if kids(i,1)==oldhandles(j,1);
            positions = [positions;[i newhandles(j,1)]];
         end;
      end;
   end;
   newkids = kids;
   for i=1:size(positions,1);
      newkids(positions(i,1),1) = positions(i,2);
   end;
   %
   % apply new order to axis
   %
   set(this_axes,'Children',newkids);
   %
   % update the legend
   %
   leg_pos = get(myleg,'Position');
   delete_legend_fcn(this_axes);
   set(get(this_axes,'Parent'),'CurrentAxes',this_axes);
   ax_pos = get(this_axes,'Position');
   new_leg = legend_fcn(newhandles,neworder,1);
   set(new_leg,'Position',leg_pos);
   set(this_axes,'UserData',new_leg,'Position',ax_pos);
   leg_ud = get(new_leg,'UserData');
   %
   % add a context menu to the legend
   %
   legcontext = uicontextmenu('Callback','set(gcf,''Pointer'',''arrow'')');
   uimenu('Parent',legcontext,'Label','Font','Callback','change_legend_font');
   uimenu('Parent',legcontext,'Label','Text Color','Separator','on','Callback','change_legend_text_color');
   uimenu('Parent',legcontext,'Label','Background Color','Callback','change_axes_color');
   uimenu('Parent',legcontext,'Label','Border Color','Callback','change_legend_color');
   uimenu('Parent',legcontext,'Label','Reorder Legend','Separator','on','Callback','reorder_legend_fcn');
   uimenu('Parent',legcontext,'Label','Hide Legend','Separator','on','Callback','toolbar_legend_fcn');
   uimenu('Parent',legcontext,'Label','Lock Legend','Separator','on','Callback','legend_lock_fcn');
   leg_ud.UIContextMenu = legcontext;
   if isfield(leg_ud,'oldlstrings')==0;
      leg_ud.oldlstrings = ud.lstrings;
   end;
   set(new_leg,'UIContextMenu',legcontext,'UserData',leg_ud);
   set(get(new_leg,'Children'),'UIContextMenu',legcontext);
   %
   % connect all newhandles user data to handles in new legend
   %
   num = 1;
   for i=1:size(leg_ud.LabelHandles,1);
      if strcmp(get(leg_ud.LabelHandles(i,1),'Type'),'text')==0;
         if strcmp(get(newhandles(num),'Type'),'surface')==0;
            set(newhandles(num),'UserData',leg_ud.LabelHandles(i));
         end;
         num = num+1;
      end;
   end;
   %
   % apply old order to axis
   %
   set(this_axes,'Children',kids);
end;

%
% end of reorder_legend_fcn.m
%
