function save_line_fcn

h = get(0,'CurrentFigure');
toolbar = get(h,'UserData');

my_xlim = get(gca,'XLim');
my_ylim = get(gca,'YLim');
my_zlim = get(gca,'ZLim');
this_line = get(toolbar.addline,'UserData');

%
% get the data from the line
%

x_data = get(this_line,'XData');
y_data = get(this_line,'YData');
z_data = get(this_line,'ZData');

%
% make sure current point is accurate relative to the axes scale
%

axes_cp = get(gca,'CurrentPoint');
axes_cp = (axes_cp(1,:)+axes_cp(2,:))/2;

%
% change the line
%
if (strcmp(get(toolbar.addline,'State'),'on')==1)|(strcmp(get(toolbar.addarrow,'State'),'on')==1);
   x_data = [x_data(1,1);axes_cp(1,1)];
   y_data = [y_data(1,1);axes_cp(1,2)];
   z_data = [z_data(1,1);axes_cp(1,3)];
else;
   x_data = [x_data axes_cp(1,1)]';
   y_data = [y_data axes_cp(1,2)]';
   z_data = [z_data axes_cp(1,3)]';
end;

set(this_line,'XData',x_data,'YData',y_data,'ZData',z_data,'Selected','off');

%
% create a context menu for lines
%

check_button = strcmp(get(toolbar.addline,'State'),'on');
check_button2 = strcmp(get(toolbar.freehand,'State'),'on');
if (check_button==1)|(check_button2==1);
   lines_context_menu = uicontextmenu('Callback','set(gcf,''Pointer'',''arrow'')');
   uimenu('Parent',lines_context_menu,'Label','Color','Callback','lines_color_fcn');
   line_type_menu = uimenu('Parent',lines_context_menu,'Separator','on','Label','Type');
      uimenu('Parent',line_type_menu,'Label','Solid','Checked','on','Callback','set(gco,''LineStyle'',''-''); uimenu_check_fcn');
      uimenu('Parent',line_type_menu,'Label','Dash','Callback','set(gco,''LineStyle'',''--''); uimenu_check_fcn');
      uimenu('Parent',line_type_menu,'Label','Dot','Callback','set(gco,''LineStyle'','':''); uimenu_check_fcn');
      uimenu('Parent',line_type_menu,'Label','Dash-Dot','Callback','set(gco,''LineStyle'',''-.''); uimenu_check_fcn');
      uimenu('Parent',line_type_menu,'Label','None','Callback','set(gco,''LineStyle'',''none''); uimenu_check_fcn');
   line_width_menu = uimenu('Parent',lines_context_menu,'Label','Width');
      uimenu('Parent',line_width_menu,'Label','1 pt','Checked','on','Callback','set(gco,''LineWidth'',1); uimenu_check_fcn');
      uimenu('Parent',line_width_menu,'Label','2 pts','Callback','set(gco,''LineWidth'',2); uimenu_check_fcn');
      uimenu('Parent',line_width_menu,'Label','3 pts','Callback','set(gco,''LineWidth'',3); uimenu_check_fcn');
      uimenu('Parent',line_width_menu,'Label','4 pts','Callback','set(gco,''LineWidth'',4); uimenu_check_fcn');
      uimenu('Parent',line_width_menu,'Label','5 pts','Callback','set(gco,''LineWidth'',5); uimenu_check_fcn');
      uimenu('Parent',line_width_menu,'Label','6 pts','Callback','set(gco,''LineWidth'',6); uimenu_check_fcn');
      uimenu('Parent',line_width_menu,'Label','7 pts','Callback','set(gco,''LineWidth'',7); uimenu_check_fcn');
      uimenu('Parent',line_width_menu,'Label','8 pts','Callback','set(gco,''LineWidth'',8); uimenu_check_fcn');
      uimenu('Parent',line_width_menu,'Label','9 pts','Callback','set(gco,''LineWidth'',9); uimenu_check_fcn');
      uimenu('Parent',line_width_menu,'Label','10 pts','Callback','set(gco,''LineWidth'',10); uimenu_check_fcn');
   line_marker_menu = uimenu('Parent',lines_context_menu,'Label','Marker');
      uimenu('Parent',line_marker_menu,'Label','none','Checked','on','Callback','set(gco,''Marker'',''none''); uimenu_check_fcn');
      uimenu('Parent',line_marker_menu,'Label','plus sign','Callback','set(gco,''Marker'',''+''); uimenu_check_fcn');
      uimenu('Parent',line_marker_menu,'Label','circle','Callback','set(gco,''Marker'',''o''); uimenu_check_fcn');
      uimenu('Parent',line_marker_menu,'Label','asterisk','Callback','set(gco,''Marker'',''*''); uimenu_check_fcn');
      uimenu('Parent',line_marker_menu,'Label','point','Callback','set(gco,''Marker'',''.''); uimenu_check_fcn');
      uimenu('Parent',line_marker_menu,'Label','cross','Callback','set(gco,''Marker'',''x''); uimenu_check_fcn');
      uimenu('Parent',line_marker_menu,'Label','square','Callback','set(gco,''Marker'',''s''); uimenu_check_fcn');
      uimenu('Parent',line_marker_menu,'Label','diamond','Callback','set(gco,''Marker'',''d''); uimenu_check_fcn');
      uimenu('Parent',line_marker_menu,'Label','up triangle','Callback','set(gco,''Marker'',''^''); uimenu_check_fcn');
      uimenu('Parent',line_marker_menu,'Label','down triangle','Callback','set(gco,''Marker'',''v''); uimenu_check_fcn');
      uimenu('Parent',line_marker_menu,'Label','right triangle','Callback','set(gco,''Marker'',''>''); uimenu_check_fcn');
      uimenu('Parent',line_marker_menu,'Label','left triangle','Callback','set(gco,''Marker'',''<''); uimenu_check_fcn');
      uimenu('Parent',line_marker_menu,'Label','pentagram','Callback','set(gco,''Marker'',''p''); uimenu_check_fcn');
      uimenu('Parent',line_marker_menu,'Label','hexagram','Callback','set(gco,''Marker'',''h''); uimenu_check_fcn');
   line_markersize_menu = uimenu('Parent',lines_context_menu,'Label','Marker Size');
      uimenu('Parent',line_markersize_menu,'Label','1 pt','Callback','set(gco,''MarkerSize'',1); uimenu_check_fcn');
      uimenu('Parent',line_markersize_menu,'Label','2 pts','Callback','set(gco,''MarkerSize'',2); uimenu_check_fcn');
      uimenu('Parent',line_markersize_menu,'Label','3 pts','Callback','set(gco,''MarkerSize'',3); uimenu_check_fcn');
      uimenu('Parent',line_markersize_menu,'Label','4 pts','Callback','set(gco,''MarkerSize'',4); uimenu_check_fcn');
      uimenu('Parent',line_markersize_menu,'Label','5 pts','Callback','set(gco,''MarkerSize'',5); uimenu_check_fcn');
      uimenu('Parent',line_markersize_menu,'Label','6 pts','Checked','on','Callback','set(gco,''MarkerSize'',6); uimenu_check_fcn');
      uimenu('Parent',line_markersize_menu,'Label','7 pts','Callback','set(gco,''MarkerSize'',7); uimenu_check_fcn');
      uimenu('Parent',line_markersize_menu,'Label','8 pts','Callback','set(gco,''MarkerSize'',8); uimenu_check_fcn');
      uimenu('Parent',line_markersize_menu,'Label','9 pts','Callback','set(gco,''MarkerSize'',9); uimenu_check_fcn');
      uimenu('Parent',line_markersize_menu,'Label','10 pts','Callback','set(gco,''MarkerSize'',10); uimenu_check_fcn');
      uimenu('Parent',line_markersize_menu,'Label','11 pts','Callback','set(gco,''MarkerSize'',11); uimenu_check_fcn');
      uimenu('Parent',line_markersize_menu,'Label','12 pts','Callback','set(gco,''MarkerSize'',12); uimenu_check_fcn');
      uimenu('Parent',line_markersize_menu,'Label','13 pts','Callback','set(gco,''MarkerSize'',13); uimenu_check_fcn');
      uimenu('Parent',line_markersize_menu,'Label','14 pts','Callback','set(gco,''MarkerSize'',14); uimenu_check_fcn');
      uimenu('Parent',line_markersize_menu,'Label','15 pts','Callback','set(gco,''MarkerSize'',15); uimenu_check_fcn');
      uimenu('Parent',line_markersize_menu,'Label','16 pts','Callback','set(gco,''MarkerSize'',16); uimenu_check_fcn');
   uimenu('Parent',lines_context_menu,'Separator','on','Label','Edit Data','Callback','toolbar_editdata_fcn');
   uimenu('Parent',lines_context_menu,'Label','Edit Name','Callback','toolbar_editname_fcn');
   uimenu('Parent',lines_context_menu,'Separator','on','Label','Cut','Callback','delete(gco); empty_axes');
   uimenu('Parent',lines_context_menu,'Label','Copy','Callback','copy_line_fcn');
   set(this_line,'UIContextMenu',lines_context_menu);
else;
   delete(this_line);
   this_arrow = arrow_fcn('Start',[x_data(1,1) y_data(1,1) z_data(1,1)],'Stop',[x_data(2,1) y_data(2,1) z_data(2,1)],'Length',10,'BaseAngle',90,'TipAngle',16,'Width',0);
   if strcmp(get(this_arrow,'Type'),'patch')==1;
      set(this_arrow,'FaceLighting','none');
      arrow_context_menu = uicontextmenu('Callback','set(gcf,''Pointer'',''arrow'')');
      uimenu('Parent',arrow_context_menu,'Label','Color','Callback','arrow_color_fcn');
      arrow_length_menu = uimenu('Parent',arrow_context_menu,'Separator','on','Label','Length');
         uimenu('Parent',arrow_length_menu,'Label','4','Callback','change_arrow_length(4); uimenu_check_fcn');
         uimenu('Parent',arrow_length_menu,'Label','5','Callback','change_arrow_length(5); uimenu_check_fcn');
         uimenu('Parent',arrow_length_menu,'Label','6','Callback','change_arrow_length(6); uimenu_check_fcn');
         uimenu('Parent',arrow_length_menu,'Label','7','Callback','change_arrow_length(7); uimenu_check_fcn');
         uimenu('Parent',arrow_length_menu,'Label','8','Callback','change_arrow_length(8); uimenu_check_fcn');
         uimenu('Parent',arrow_length_menu,'Label','9','Callback','change_arrow_length(9); uimenu_check_fcn');
         uimenu('Parent',arrow_length_menu,'Label','10','Checked','on','Callback','change_arrow_length(10); uimenu_check_fcn');
         uimenu('Parent',arrow_length_menu,'Label','11','Callback','change_arrow_length(11); uimenu_check_fcn');
         uimenu('Parent',arrow_length_menu,'Label','12','Callback','change_arrow_length(12); uimenu_check_fcn');
         uimenu('Parent',arrow_length_menu,'Label','13','Callback','change_arrow_length(13); uimenu_check_fcn');
         uimenu('Parent',arrow_length_menu,'Label','14','Callback','change_arrow_length(14); uimenu_check_fcn');
         uimenu('Parent',arrow_length_menu,'Label','15','Callback','change_arrow_length(15); uimenu_check_fcn');
         uimenu('Parent',arrow_length_menu,'Label','16','Callback','change_arrow_length(16); uimenu_check_fcn');
         uimenu('Parent',arrow_length_menu,'Label','17','Callback','change_arrow_length(17); uimenu_check_fcn');
         uimenu('Parent',arrow_length_menu,'Label','18','Callback','change_arrow_length(18); uimenu_check_fcn');
         uimenu('Parent',arrow_length_menu,'Label','19','Callback','change_arrow_length(19); uimenu_check_fcn');
         uimenu('Parent',arrow_length_menu,'Label','20','Callback','change_arrow_length(20); uimenu_check_fcn');
         uimenu('Parent',arrow_length_menu,'Label','21','Callback','change_arrow_length(21); uimenu_check_fcn');
         uimenu('Parent',arrow_length_menu,'Label','22','Callback','change_arrow_length(22); uimenu_check_fcn');
         uimenu('Parent',arrow_length_menu,'Label','23','Callback','change_arrow_length(23); uimenu_check_fcn');
         uimenu('Parent',arrow_length_menu,'Label','24','Callback','change_arrow_length(24); uimenu_check_fcn');
         uimenu('Parent',arrow_length_menu,'Label','25','Callback','change_arrow_length(25); uimenu_check_fcn');
         uimenu('Parent',arrow_length_menu,'Label','26','Callback','change_arrow_length(26); uimenu_check_fcn');
         uimenu('Parent',arrow_length_menu,'Label','27','Callback','change_arrow_length(27); uimenu_check_fcn');
         uimenu('Parent',arrow_length_menu,'Label','28','Callback','change_arrow_length(28); uimenu_check_fcn');
         uimenu('Parent',arrow_length_menu,'Label','29','Callback','change_arrow_length(29); uimenu_check_fcn');
         uimenu('Parent',arrow_length_menu,'Label','30','Callback','change_arrow_length(30); uimenu_check_fcn');
      arrow_base_menu = uimenu('Parent',arrow_context_menu,'Label','Base Angle');
         uimenu('Parent',arrow_base_menu,'Label','5','Callback','change_arrow_base(5)');
         uimenu('Parent',arrow_base_menu,'Label','10','Callback','change_arrow_base(10); uimenu_check_fcn');
         uimenu('Parent',arrow_base_menu,'Label','15','Callback','change_arrow_base(15); uimenu_check_fcn');
         uimenu('Parent',arrow_base_menu,'Label','20','Callback','change_arrow_base(20); uimenu_check_fcn');
         uimenu('Parent',arrow_base_menu,'Label','25','Callback','change_arrow_base(25); uimenu_check_fcn');
         uimenu('Parent',arrow_base_menu,'Label','30','Callback','change_arrow_base(30); uimenu_check_fcn');
         uimenu('Parent',arrow_base_menu,'Label','35','Callback','change_arrow_base(35); uimenu_check_fcn');
         uimenu('Parent',arrow_base_menu,'Label','40','Callback','change_arrow_base(40); uimenu_check_fcn');
         uimenu('Parent',arrow_base_menu,'Label','45','Callback','change_arrow_base(45); uimenu_check_fcn');
         uimenu('Parent',arrow_base_menu,'Label','50','Callback','change_arrow_base(50); uimenu_check_fcn');
         uimenu('Parent',arrow_base_menu,'Label','55','Callback','change_arrow_base(55); uimenu_check_fcn');
         uimenu('Parent',arrow_base_menu,'Label','60','Callback','change_arrow_base(60); uimenu_check_fcn');
         uimenu('Parent',arrow_base_menu,'Label','65','Callback','change_arrow_base(65); uimenu_check_fcn');
         uimenu('Parent',arrow_base_menu,'Label','70','Callback','change_arrow_base(70); uimenu_check_fcn');
         uimenu('Parent',arrow_base_menu,'Label','75','Callback','change_arrow_base(75); uimenu_check_fcn');
         uimenu('Parent',arrow_base_menu,'Label','80','Callback','change_arrow_base(80); uimenu_check_fcn');
         uimenu('Parent',arrow_base_menu,'Label','85','Callback','change_arrow_base(85); uimenu_check_fcn');
         uimenu('Parent',arrow_base_menu,'Label','90','Checked','on','Callback','change_arrow_base(90)');
      arrow_tip_menu = uimenu('Parent',arrow_context_menu,'Label','Tip Angle');
         uimenu('Parent',arrow_tip_menu,'Label','4','Callback','change_arrow_tip(4); uimenu_check_fcn');
         uimenu('Parent',arrow_tip_menu,'Label','8','Callback','change_arrow_tip(8); uimenu_check_fcn');
         uimenu('Parent',arrow_tip_menu,'Label','12','Callback','change_arrow_tip(12); uimenu_check_fcn');
         uimenu('Parent',arrow_tip_menu,'Label','16','Checked','on','Callback','change_arrow_tip(16); uimenu_check_fcn');
         uimenu('Parent',arrow_tip_menu,'Label','20','Callback','change_arrow_tip(20); uimenu_check_fcn');
         uimenu('Parent',arrow_tip_menu,'Label','24','Callback','change_arrow_tip(24); uimenu_check_fcn');
         uimenu('Parent',arrow_tip_menu,'Label','28','Callback','change_arrow_tip(28); uimenu_check_fcn');
         uimenu('Parent',arrow_tip_menu,'Label','32','Callback','change_arrow_tip(32); uimenu_check_fcn');
         uimenu('Parent',arrow_tip_menu,'Label','36','Callback','change_arrow_tip(36); uimenu_check_fcn');
         uimenu('Parent',arrow_tip_menu,'Label','40','Callback','change_arrow_tip(40); uimenu_check_fcn');
         uimenu('Parent',arrow_tip_menu,'Label','44','Callback','change_arrow_tip(44); uimenu_check_fcn');
         uimenu('Parent',arrow_tip_menu,'Label','48','Callback','change_arrow_tip(48); uimenu_check_fcn');
         uimenu('Parent',arrow_tip_menu,'Label','52','Callback','change_arrow_tip(52); uimenu_check_fcn');
         uimenu('Parent',arrow_tip_menu,'Label','56','Callback','change_arrow_tip(56); uimenu_check_fcn');
         uimenu('Parent',arrow_tip_menu,'Label','60','Callback','change_arrow_tip(60); uimenu_check_fcn');
      arrow_width_menu = uimenu('Parent',arrow_context_menu,'Label','Width');
         uimenu('Parent',arrow_width_menu,'Label','0','Checked','on','Callback','change_arrow_width(0); uimenu_check_fcn');
         uimenu('Parent',arrow_width_menu,'Label','1','Callback','change_arrow_width(1); uimenu_check_fcn');
         uimenu('Parent',arrow_width_menu,'Label','2','Callback','change_arrow_width(2); uimenu_check_fcn');
         uimenu('Parent',arrow_width_menu,'Label','3','Callback','change_arrow_width(3); uimenu_check_fcn');
         uimenu('Parent',arrow_width_menu,'Label','4','Callback','change_arrow_width(4); uimenu_check_fcn');
         uimenu('Parent',arrow_width_menu,'Label','5','Callback','change_arrow_width(5); uimenu_check_fcn');
         uimenu('Parent',arrow_width_menu,'Label','6','Callback','change_arrow_width(6); uimenu_check_fcn');
         uimenu('Parent',arrow_width_menu,'Label','7','Callback','change_arrow_width(7); uimenu_check_fcn');
         uimenu('Parent',arrow_width_menu,'Label','8','Callback','change_arrow_width(8); uimenu_check_fcn');
         uimenu('Parent',arrow_width_menu,'Label','9','Callback','change_arrow_width(9); uimenu_check_fcn');
         uimenu('Parent',arrow_width_menu,'Label','10','Callback','change_arrow_width(10); uimenu_check_fcn');
      uimenu('Parent',arrow_context_menu,'Separator','on','Label','Shift Tip','Callback','change_arrow_tippos');
      uimenu('Parent',arrow_context_menu,'Separator','on','Label','Cut','Callback','delete(gco); empty_axes');
      set(this_arrow,'UIContextMenu',arrow_context_menu);
   elseif strcmp(get(this_arrow,'Type'),'line')==1;
      lines_context_menu = uicontextmenu('Callback','set(gcf,''Pointer'',''arrow'')');
      uimenu('Parent',lines_context_menu,'Label','Color','Callback','lines_color_fcn');
      line_type_menu = uimenu('Parent',lines_context_menu,'Separator','on','Label','Type');
         uimenu('Parent',line_type_menu,'Label','Solid','Checked','on','Callback','set(gco,''LineStyle'',''-''); uimenu_check_fcn');
         uimenu('Parent',line_type_menu,'Label','Dash','Callback','set(gco,''LineStyle'',''--''); uimenu_check_fcn');
         uimenu('Parent',line_type_menu,'Label','Dot','Callback','set(gco,''LineStyle'','':''); uimenu_check_fcn');
         uimenu('Parent',line_type_menu,'Label','Dash-Dot','Callback','set(gco,''LineStyle'',''-.''); uimenu_check_fcn');
         uimenu('Parent',line_type_menu,'Label','None','Callback','set(gco,''LineStyle'',''none''); uimenu_check_fcn');
      line_width_menu = uimenu('Parent',lines_context_menu,'Label','Width');
         uimenu('Parent',line_width_menu,'Label','1 pt','Checked','on','Callback','set(gco,''LineWidth'',1); uimenu_check_fcn');
         uimenu('Parent',line_width_menu,'Label','2 pts','Callback','set(gco,''LineWidth'',2); uimenu_check_fcn');
         uimenu('Parent',line_width_menu,'Label','3 pts','Callback','set(gco,''LineWidth'',3); uimenu_check_fcn');
         uimenu('Parent',line_width_menu,'Label','4 pts','Callback','set(gco,''LineWidth'',4); uimenu_check_fcn');
         uimenu('Parent',line_width_menu,'Label','5 pts','Callback','set(gco,''LineWidth'',5); uimenu_check_fcn');
         uimenu('Parent',line_width_menu,'Label','6 pts','Callback','set(gco,''LineWidth'',6); uimenu_check_fcn');
         uimenu('Parent',line_width_menu,'Label','7 pts','Callback','set(gco,''LineWidth'',7); uimenu_check_fcn');
         uimenu('Parent',line_width_menu,'Label','8 pts','Callback','set(gco,''LineWidth'',8); uimenu_check_fcn');
         uimenu('Parent',line_width_menu,'Label','9 pts','Callback','set(gco,''LineWidth'',9); uimenu_check_fcn');
         uimenu('Parent',line_width_menu,'Label','10 pts','Callback','set(gco,''LineWidth'',10); uimenu_check_fcn');
      line_marker_menu = uimenu('Parent',lines_context_menu,'Label','Marker');
         uimenu('Parent',line_marker_menu,'Label','none','Checked','on','Callback','set(gco,''Marker'',''none''); uimenu_check_fcn');
         uimenu('Parent',line_marker_menu,'Label','plus sign','Callback','set(gco,''Marker'',''+''); uimenu_check_fcn');
         uimenu('Parent',line_marker_menu,'Label','circle','Callback','set(gco,''Marker'',''o''); uimenu_check_fcn');
         uimenu('Parent',line_marker_menu,'Label','asterisk','Callback','set(gco,''Marker'',''*''); uimenu_check_fcn');
         uimenu('Parent',line_marker_menu,'Label','point','Callback','set(gco,''Marker'',''.''); uimenu_check_fcn');
         uimenu('Parent',line_marker_menu,'Label','cross','Callback','set(gco,''Marker'',''x''); uimenu_check_fcn');
         uimenu('Parent',line_marker_menu,'Label','square','Callback','set(gco,''Marker'',''s''); uimenu_check_fcn');
         uimenu('Parent',line_marker_menu,'Label','diamond','Callback','set(gco,''Marker'',''d''); uimenu_check_fcn');
         uimenu('Parent',line_marker_menu,'Label','up triangle','Callback','set(gco,''Marker'',''^''); uimenu_check_fcn');
         uimenu('Parent',line_marker_menu,'Label','down triangle','Callback','set(gco,''Marker'',''v''); uimenu_check_fcn');
         uimenu('Parent',line_marker_menu,'Label','right triangle','Callback','set(gco,''Marker'',''>''); uimenu_check_fcn');
         uimenu('Parent',line_marker_menu,'Label','left triangle','Callback','set(gco,''Marker'',''<''); uimenu_check_fcn');
         uimenu('Parent',line_marker_menu,'Label','pentagram','Callback','set(gco,''Marker'',''p''); uimenu_check_fcn');
         uimenu('Parent',line_marker_menu,'Label','hexagram','Callback','set(gco,''Marker'',''h''); uimenu_check_fcn');
      line_markersize_menu = uimenu('Parent',lines_context_menu,'Label','Marker Size');
         uimenu('Parent',line_markersize_menu,'Label','1 pt','Callback','set(gco,''MarkerSize'',1); uimenu_check_fcn');
         uimenu('Parent',line_markersize_menu,'Label','2 pts','Callback','set(gco,''MarkerSize'',2); uimenu_check_fcn');
         uimenu('Parent',line_markersize_menu,'Label','3 pts','Callback','set(gco,''MarkerSize'',3); uimenu_check_fcn');
         uimenu('Parent',line_markersize_menu,'Label','4 pts','Callback','set(gco,''MarkerSize'',4); uimenu_check_fcn');
         uimenu('Parent',line_markersize_menu,'Label','5 pts','Callback','set(gco,''MarkerSize'',5); uimenu_check_fcn');
         uimenu('Parent',line_markersize_menu,'Label','6 pts','Checked','on','Callback','set(gco,''MarkerSize'',6); uimenu_check_fcn');
         uimenu('Parent',line_markersize_menu,'Label','7 pts','Callback','set(gco,''MarkerSize'',7); uimenu_check_fcn');
         uimenu('Parent',line_markersize_menu,'Label','8 pts','Callback','set(gco,''MarkerSize'',8); uimenu_check_fcn');
         uimenu('Parent',line_markersize_menu,'Label','9 pts','Callback','set(gco,''MarkerSize'',9); uimenu_check_fcn');
         uimenu('Parent',line_markersize_menu,'Label','10 pts','Callback','set(gco,''MarkerSize'',10); uimenu_check_fcn');
         uimenu('Parent',line_markersize_menu,'Label','11 pts','Callback','set(gco,''MarkerSize'',11); uimenu_check_fcn');
         uimenu('Parent',line_markersize_menu,'Label','12 pts','Callback','set(gco,''MarkerSize'',12); uimenu_check_fcn');
         uimenu('Parent',line_markersize_menu,'Label','13 pts','Callback','set(gco,''MarkerSize'',13); uimenu_check_fcn');
         uimenu('Parent',line_markersize_menu,'Label','14 pts','Callback','set(gco,''MarkerSize'',14); uimenu_check_fcn');
         uimenu('Parent',line_markersize_menu,'Label','15 pts','Callback','set(gco,''MarkerSize'',15); uimenu_check_fcn');
         uimenu('Parent',line_markersize_menu,'Label','16 pts','Callback','set(gco,''MarkerSize'',16); uimenu_check_fcn');
      uimenu('Parent',lines_context_menu,'Separator','on','Label','Cut','Callback','delete(gco); empty_axes');
      set(this_arrow,'UIContextMenu',lines_context_menu);
   end;
end;

set(gca,'XLim',my_xlim,'YLim',my_ylim,'ZLim',my_zlim);

set(h,'WindowButtonUpFcn','');
set(h,'WindowButtonMotionFcn','pointer_crosshair');
set(h,'WindowButtonDownFcn','addline_fcn');
set(h,'DoubleBuffer','off');

%
% end of save_line_fcn.m
%
