function save_rectangle_fcn

h = get(0,'CurrentFigure');
toolbar = get(h,'UserData');

my_xlim = get(gca,'XLim');
my_ylim = get(gca,'YLim');
my_zlim = get(gca,'ZLim');
this_line = get(toolbar.rectangle,'UserData');

if size(this_line,2)==4;
   %
   % Collecting the line data
   %
   x_data = [get(this_line(1,1),'XData') get(this_line(1,2),'XData') get(this_line(1,3),'XData') get(this_line(1,4),'XData')];
   y_data = [get(this_line(1,1),'YData') get(this_line(1,2),'YData') get(this_line(1,3),'YData') get(this_line(1,4),'YData')];
   delete(this_line);
   %
   % create a patch object instead
   %
   my_p = patch(x_data,y_data,[0.5 0.5 0.5]);
   face_color = (192/255)*[1 1 1];
   %
   set(my_p,'FaceColor',face_color,'EdgeColor',face_color,'Tag','rectpatch','LineStyle','-','LineWidth',1);
   %
   % make sure the patch lies under all objects, including the axes
   %
   kids = get(gca,'Children');
   if size(kids,1)>1;
      kids = [kids(2:size(kids,1),1);my_p];
      set(gca,'Children',kids);
   end;
   set(gca,'Layer','top');
   %
   % Create a context menu for patches
   %
   patches_context_menu = uicontextmenu('Callback','set(gcf,''Pointer'',''arrow'')');
   uimenu('Parent',patches_context_menu,'Label','Patch Color','Callback','patch_color_fcn');
   uimenu('Parent',patches_context_menu,'Label','Edge Color','Callback','patch_edgecolor_fcn');
   uimenu('Parent',patches_context_menu,'Label','Face Color','Callback','patch_facecolor_fcn');
   patch_type_menu = uimenu('Parent',patches_context_menu,'Separator','on','Label','Type');
      uimenu('Parent',patch_type_menu,'Label','Solid','Checked','on','Callback','change_patch_type(''-''); uimenu_check_fcn');
      uimenu('Parent',patch_type_menu,'Label','Dash','Checked','off','Callback','change_patch_type(''--''); uimenu_check_fcn');
      uimenu('Parent',patch_type_menu,'Label','Dot','Checked','off','Callback','change_patch_type('':''); uimenu_check_fcn');
      uimenu('Parent',patch_type_menu,'Label','Dash-Dot','Checked','off','Callback','change_patch_type(''-.''); uimenu_check_fcn');
   patch_width_menu = uimenu('Parent',patches_context_menu,'Label','Width');
      uimenu('Parent',patch_width_menu,'Label','1 pt','Checked','on','Callback','change_patch_width(1); uimenu_check_fcn');
      uimenu('Parent',patch_width_menu,'Label','2 pts','Checked','off','Callback','change_patch_width(2); uimenu_check_fcn');
      uimenu('Parent',patch_width_menu,'Label','3 pts','Checked','off','Callback','change_patch_width(3); uimenu_check_fcn');
      uimenu('Parent',patch_width_menu,'Label','4 pts','Checked','off','Callback','change_patch_width(4); uimenu_check_fcn');
      uimenu('Parent',patch_width_menu,'Label','5 pts','Checked','off','Callback','change_patch_width(5); uimenu_check_fcn');
      uimenu('Parent',patch_width_menu,'Label','6 pts','Checked','off','Callback','change_patch_width(6); uimenu_check_fcn');
      uimenu('Parent',patch_width_menu,'Label','7 pts','Checked','off','Callback','change_patch_width(7); uimenu_check_fcn');
      uimenu('Parent',patch_width_menu,'Label','8 pts','Checked','off','Callback','change_patch_width(8); uimenu_check_fcn');
      uimenu('Parent',patch_width_menu,'Label','9 pts','Checked','off','Callback','change_patch_width(9); uimenu_check_fcn');
      uimenu('Parent',patch_width_menu,'Label','10 pts','Checked','off','Callback','change_patch_width(10); uimenu_check_fcn');
   uimenu('Parent',patches_context_menu,'Separator','on','Label','Stretch Horizontally','Callback','stretch_a_patch(''h'')');
   uimenu('Parent',patches_context_menu,'Label','Stretch Vertically','Callback','stretch_a_patch(''v'')');
   uimenu('Parent',patches_context_menu,'Label','Adjust X-scale to X axis limits','Callback','xscale_patch_fcn');
   uimenu('Parent',patches_context_menu,'Label','Adjust Y-scale to Y axis limits','Callback','yscale_patch_fcn');
   uimenu('Parent',patches_context_menu,'Separator','on','Label','Edit Data','Callback','toolbar_editdata_fcn');
   if isvalidpatchname(my_p)==1;
      uimenu('Parent',patches_context_menu,'Label','Edit Name','Callback','toolbar_editname_fcn');
   end;
   uimenu('Parent',patches_context_menu,'Separator','on','Label','Cut','Callback','delete_line_patch_fcn');
   uimenu('Parent',patches_context_menu,'Label','Copy','Callback','copy_patch_fcn');
   set(my_p,'UIContextMenu',patches_context_menu);
else;
   %
   % didn't move cursor so we don't make a patch
   %
   delete(this_line);
end;

%
% reset figure button up, down and motion function
%

set(gca,'XLim',my_xlim,'YLim',my_ylim,'ZLim',my_zlim);

set(h,'WindowButtonUpFcn','');
set(h,'WindowButtonMotionFcn','pointer_crosshair');
set(h,'WindowButtonDownFcn','addrectangle_fcn');
set(h,'DoubleBuffer','off');

%
% end of save_rectangle_fcn.m
%
