function show_normalitytest(fig_handle,tm,curr_ini,ind)

set(fig_handle,'Visible','off');
drawnow;
res_str = '';
if ind==1;
   res_str = ' restricted';
end;
prt_val = ['%0.' num2str(curr_ini.decimals,'%0.0f') 'f'];
realscrsz = get(0,'ScreenSize');
[results3,degfreedom3] = normality(tm.epsilon,tm.T-tm.df);
normtext = strvcat(' ',['NORMALITY TESTS (for' res_str ' rank=' num2str(tm.r,'%0.0f') ')']);
numchar = size(normtext,2);
addcorr = '';
for i=1:numchar;
   addcorr = strcat(addcorr,'=');
end;
normtext = strvcat(normtext,addcorr,' ');
normtext = strvcat(normtext,'  Wald-type test statistic','  ~~~~~~~~~~~~~~~~~~~~~~~~',' ');
normtext = strvcat(normtext,'Null hypothesis:        Std. residuals have skewness 0','Alternative hypothesis: Std. residuals are skewed',' ');
if curr_ini.sscorrect==0;
   normtext = strvcat(normtext,['W(' strrep(degfreedom3(1,:),' ','') ') = ' num2str(results3(1,1),prt_val)]);
   normtext = strvcat(normtext,['p-value = ' num2str(results3(1,2),prt_val)]);
   normtext = strvcat(normtext,' ','   ------------------------',' ');
   normtext = strvcat(normtext,'Null hypothesis:        Std. residuals have kurtosis 3','Alternative hypothesis: Std. residuals don''t have kurtosis 3',' ');
   normtext = strvcat(normtext,['W(' strrep(degfreedom3(2,:),' ','') ') = ' num2str(results3(1,3),prt_val)]);
   normtext = strvcat(normtext,['p-value = ' num2str(results3(1,4),prt_val)]);
   normtext = strvcat(normtext,' ','   ------------------------',' ');
   normtext = strvcat(normtext,'Null hypothesis:        Std. resisuals have skewness 0','                        and kurtosis 3','Alternative hypothesis: Std. residuals are either skewed or','                        don''t have kurtosis 3',' ');
   normtext = strvcat(normtext,['W(' strrep(degfreedom3(3,:),' ','') ') = ' num2str(results3(1,5),prt_val)]);
   normtext = strvcat(normtext,['p-value = ' num2str(results3(1,6),prt_val)]);
else;
   normtext = strvcat(normtext,['F' strrep(degfreedom3(1,:),' ','') ' = ' num2str(results3(1,1),prt_val)]);
   normtext = strvcat(normtext,['p-value = ' num2str(results3(1,2),prt_val)]);
   normtext = strvcat(normtext,' ','   ------------------------',' ');
   normtext = strvcat(normtext,'Null hypothesis:        Std. residuals have kurtosis 3','Alternative hypothesis: Std. residuals don''t have kurtosis 3',' ');
   normtext = strvcat(normtext,['F' strrep(degfreedom3(2,:),' ','') ' = ' num2str(results3(1,3),prt_val)]);
   normtext = strvcat(normtext,['p-value = ' num2str(results3(1,4),prt_val)]);
   normtext = strvcat(normtext,' ','   ------------------------',' ');
   normtext = strvcat(normtext,'Null hypothesis:        Std. resisuals have skewness 0','                        and kurtosis 3','Alternative hypothesis: Std. residuals are either skewed or','                        don''t have kurtosis 3',' ');
   normtext = strvcat(normtext,['F' strrep(degfreedom3(3,:),' ','') ' = ' num2str(results3(1,5),prt_val)]);
   normtext = strvcat(normtext,['p-value = ' num2str(results3(1,6),prt_val)]);
end;
normtext = strvcat(normtext,' ');
if curr_ini.omnibus==1;
   [results4,degfreedom4] = omnibus_fcn(tm.epsilon,tm.T-tm.df);
   addcorr = '';
   numchar = size(normtext,2);
   for i=1:numchar+1;
      addcorr=[addcorr '-'];
   end;
   normtext = strvcat(normtext,addcorr,' ');
   normtext = strvcat(normtext,'   Shenton-Bowman/Doornik-Hansen Omnibus-type test','   ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~',' ');
   normtext = strvcat(normtext,'Null hypothesis:        Std. resisuals have skewness 0','                        and kurtosis 3','Alternative hypothesis: Std. residuals are either skewed or','                        don''t have kurtosis 3',' ');
   if curr_ini.sscorrect==0;
      normtext = strvcat(normtext,['E_' num2str(tm.n,'%0.0f') '(' degfreedom4 ') = ' num2str(results4(1,1),prt_val)]);
      normtext = strvcat(normtext,['p-value = ' num2str(results4(1,2),prt_val)]);
   else;
      normtext = strvcat(normtext,['F' degfreedom4 ' = ' num2str(results4(1,1),prt_val) '       (based on E_' num2str(tm.n,'%0.0f') ')']);
      normtext = strvcat(normtext,['p-value = ' num2str(results4(1,2),prt_val)]);
   end;
   normtext = strvcat(normtext,' ');
end;
textgui(normtext,'Normality Tests',[(realscrsz(3)-680)/2 (realscrsz(4)-400)/2 680 400],'Results',38);
set(fig_handle,'Visible','on');
drawnow;

%
% end of show_normalitytest.m
%
