function toolbar_editdata_fcn(selector)

if nargin==0;
   selector = 'init';
   curr_obj = gco;
   curr_ini = find_inisettings;
   %
   mycons = getstoredimages;
   if curr_ini.use_toolbar_bgcolor==1;
      bgcolor = (1/255)*(round(255*get(0,'defaultuicontrolbackgroundcolor'))-[8 4 8]);
      bgcolor(1) = max(0,bgcolor(1));
      bgcolor(2) = max(0,bgcolor(2));
      bgcolor(3) = max(0,bgcolor(3));
   else;
      bgcolor = [NaN NaN NaN];
   end;
   btn_images.save = maketrans(mycons.save_image,[160 160 164],bgcolor);
   btn_images.saveas = maketrans(mycons.saveas_image,[160 160 164],bgcolor);
   btn_images.print = maketrans(mycons.print_image,[160 160 164],bgcolor);
   btn_images.close = maketrans(mycons.close_image,[160 160 164],bgcolor);
   ed_data.undo = maketrans(mycons.undo_image,[160 160 164],get(0,'defaultuicontrolbackgroundcolor'));
   ed_data.undodisable = maketrans(mycons.undodisable_image,[160 160 164],get(0,'defaultuicontrolbackgroundcolor'));
   %
   % now we can hide the current window
   %
   par = get(0,'CurrentFigure');
   set(par,'Visible','off');
   drawnow;
   x_data = get(curr_obj,'XData')';
   y_data = get(curr_obj,'YData')';
   if strcmp(get(curr_obj,'Type'),'line')==1;
      %
      % current object is a line
      %
      if size(x_data,2)>size(x_data,1);
         x_data = x_data';
      end;
      if size(y_data,2)>size(y_data,1);
         y_data = y_data';
      end;
      %
      % check if the line is constructed from a stairs function. if so remove duplicates
      %
      res_tag = findstr(get(curr_obj,'Tag'),'-stairs');
      if (isempty(res_tag)==0)&(max(size(x_data))>1);
         elem = (1:2:max(size(x_data)))';
         x_data = x_data(elem,:);
         y_data = y_data(elem,:);
      end;
      %
      % check the frequency of the data
      %
      ch_freq = x_data(2,1)-x_data(1,1);
      if isalmostequal(ch_freq,1)==1;
         this_freq = 1;
      elseif isalmostequal(ch_freq,1/4)==1;
         this_freq = 4;
      elseif isalmostequal(ch_freq,1/12)==1;
         this_freq = 12;
      else;
         this_freq = 0;
      end;
      %
      if this_freq==1;
         if isalmostequal(x_data(1,1),0)==0;
            label_str = 'Date';
            add_str = ':1';
         else;
            label_str = 'Period';
            add_str = '';
         end;
         x_str = [num2str(x_data(1,1),'%0.0f') add_str];
         for j=2:size(x_data,1);
            x_str = strvcat(x_str,[num2str(x_data(j,1),'%0.0f') add_str]);
         end;
      elseif this_freq==4;
         x_str = getdate(x_data(1,1),x_data(size(x_data,1),1),'q',1/size(x_data,1));
         for j=2:size(x_data,1);
            x_str = strvcat(x_str,getdate(x_data(1,1),x_data(size(x_data,1),1),'q',j/size(x_data,1)));
         end;
         label_str = 'Date';
      elseif this_freq==12;
         x_str = getdate(x_data(1,1),x_data(size(x_data,1),1),'m',1/size(x_data,1));
         for j=2:size(x_data,1);
            x_str = strvcat(x_str,getdate(x_data(1,1),x_data(size(x_data,1),1),'m',j/size(x_data,1)));
         end;
         label_str = 'Date';
      else;
         x_str = '';
         label_str = 'X-axis';
      end;
      %
      % try to determine a name for the Y-axis data
      %
      var_name = get(curr_obj,'Tag');
      if strcmp(strtrim(var_name),'')==1;
         var_name = 'y-data';
      else;
         var_name = strrep(var_name,'-stairs','');
         if strcmp(strtrim(var_name),'')==1;
            var_names = 'y-data';
         end;
      end;
   elseif strcmp(get(curr_obj,'Type'),'patch')==1;
      %
      % current object is a patch
      %
      if size(x_data,2)>size(x_data,1);
         x_data = x_data';
      end;
      if size(y_data,2)>size(y_data,1);
         y_data = y_data';
      end;
      valid_p = 0;
      %
      % need to fix the y_data depending on the type of patch we have
      %
      if (strcmp(get(curr_obj,'Tag'),'confpatch')==1)|(strcmp(get(curr_obj,'Tag'),'confpatch-new')==1);
         %
         % we have a confidence region patch
         %
         y_data = [y_data(1:size(x_data,1)/2,1) reverse(y_data((size(x_data,1)/2)+1:size(x_data,1),1))];
         x_data = x_data(1:size(x_data,1)/2,1);
         valid_p = 1;
      elseif (strcmp(get(curr_obj,'Tag'),'autopatch')==1)|(strcmp(get(curr_obj,'Tag'),'autopatch-new')==1)|(strcmp(get(curr_obj,'Tag'),'distpatch')==1)|(strcmp(get(curr_obj,'Tag'),'distpatch-new')==1)|(strcmp(get(curr_obj,'Tag'),'import-data')==1)|(strcmp(get(curr_obj,'Tag'),'import-data-new')==1);
         %
         % we have a bar patch
         %
         if size(x_data,2)<4;
            x_data = x_data';
         end;
         if size(y_data,2)<4;
            y_data = y_data';
         end;
         if (size(x_data,2)==4)&(size(y_data,2)==4);
            ed_data.old_x_data = x_data;
            ed_data.old_y_data = y_data;
            ed_data.width = abs((x_data(1,3)-x_data(1,2))/2);
            x_data = (1/size(x_data,2))*sum(x_data,2);
            y_data = y_data(:,2);
            valid_p = 1;
         end;
      elseif (strcmp(lower(get(curr_obj,'Tag')),'rectpatch')==1)|(strcmp(lower(get(curr_obj,'Tag')),'rectpatch-new')==1);
         %
         % we have a rectangle patch
         %
         x_data = sort(x_data(3:4,1));
         y_data = sort(y_data(5:6,1));
         valid_p = 1;
      end;
      %
      if valid_p==1;
         %
         % check the frequency of the data
         %
         ch_freq = x_data(2,1)-x_data(1,1);
         if isalmostequal(ch_freq,1)==1;
            this_freq = 1;
         elseif isalmostequal(ch_freq,1/4)==1;
            this_freq = 4;
         elseif isalmostequal(ch_freq,1/12)==1;
            this_freq = 12;
         else;
            this_freq = 0;
         end;
         %
         if this_freq==1;
            if (isalmostequal(x_data(1,1),0)==1)|(isalmostequal(x_data(1,1),1)==1);
               label_str = 'Period';
               add_str = '';
            else;
               label_str = 'Date';
               add_str = ':1';
            end;
            x_str = [num2str(x_data(1,1),'%0.0f') add_str];
            for j=2:size(x_data,1);
               x_str = strvcat(x_str,[num2str(x_data(j,1),'%0.0f') add_str]);
            end;
         elseif this_freq==4;
            x_str = getdate(x_data(1,1),x_data(size(x_data,1),1),'q',1/size(x_data,1));
            for j=2:size(x_data,1);
               x_str = strvcat(x_str,getdate(x_data(1,1),x_data(size(x_data,1),1),'q',j/size(x_data,1)));
            end;
            label_str = 'Date';
         elseif this_freq==12;
            x_str = getdate(x_data(1,1),x_data(size(x_data,1),1),'m',1/size(x_data,1));
            for j=2:size(x_data,1);
               x_str = strvcat(x_str,getdate(x_data(1,1),x_data(size(x_data,1),1),'m',j/size(x_data,1)));
            end;
            label_str = 'Date';
         else;
            x_str = '';
            label_str = 'X-axis';
         end;
         %
         % try to determine a name for the Y-axis data
         %
         if size(y_data,2)==1;
            line_ud = get(curr_obj,'UserData');
            if (isempty(line_ud)==0)&(ishandle(line_ud)==1);
               leg = get(line_ud,'Parent');
               leg_ud = get(leg,'UserData');
               chk = 0;
               if size(leg_ud.handles,2)>size(leg_ud.handles,1);
                  leg_ud.handles = leg_ud.handles';
               end;
               for i1=1:size(leg_ud.handles,1);
                  if leg_ud.handles(i1,1)==curr_obj;
                     num = i1;
                     chk = 1;
                     break;
                  end;
               end;
               if chk==1;
                  if iscellstr(leg_ud.lstrings)==1;
                     var_name = leg_ud.lstrings{num};
                  else;
                     if size(leg_ud.lstrings,1)>=num;
                        var_name = strtrim(leg_ud.lstrings(num,:));
                     end;
                  end;
               else;
                  var_name = get(curr_obj,'Tag');
               end;
            else;
               var_name = get(curr_obj,'Tag');
            end;
            %           
            if strcmp(strtrim(var_name),'')==1;
               var_name = 'y-data';
            end;
            var_name = strrep(var_name,'\','');
         else;
            var_name = strvcat('upper','lower');
         end;
      else;
         txt_str = 'Structural VAR was unable to use the patch data.';
         about(txt_str,'information','Bad Data',120,350);
         set(par,'Visible','on');
         drawnow;
         return;
      end;
   end;
else;
   ed_gui = get(0,'CurrentFigure');
   ed_data = get(ed_gui,'UserData');
   curr_ini = ed_data.curr_ini;
end;

%
% the switch function
%

switch selector;
   case 'init';
      realscrsz = get(0,'ScreenSize');
      ed_gui = figure('Color',get(0,'defaultuicontrolbackgroundcolor'), ...
         'FileName','toolbar_editdata_fcn.m', ...
         'MenuBar','none', ...
         'PaperUnits','points', ...
         'Units','pixels', ...
         'Position',[(realscrsz(3)-700)/2 32 700 realscrsz(4)-84], ...
         'Tag','EditData', ...
         'Visible','off', ...
         'Resize','off', ...
         'NumberTitle','off', ...
         'CloseRequestFcn','toolbar_editdata_fcn close', ...
         'ToolBar','none');

      if matlabnumber>=7.0;
         set(ed_gui,'DockControl','off');
      end;

      if size(var_name,1)==1;
         set(ed_gui,'Name',['Edit Data - ' var_name]);
      elseif size(var_name,1)==2;
         set(ed_gui,'Name',['Edit Data - ' strtrim(var_name(1,:)) ' and ' strtrim(var_name(2,:))]);
      end;

      %
      % set up a dialog information structure
      %
      
      ed_data.parent = par;
      ed_data.curr_ini = curr_ini;
      ed_data.x_str = x_str;
      ed_data.x_data = x_data;
      ed_data.y_data = y_data;
      ed_data.curr_obj = curr_obj;
      ed_data.obj_type = get(curr_obj,'Type');
      ed_data.orig_x_data = x_data;
      ed_data.orig_y_data = y_data;
      ed_data.changed = 0;

      %
      % setting up a toolbar
      %

      ed_data.toolbar = uitoolbar('Parent',ed_gui, ...
                           'HandleVisibility','off', ...
                           'Interruptible','on', ...
                           'Clipping','on');

      ed_data.save = uipushtool('Parent',ed_data.toolbar, ...
                         'TooltipString','Save', ...
                         'CData',btn_images.save, ...
                         'ClickedCallback','toolbar_editdata_fcn save', ...
                         'Separator','off', ...
                         'Interruptible','on', ...
                         'Clipping','on', ...
                         'Enable','off', ...
                         'Tag','Save');

      ed_data.saveas = uipushtool('Parent',ed_data.toolbar, ...
                         'TooltipString','Save As', ...
                         'CData',btn_images.saveas, ...
                         'ClickedCallback','toolbar_editdata_fcn saveas', ...
                         'Separator','off', ...
                         'Interruptible','on', ...
                         'Clipping','on', ...
                         'Enable','on', ...
                         'Tag','SaveAs');

      ed_data.print = uipushtool('Parent',ed_data.toolbar, ...
                         'TooltipString','Print', ...
                         'CData',btn_images.print, ...
                         'ClickedCallback','toolbar_editdata_fcn print', ...
                         'Separator','off', ...
                         'Interruptible','on', ...
                         'Clipping','on', ...
                         'Enable','on', ...
                         'Tag','Print');

      ed_data.done = uipushtool('Parent',ed_data.toolbar, ...
                         'TooltipString','Close', ...
                         'CData',btn_images.close, ...
                         'ClickedCallback','toolbar_editdata_fcn close', ...
                         'Separator','on', ...
                         'Interruptible','on', ...
                         'Clipping','on', ...
                         'UserData','waiting', ...
                         'Enable','on', ...
                         'Tag','Done');

      %
      % we now create the edit controls
      %

      if size(y_data,2)==1;
         ed_data.icon = uicontrol('Units','pixels', ...
            'BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'), ...
            'Style','pushbutton', ...
            'Position',[20 realscrsz(4)-135 46 20], ...
            'FontSize',curr_ini.gui_fontsize, ...
            'FontName',curr_ini.gui_fontname, ...
            'CData',ed_data.undodisable, ...
            'HorizontalAlignment','right', ...
            'Callback','toolbar_editdata_fcn cancel', ...
            'ToolTipString','Cancel', ...
            'Enable','off', ...
            'Tag','topleft');
   
         c1 = uicontrol('Units','pixels', ...
            'BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'), ...
            'Style','togglebutton', ...
            'Position',[66 realscrsz(4)-135 300 20], ...
            'FontSize',curr_ini.gui_fontsize, ...
            'FontName',curr_ini.gui_fontname, ...
            'HorizontalAlignment','right', ...
            'String',label_str, ...
            'Callback','toolbar_editdata_fcn vertical', ...
            'UserData',2, ...
            'Enable','on', ...
            'Tag','topmiddle');
   
         c2 = uicontrol('Units','pixels', ...
            'BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'), ...
            'Style','togglebutton', ...
            'Position',[366 realscrsz(4)-135 300 20], ...
            'FontSize',curr_ini.gui_fontsize, ...
            'FontName',curr_ini.gui_fontname, ...
            'HorizontalAlignment','right', ...
            'String',var_name, ...
            'Callback','toolbar_editdata_fcn vertical', ...
            'UserData',3, ...
            'Enable','on', ...
            'Tag','topright');
         ed_data.header = [ed_data.icon c1 c2];
      else;
         ed_data.icon = uicontrol('Units','pixels', ...
            'BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'), ...
            'Style','pushbutton', ...
            'Position',[20 realscrsz(4)-135 46 20], ...
            'FontSize',curr_ini.gui_fontsize, ...
            'FontName',curr_ini.gui_fontname, ...
            'CData',ed_data.undodisable, ...
            'HorizontalAlignment','right', ...
            'Callback','toolbar_editdata_fcn cancel', ...
            'ToolTipString','Cancel', ...
            'Enable','off', ...
            'Tag','topleft');
   
         c1 = uicontrol('Units','pixels', ...
            'BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'), ...
            'Style','togglebutton', ...
            'Position',[66 realscrsz(4)-135 200 20], ...
            'FontSize',curr_ini.gui_fontsize, ...
            'FontName',curr_ini.gui_fontname, ...
            'HorizontalAlignment','right', ...
            'String',label_str, ...
            'Callback','toolbar_editdata_fcn vertical', ...
            'UserData',2, ...
            'Enable','on', ...
            'Tag','topmiddle');
   
         c2 = uicontrol('Units','pixels', ...
            'BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'), ...
            'Style','togglebutton', ...
            'Position',[266 realscrsz(4)-135 200 20], ...
            'FontSize',curr_ini.gui_fontsize, ...
            'FontName',curr_ini.gui_fontname, ...
            'HorizontalAlignment','right', ...
            'String',strtrim(var_name(1,:)), ...
            'Callback','toolbar_editdata_fcn vertical', ...
            'UserData',3, ...
            'Enable','on', ...
            'Tag','topright');
         c3 = uicontrol('Units','pixels', ...
            'BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'), ...
            'Style','togglebutton', ...
            'Position',[466 realscrsz(4)-135 200 20], ...
            'FontSize',curr_ini.gui_fontsize, ...
            'FontName',curr_ini.gui_fontname, ...
            'HorizontalAlignment','right', ...
            'String',strtrim(var_name(2,:)), ...
            'Callback','toolbar_editdata_fcn vertical', ...
            'UserData',4, ...
            'Enable','on', ...
            'Tag','topright2');
         ed_data.header = [ed_data.icon c1 c2 c3];
      end;
            

      ed_data.controls = [];
      pos = realscrsz(4)-155;
      ed_data.positions = [];
      for i=1:size(y_data,1);
         if pos>=20;
            if size(y_data,2)==1;
               con1 = uicontrol('Units','pixels', ...
                  'BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'), ...
                  'Style','togglebutton', ...
                  'Position',[20 pos 46 20], ...
                  'FontSize',curr_ini.gui_fontsize, ...
                  'FontName',curr_ini.gui_fontname, ...
                  'HorizontalAlignment','right', ...
                  'String',num2str(i,'%0.0f'), ...
                  'Callback','toolbar_editdata_fcn horizontal', ...
                  'Enable','on', ...
                  'Tag','topleft');
               con2 = uicontrol('Units','pixels', ...
                  'BackgroundColor',[1 1 1], ...
                  'Style','edit', ...
                  'Position',[66 pos 300 20], ...
                  'FontSize',curr_ini.gui_fontsize, ...
                  'FontName',curr_ini.gui_fontname, ...
                  'HorizontalAlignment','right', ...
                  'String','', ...
                  'Callback','toolbar_editdata_fcn edit', ...
                  'Enable','on', ...
                  'Tag','topmiddle');
               con3 = uicontrol('Units','pixels', ...
                  'BackgroundColor',[1 1 1], ...
                  'Style','edit', ...
                  'Position',[366 pos 300 20], ...
                  'FontSize',curr_ini.gui_fontsize, ...
                  'FontName',curr_ini.gui_fontname, ...
                  'HorizontalAlignment','right', ...
                  'String','', ...
                  'Callback','toolbar_editdata_fcn edit', ...
                  'Enable','on', ...
                  'Tag','topright');
               con4 = [];
            else;
               con1 = uicontrol('Units','pixels', ...
                  'BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'), ...
                  'Style','togglebutton', ...
                  'Position',[20 pos 46 20], ...
                  'FontSize',curr_ini.gui_fontsize, ...
                  'FontName',curr_ini.gui_fontname, ...
                  'HorizontalAlignment','right', ...
                  'String',num2str(i,'%0.0f'), ...
                  'Callback','toolbar_editdata_fcn horizontal', ...
                  'Enable','on', ...
                  'Tag','topleft');
               con2 = uicontrol('Units','pixels', ...
                  'BackgroundColor',[1 1 1], ...
                  'Style','edit', ...
                  'Position',[66 pos 200 20], ...
                  'FontSize',curr_ini.gui_fontsize, ...
                  'FontName',curr_ini.gui_fontname, ...
                  'HorizontalAlignment','right', ...
                  'String','', ...
                  'Callback','toolbar_editdata_fcn edit', ...
                  'Enable','on', ...
                  'Tag','topmiddle');
               con3 = uicontrol('Units','pixels', ...
                  'BackgroundColor',[1 1 1], ...
                  'Style','edit', ...
                  'Position',[266 pos 200 20], ...
                  'FontSize',curr_ini.gui_fontsize, ...
                  'FontName',curr_ini.gui_fontname, ...
                  'HorizontalAlignment','right', ...
                  'String','', ...
                  'Callback','toolbar_editdata_fcn edit', ...
                  'Enable','on', ...
                  'Tag','topright');
               con4 = uicontrol('Units','pixels', ...
                  'BackgroundColor',[1 1 1], ...
                  'Style','edit', ...
                  'Position',[466 pos 200 20], ...
                  'FontSize',curr_ini.gui_fontsize, ...
                  'FontName',curr_ini.gui_fontname, ...
                  'HorizontalAlignment','right', ...
                  'String','', ...
                  'Callback','toolbar_editdata_fcn edit', ...
                  'Enable','on', ...
                  'Tag','topright2');
            end;
            ed_data.positions = [ed_data.positions;pos];
            
            last_pos = pos;
            if pos-20>=20;
               pos = pos-20;
            else;
               pos = 0;
            end;
            ed_data.low_num = i;
            
         else;
            if size(y_data,2)==1;
               con1 = uicontrol('Units','pixels', ...
                  'BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'), ...
                  'Style','togglebutton', ...
                  'Position',[20 pos 46 20], ...
                  'FontSize',curr_ini.gui_fontsize, ...
                  'FontName',curr_ini.gui_fontname, ...
                  'HorizontalAlignment','right', ...
                  'String',num2str(i,'%0.0f'), ...
                  'Callback','toolbar_editdata_fcn horizontal', ...
                  'Enable','on', ...
                  'Visible','off', ...
                  'Tag','topleft');
               con2 = uicontrol('Units','pixels', ...
                  'BackgroundColor',[1 1 1], ...
                  'Style','edit', ...
                  'Position',[66 pos 300 20], ...
                  'FontSize',curr_ini.gui_fontsize, ...
                  'FontName',curr_ini.gui_fontname, ...
                  'HorizontalAlignment','right', ...
                  'String','', ...
                  'Visible','off', ...
                  'Callback','toolbar_editdata_fcn edit', ...
                  'Enable','on', ...
                  'Tag','topmiddle');
               con3 = uicontrol('Units','pixels', ...
                  'BackgroundColor',[1 1 1], ...
                  'Style','edit', ...
                  'Position',[366 pos 300 20], ...
                  'FontSize',curr_ini.gui_fontsize, ...
                  'FontName',curr_ini.gui_fontname, ...
                  'HorizontalAlignment','right', ...
                  'String','', ...
                  'Visible','off', ...
                  'Callback','toolbar_editdata_fcn edit', ...
                  'Enable','on', ...
                  'Tag','topright');
               con4 = [];
            else;
               con1 = uicontrol('Units','pixels', ...
                  'BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'), ...
                  'Style','togglebutton', ...
                  'Position',[20 pos 46 20], ...
                  'FontSize',curr_ini.gui_fontsize, ...
                  'FontName',curr_ini.gui_fontname, ...
                  'HorizontalAlignment','right', ...
                  'String',num2str(i,'%0.0f'), ...
                  'Callback','toolbar_editdata_fcn horizontal', ...
                  'Enable','on', ...
                  'Visible','off', ...
                  'Tag','topleft');
               con2 = uicontrol('Units','pixels', ...
                  'BackgroundColor',[1 1 1], ...
                  'Style','edit', ...
                  'Position',[66 pos 200 20], ...
                  'FontSize',curr_ini.gui_fontsize, ...
                  'FontName',curr_ini.gui_fontname, ...
                  'HorizontalAlignment','right', ...
                  'String','', ...
                  'Visible','off', ...
                  'Callback','toolbar_editdata_fcn edit', ...
                  'Enable','on', ...
                  'Tag','topmiddle');
               con3 = uicontrol('Units','pixels', ...
                  'BackgroundColor',[1 1 1], ...
                  'Style','edit', ...
                  'Position',[266 pos 200 20], ...
                  'FontSize',curr_ini.gui_fontsize, ...
                  'FontName',curr_ini.gui_fontname, ...
                  'HorizontalAlignment','right', ...
                  'String','', ...
                  'Visible','off', ...
                  'Callback','toolbar_editdata_fcn edit', ...
                  'Enable','on', ...
                  'Tag','topright');
               con4 = uicontrol('Units','pixels', ...
                  'BackgroundColor',[1 1 1], ...
                  'Style','edit', ...
                  'Position',[466 pos 200 20], ...
                  'FontSize',curr_ini.gui_fontsize, ...
                  'FontName',curr_ini.gui_fontname, ...
                  'HorizontalAlignment','right', ...
                  'String','', ...
                  'Visible','off', ...
                  'Callback','toolbar_editdata_fcn edit', ...
                  'Enable','on', ...
                  'Tag','topright2');
            end;

         end;

         if isempty(x_str)==0;
            set(con2,'String',strtrim(x_str(i,:)),'Enable','off');
         else;
            set(con2,'String',num2str(x_data(i,1),'%0.16f'),'UserData',x_data(i,1));
         end;
         set(con3,'String',num2str(y_data(i,1),'%0.16f'),'UserData',y_data(i,1));
         if size(y_data,2)==2;
            set(con4,'String',num2str(y_data(i,2),'%0.16f'),'UserData',y_data(i,2));
         end;

         ed_data.controls =[ed_data.controls;[con1 con2 con3 con4]];
      end;
      

      
      ed_data.slider = uicontrol('Units','pixels', ...
         'BackgroundColor',(get(0,'defaultuicontrolbackgroundcolor')+[1 1 1])/2, ...
         'Position',[666 20 14 realscrsz(4)-135], ...
         'Style','slider', ...
         'Min',ed_data.low_num, ...
         'Max',size(y_data,1), ...
         'Value',size(y_data,1), ...
         'Callback','toolbar_editdata_fcn slider', ...
         'Enable','on', ...
         'Tag','Vertical');
      
      if last_pos>20;
         set(ed_data.slider,'Position',[666 last_pos 14 realscrsz(4)-135-(last_pos-20)]);
      end;

      if size(y_data,1)-ed_data.low_num>0;
         if 10/(size(y_data,1)-ed_data.low_num)<=1;
            set(ed_data.slider,'SliderStep',[1/(size(y_data,1)-ed_data.low_num) 10/(size(y_data,1)-ed_data.low_num)]);
         else;
            if 2/(size(y_data,1)-ed_data.low_num)<=1;
               set(ed_data.slider,'SliderStep',[1/(size(y_data,1)-ed_data.low_num) 2/(size(y_data,1)-ed_data.low_num)]);
            else;
               set(ed_data.slider,'SliderStep',[0.9 1.0],'UserData',1);
            end;
         end;
      else;
         delete(ed_data.slider);
         ed_data = rmfield(ed_data,'slider');
      end;
      %
      % resize the window if there is no slider
      %
      if isfield(ed_data,'slider')==0;
         %
         % readjust all controls
         %
         pos = 20;
         for i=1:size(ed_data.controls,1);
            for j=1:size(ed_data.controls,2);
               new_pos = get(ed_data.controls(size(ed_data.controls,1)-i+1,j),'Position');
               new_pos(2) = pos;
               set(ed_data.controls(size(ed_data.controls,1)-i+1,j),'Position',new_pos);
            end;
            pos = pos+20;
         end;
         %
         for j=1:size(ed_data.header,2);
            new_pos = get(ed_data.header(1,j),'Position');
            new_pos(2) = pos;
            set(ed_data.header(1,j),'Position',new_pos);
         end;
         %
         % adjust pos
         %
         xline([1 pos+50 700],[0.5 1]);
         axesbox([2 2 698 pos+40],'Data',25,[0.5 1]);
         set(ed_gui,'Position',[(realscrsz(3)-700)/2 (realscrsz(4)-pos-51)/2 700 pos+51]);
      else;
         xline([1 realscrsz(4)-85 700],[0.5 1]);
         axesbox([2 2 698 realscrsz(4)-95],'Data',25,[0.5 1]);
      end;

      set(ed_gui,'UserData',ed_data,'HandleVisibility','callback');

   case 'slider'
      slider_val = get(ed_data.slider,'Value');
      if isempty(get(ed_data.slider,'UserData'))==0;
         if isequal(slider_val,round(slider_val))==0;
            slider_val = round(slider_val);
            set(ed_data.slider,'Value',slider_val);
         end;
      end;
      for i=1:size(ed_data.controls,1);
         for j=1:size(ed_data.controls,2);
            pos = get(ed_data.controls(i,j),'Position');
            pos(1,2) = 0;
            set(ed_data.controls(i,j),'Position',pos,'Visible','off');
         end;
      end;
      if isint(slider_val)==0;
         slider_val = round(slider_val);
      end;
      first_con = size(ed_data.controls,1)-slider_val+1;
      last_con = first_con+ed_data.low_num-1;
      num = 1;
      for i=first_con:last_con;
         for j=1:size(ed_data.controls,2);
            pos = get(ed_data.controls(i,j),'Position');
            pos(1,2) = ed_data.positions(num,1);
            set(ed_data.controls(i,j),'Position',pos,'Visible','on');
         end;
         num = num+1;
      end;
   case 'print'
      file = [curr_ini.tempdir 'svar-temp.txt'];
      fid = fopen(file,'wt');
      %
      % header text
      %
      txt_str = '';
      for i=2:size(ed_data.header,2);
         txt_str = [txt_str '   ' strrep(get(ed_data.header(1,i),'String'),' ','')];
      end;
      fprintf(fid,'%s \n',strtrim(txt_str));
      for i=1:size(ed_data.controls,1);
         txt_str = '';
         for j=2:size(ed_data.controls,2);
            txt_str = [txt_str '   ' get(ed_data.controls(i,j),'String')];
         end;
         fprintf(fid,[strtrim(txt_str) '\n']);
      end;
      fclose(fid);
      %
      % we now print the temporary text file
      %
      stat = waitfor_filewrite(file,'t');
      if stat==0;
         if strcmp(computer,'PCWIN')==1;
            if strcmp(curr_ini.txtprint,'')==1;
               prog = ['notepad.exe /p ' fix_path(file) ' &'];
            else;
               prog = fix_path(curr_ini.txtprint);
               if strcmp(curr_ini.txtprintcmd,'')==0;
                  prog = [prog ' ' curr_ini.txtprintcmd];
               end;
               prog = [prog ' ' fix_path(file) ' &'];
            end;
            prog = fixcmd(prog);
            newstat = dos(prog);
            drawnow;
         else;
            if isunix==1;
               if strcmp(curr_ini.txtprint,'')==1;
                  prog = ['lpr ' file];
               else;
                  prog = curr_ini.txtprint;
                  if strcmp(curr_ini.txtprintcmd,'')==0;
                     prog = [prog ' ' curr_ini.txtprintcmd];
                  end;
                  prog = [prog ' ' file];
               end;
               newstat = unix(prog);
               drawnow;
            else;
               txt = 'Currently Structural VAR cannot print files under Mac. If you know how to solve this, please let me know.';
               about(txt,'warning','Print - Mac Message',135,350);
            end;
         end;
      else;
         txt = 'Unable to print. Please try again!';
         about(txt,'error','Print Error',120,350);
      end;
   case 'edit'
      %
      % need to change userdata if value in control has changed
      %
      curr_obj = gcbo;
      new_val = get(curr_obj,'String');
      %
      % allow for mathematical expressions +-/*
      %
      old_val = num2str(get(curr_obj,'UserData'),'%0.16f');
      if (isempty(str2math(new_val))==0)&(strcmp(new_val,old_val)==0);
         set(curr_obj,'UserData',str2math(new_val));
         if strcmp(num2str(str2math(new_val)),new_val)==0;
            set(curr_obj,'String',num2str(str2math(new_val),'%0.16f'));
         end;
         set(ed_data.save,'Enable','on');
         set(ed_data.icon,'CData',ed_data.undo,'Enable','on');
      elseif isempty(mystr2num(new_val))==1;
         set(curr_obj,'String',old_val);
      end;      
   case 'horizontal'
      curr_obj = gco;
      curr_num = mystr2num(get(curr_obj,'String'));
      curr_val = get(curr_obj,'Value');
      for i=1:size(ed_data.controls,1);
         set(ed_data.controls(i,1),'Value',0);
         set(ed_data.controls(i,:),'FontWeight','normal');
      end;
      if curr_val==1;
         set(ed_data.controls(curr_num,1),'Value',1);
         set(ed_data.controls(curr_num,:),'FontWeight','bold');
         set(ed_data.header,'Value',0,'FontWeight','normal');
      else;
         set(ed_data.controls(curr_num,:),'FontWeight','normal');
      end;
   case 'vertical'
      curr_obj = gco;
      curr_num = get(curr_obj,'UserData');
      curr_val = get(curr_obj,'Value');
      for i=1:size(ed_data.controls,1);
         set(ed_data.controls(i,1),'Value',0);
         set(ed_data.controls(i,:),'FontWeight','normal');
      end;
      if curr_val==1;
         set(ed_data.header,'Value',0,'FontWeight','normal');
         set(curr_obj,'Value',1,'FontWeight','bold');
         set(ed_data.controls(:,curr_num),'FontWeight','bold');
      else;
         set(curr_obj,'FontWeight','normal');
      end;
   case 'save'
      x_data = [];
      y_data = [];
      for i=1:size(ed_data.controls,1);
         if strcmp(get(ed_data.controls(1,2),'Enable'),'on')==1;
            x_data = [x_data;get(ed_data.controls(i,2),'UserData')];
         end;
         y_datai = [];
         for j=3:size(ed_data.controls,2);
            y_datai = [y_datai get(ed_data.controls(i,j),'UserData')];
         end;
         y_data = [y_data;y_datai];
      end;
      if isempty(x_data)==0;
         ed_data.x_data = x_data;
      end;
      ed_data.y_data = y_data;
      ed_data.changed = 1;
      set(ed_data.save,'Enable','off');
   case 'saveas'
      fix_fig = findobj('Tag','StructuralVAR');
      model = get(fix_fig,'UserData');
      outputdir = getpath(get(model.outputfile,'String'));
      num = 1;
      check = 0;
      for i=3:size(ed_data.header,2);
         if i==3;
            filename = get(ed_data.header(1,3),'String');
         else;
            filename = [filename '-' get(ed_data.header(1,i),'String')];
         end;
      end;
      filename = strrep(filename,'\','');
      filename = strrep(filename,'*','');
      filename = strrep(filename,' ','');
      filename = strrep(filename,':','');
      filename = strrep(filename,'?','');
      filename = strrep(filename,'~','');
      filename = strrep(filename,'','');
      filename = strrep(filename,'"','');
      filename = strrep(filename,'''','');
      filename = strrep(filename,'!','');
      filename = strrep(filename,'@','');
      filename = strrep(filename,'$','');
      filename = strrep(filename,'&','');
      filename = strrep(filename,'<','');
      filename = strrep(filename,'>','');
      filename = strrep(filename,'%','');
      filename = strrep(filename,';','');
      filename = strrep(filename,'','');
      filename = strrep(filename,'#','');
      filename = strrep(filename,'','');
      while check==0;
         myfile = [outputdir filename '-data-' num2str(num,'%0.0f') '.data'];
         if fileexist(myfile)==0;
            check = 1;
         else;
            num = num+1;
         end;
      end;
      [savefile,savepath] = uiputfile(myfile,'Save As');
      drawnow;
      if isnumeric(savefile)==0;
         if strcmp(getext(savefile),'.mat')==1;
            savefile = [getname(savefile) '.data'];
         end;
         setlogtext(['Saving data to ' savefile '...']);
         %
         % creating the file
         %
         txt = strvcat(' ',['Saving data to "' savefile '". Please hold!']);
         mywait = waitdlg(txt,'information','Save Data',350,80);
         waitf = get(mywait,'UserData');
         %
         savefile = strcat(savepath,savefile);
         fid = fopen(savefile,'wt');
         %
         % header text
         %
         txt_str = '';
         for i=2:size(ed_data.header,2);
            txt_str = [txt_str '   ' strrep(get(ed_data.header(1,i),'String'),' ','')];
         end;
         fprintf(fid,'%s \n',strtrim(txt_str));
         for i=1:size(ed_data.controls,1);
            txt_str = '';
            for j=2:size(ed_data.controls,2);
               txt_str = [txt_str '   ' get(ed_data.controls(i,j),'String')];
            end;
            fprintf(fid,[strtrim(txt_str) '\n']);
         end;
         fclose(fid);
         %
         set(waitf.text,'UserData','done');
         delete(mywait);
         drawnow;
      end;
   case 'cancel'
      ed_data.x_data = ed_data.orig_x_data;
      ed_data.y_data = ed_data.orig_y_data;
      for i=1:size(ed_data.controls,1);
         if strcmp(get(ed_data.controls(i,2),'Enable'),'on')==1;
            set(ed_data.controls(i,2),'String',num2str(ed_data.x_data(i,1),'%0.16f'),'UserData',ed_data.x_data(i,1));
         end;
         set(ed_data.controls(i,3),'String',num2str(ed_data.y_data(i,1),'%0.16f'),'UserData',ed_data.y_data(i,1));
         if size(ed_data.y_data,2)==2;
            set(ed_data.controls(i,4),'String',num2str(ed_data.y_data(i,2),'%0.16f'),'UserData',ed_data.y_data(i,2));
         end;
      end;
      ed_data.changed = 0;
      set(ed_data.save,'Enable','off');
      set(ed_data.icon,'Enable','off','CData',ed_data.undodisable);
   case 'close';
      set(ed_data.done,'UserData','done');
      killguipid(ed_gui);
      if ed_data.changed==1;
         if strcmp(get(ed_data.curr_obj,'Type'),'line')==1;
            set(ed_data.curr_obj,'XData',ed_data.x_data,'YData',ed_data.y_data);
         elseif strcmp(get(ed_data.curr_obj,'Type'),'patch')==1;
            %
            % need to fix the y_data and x_data depending on the type of patch we have
            %
            if (strcmp(get(ed_data.curr_obj,'Tag'),'confpatch')==1)|(strcmp(get(ed_data.curr_obj,'Tag'),'confpatch-new')==1);
               %
               % we have a confidence region patch
               %
               ed_data.x_data = [ed_data.x_data' reverse(ed_data.x_data')];
               ed_data.y_data = [ed_data.y_data(:,1)' reverse(ed_data.y_data(:,2)')];
               set(ed_data.curr_obj,'XData',ed_data.x_data,'YData',ed_data.y_data);
            elseif (strcmp(get(ed_data.curr_obj,'Tag'),'autopatch')==1)|(strcmp(get(ed_data.curr_obj,'Tag'),'autopatch-new')==1)|(strcmp(get(ed_data.curr_obj,'Tag'),'distpatch')==1)|(strcmp(get(ed_data.curr_obj,'Tag'),'distpatch-new')==1)|(strcmp(get(ed_data.curr_obj,'Tag'),'import-data')==1)|(strcmp(get(ed_data.curr_obj,'Tag'),'import-data-new')==1);
               %
               % we have a bar patch
               %
               % first we need to sort the x-data and let the y-data follow the same sorting scheme
               %
               [ed_data.x_data,ind] = sort(ed_data.x_data);
               ed_data.y_data = ed_data.y_data(ind);
               %
               % now we recreate the original matrices
               %
               ed_data.x_data = [ed_data.x_data-ed_data.width ed_data.x_data-ed_data.width ed_data.x_data+ed_data.width ed_data.x_data+ed_data.width];
               ed_data.y_data = [ed_data.old_y_data(:,1) ed_data.y_data ed_data.y_data ed_data.old_y_data(:,4)];
               set(ed_data.curr_obj,'XData',ed_data.x_data','YData',ed_data.y_data');
            elseif (strcmp(lower(get(ed_data.curr_obj,'Tag')),'rectpatch')==1)|(strcmp(lower(get(ed_data.curr_obj,'Tag')),'rectpatch-new')==1);
               %
               % we have a rectangle patch
               %
               ed_data.x_data = [min(ed_data.x_data)*ones(1,3) max(ed_data.x_data)*ones(1,4) min(ed_data.x_data)];
               ed_data.y_data = [max(ed_data.y_data) min(ed_data.y_data)*ones(1,4) max(ed_data.y_data)*ones(1,3)];
               set(ed_data.curr_obj,'XData',ed_data.x_data,'YData',ed_data.y_data);
            end;
         end;
      end;
      set(ed_data.parent,'Visible','on');
      drawnow;
      drawnow;
      file = [curr_ini.tempdir 'svar-temp.txt'];
      if fileexist(file)==1;
         delete_file_fcn(file);
      end;
end;


if strcmp(selector,'init')==1;
   if (iswinnt==1)&(iscompiled==1)&(curr_ini.loadguiicon==1);
      prog = ['bin\runwindow.exe ' fix_path([pwd '\bin\seticon.exe']) ' ' get(ed_gui,'Name') ' ' fix_filepath([pwd '\icons\spreadsheet.ico'])];
      dos(prog);
      if (strcmp(curr_ini.pstoolsdir,'')==0)&(appexist([curr_ini.pstoolsdir 'pslist.exe'])==1);
         %
         % now we need to determine the pid
         %
         pid = getpid('seticon');
         set(ed_data.icon,'UserData',pid);
      end;
   end;
   %
   set(ed_gui,'Visible','on');
   drawnow;
   drawnow;
   waitfor(ed_data.done,'UserData','done');
elseif strcmp(selector,'close')==0;
   set(ed_gui,'UserData',ed_data);
end;



%
% end of toolbar_editdata_fcn.m
%
