function toolbar_editname_fcn

t_obj = gco;
tag = get(t_obj,'Tag');
if strcmp(strtrim(tag),'')==1;
   tag = 'y-data';
end;
add_stairs = '';
line_num = 0;
if strcmp(get(t_obj,'Type'),'line')==1;
   my_type = 'Line';
   line_num = 5;
   if isempty(findstr(tag,'-stairs'))==0;
      pos = findstr(tag,'-stairs');
      add_stairs = tag(1,pos:size(tag,2));
      if pos>1;
         tag = tag(1,1:pos-1);
      else;
         tag = 'y-data';
      end;
   end;
else;
   my_type = 'Patch';
end;

scrsz = get(0,'ScreenSize');
curr_ini = find_inisettings;

toolbar_editnamegui = figure('Color',get(0,'defaultuicontrolbackgroundcolor'), ...
   'FileName','toolbar_editname_fcn.m', ...
   'MenuBar','none', ...
   'Units','pixels', ...
   'Position',[scrsz(3)/2-180 (scrsz(4)-110)/2 360 110], ...
   'Tag','FigSheetDlg', ...
   'Resize','off', ...
   'Visible','off', ...
   'Name',['New ' my_type ' Name'], ...
   'NumberTitle','off', ...
   'WindowStyle','modal', ...
   'CloseRequestFcn','closegui', ...
   'ToolBar','none');

if matlabnumber>=7.0;
   set(toolbar_editnamegui,'DockControl','off');
end;

axesbox([2 2 358 103],[my_type ' Name'],60-line_num,[0.5 1]);

uicontrol('Units','pixels', ...
   'BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'), ...
   'Position',[12 70 270 20], ...
   'FontSize',curr_ini.gui_fontsize, ...
   'FontName',curr_ini.gui_fontname, ...
   'FontWeight',curr_ini.gui_fontweight, ...
   'FontAngle',curr_ini.gui_fontangle, ...
   'Style','text', ...
   'HorizontalAlignment','left', ...
   'String',['Select new name for ' lower(my_type)], ...
   'Tag','Text');

toolbar_editname.select = uicontrol('Units','pixels', ...
   'BackgroundColor',[1 1 1], ...
   'Position',[12 50 336 20], ...
   'String',tag, ...
   'FontSize',curr_ini.gui_fontsize, ...
   'FontName',curr_ini.gui_fontname, ...
   'FontWeight',curr_ini.gui_fontweight, ...
   'FontAngle',curr_ini.gui_fontangle, ...
   'HorizontalAlignment','Left', ...
   'Style','edit', ...
   'Enable','on', ...
   'Tag','toolbar_editnameEdit');

%
% Two buttons to select action
%

toolbar_editname.ok = uicontrol('Units','pixels', ...
   'BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'), ...
   'Position',[102 12 75 25], ...
   'String','OK', ...
   'FontSize',curr_ini.gui_fontsize, ...
   'FontName',curr_ini.gui_fontname, ...
   'FontWeight',curr_ini.gui_fontweight, ...
   'FontAngle',curr_ini.gui_fontangle, ...
   'Enable','on', ...
   'Callback','closegui', ...
   'UserData','waiting', ...
   'Tag','ButtonOK');

toolbar_editname.cancel = uicontrol('Units','pixels', ...
   'BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'), ...
   'Position',[182 12 75 25], ...
   'String','Cancel', ...
   'FontSize',curr_ini.gui_fontsize, ...
   'FontName',curr_ini.gui_fontname, ...
   'FontWeight',curr_ini.gui_fontweight, ...
   'FontAngle',curr_ini.gui_fontangle, ...
   'Enable','on', ...
   'Callback','closegui', ...
   'Tag','ButtonCancel');

if (iswinnt==1)&(iscompiled==1)&(curr_ini.noicon==1);
   set(toolbar_editnamegui,'WindowStyle','normal');
   prog = ['bin\runwindow.exe ' fix_path([pwd '\bin\seticon.exe']) ' ' get(toolbar_editnamegui,'Name') ' NULL'];
   dos(prog);
   wait_fcn(curr_ini.delay);
   pos = get(toolbar_editnamegui,'Position');
   set(toolbar_editnamegui,'Position',[0 0 1 1]);
end;

set(toolbar_editnamegui,'Visible','on');
drawnow;
if (iswinnt==1)&(iscompiled==1);
   if curr_ini.noicon==1;
      drawnow;
      set(toolbar_editnamegui,'WindowStyle','modal');
      prog = ['bin\runwindow.exe ' fix_path([pwd '\bin\seticon.exe']) ' ' get(toolbar_editnamegui,'Name') ' NULL'];
      dos(prog);
      wait_fcn(curr_ini.delay);
      set(toolbar_editnamegui,'Position',pos);
   end;
   drawnow;
   if matlabnumber<7;
      prog = ['bin\run_prog.exe ' fix_path([pwd '\bin\setfocus.exe']) ' ' get(toolbar_editnamegui,'Name') ' 2'];
      dos(prog);
      drawnow;
   else;
      uicontrol(toolbar_editname.ok);
   end;
   if curr_ini.noicon==1;
      set(toolbar_editnamegui,'Position',pos);
   end;
elseif matlabnumber>=7;
   uicontrol(toolbar_editname.ok);
end;
waitfor(toolbar_editnamegui,'waitstatus','inactive');
%uiwait(toolbar_editnamegui);

action = get(get(toolbar_editnamegui,'CurrentObject'),'String');

if isempty(action)==1;
   action = 'Cancel';
end;

if strcmp(action,'OK')==1;
   new_name = get(toolbar_editname.select,'String');
   new_name = strtrim(new_name);
   if strcmp(new_name,'')==0;
      set(t_obj,'Tag',[new_name add_stairs]);
   else;
      set(t_obj,'Tag',[tag add_stairs]);
   end;
else;
   set(t_obj,'Tag',[tag add_stairs]);
end;

delete(toolbar_editnamegui);
drawnow;


%
% end of toolbar_editname_fcn.m
%
