function toolbar_print_fcn

h = get(0,'CurrentFigure');
old_pointer = get(h,'Pointer');
if strcmp(old_pointer,'custom')==1;
   old_pointer_shape_cdata = get(h,'PointerShapeCData');
end;
set(h,'Pointer','watch');
toolbar = get(h,'UserData');
set(toolbar.saveas,'UserData',1);

curr_ini = find_inisettings;

if ishandle(h)==1;
   basedir = curr_ini.tempdir;
   last_char = basedir(1,size(basedir,2));
   if strcmp(computer,'PCWIN')==1;
      if strcmp(last_char,'\')==0;
         basedir = [basedir '\'];
      end;
   else;
      if isunix==1;
         if strcmp(last_char,'/')==0;
            basedir = [basedir '/'];
         end;
      end;
   end;
   filename = [basedir 'texlips.eps'];
   printfmt = 'epsc';
   addpsprintcmd = ' -color -q';
   myaxes = get(toolbar.print,'UserData');
   if strcmp(get(h,'InvertHardcopy'),'on')==1;
      printfmt = 'eps';
      addpsprintcmd = ' -grey -q';
   else;
      %
      % change background color of figure to white or background color
      % of first axes
      %
      new_color = get(myaxes(1,1),'Color');
      old_color = get(h,'Color');
      set(h,'Color',new_color);
   end;
   set(h,'ResizeFcn','print_resize_legend_fcn');
   mstat = saveas_fcn(h,filename,printfmt);
   set(h,'ResizeFcn','toolbar_resize_fcn');
   if fileexist(filename)==1;
      prog = fix_path(curr_ini.psprint);
      if strcmp(lower(getfilename(curr_ini.psprint)),['gsprint' lower(getext(curr_ini.psprint))])==1;
         if (isempty(findstr('-portrait',curr_ini.psprintcmd))==0)|(isempty(findstr('-landscape',curr_ini.psprintcmd))==0);
            if strcmp(get(h,'PaperOrientation'),'portrait')==1;
               curr_ini.psprintcmd = strrep(curr_ini.psprintcmd,'-portrait','');
            else;
               curr_ini.psprintcmd = strrep(curr_ini.psprintcmd,'-landscape','');
            end;
         end;
      end;
      if strcmp(curr_ini.psprintcmd,'')==0;
         prog = [prog ' ' curr_ini.psprintcmd];
      end;
      if strcmp(lower(getfilename(curr_ini.psprint)),['gsprint' lower(getext(curr_ini.psprint))])==1;
         prog = [strrep(prog,'  ',' ') addpsprintcmd];
      end;
      prog = [prog ' ' fix_path(filename)];
      if strcmp(computer,'PCWIN')==1;
         prog = ['bin\run_exe.exe ' prog];
         mystat = dos(prog);
         drawnow;
         delete_file_fcn(filename);
      else;
         if isunix==1;
            mystat = unix(prog);
            drawnow;
            stat1 = unix('clear');
            stat2 = unix(['rm -f ' filename]);
         end;
      end;
      if strcmp(get(h,'InvertHardcopy'),'off')==1;
         set(h,'Color',old_color);
      end;
   else;
      txt = 'Unable to create PostScript file for printing.';
      about(txt,'error','Error',120,350);
   end;
else;
   txt = 'ERROR: Current figure doesn''t have a handle! Unable to save.';
   about(txt,'error','Error',120,350);
end;

set(h,'Pointer',old_pointer);
if strcmp(old_pointer,'custom')==1;
   set(h,'PointerShapeCData',old_pointer_shape_cdata);
end;

%
% end of toolbar_print_fcn.m
%
