function toolbar_rotate_fcn(selector)

global rotategui basefig
global my_az my_el old_az old_el az_val el_val

if nargin==0;
   selector = 'init';
   basefig = get(0,'CurrentFigure');
   toolbar = get(basefig,'UserData');
   set(basefig,'Resize','off');
   this_azel = get(toolbar.rotate,'UserData');
   my_az = this_azel(1,3);
   my_el = this_azel(1,4);
   old_az = my_az;
   old_el = my_el;
   scrsz = get(0,'ScreenSize');
   if my_az==1;
      az_val = 1;
   elseif my_az==2;
      az_val = 2;
   elseif my_az==3;
      az_val = 3;
   elseif my_az==5;
      az_val = 4;
   elseif my_az==10;
      az_val = 5;
   elseif my_az==15;
      az_val = 6;
   elseif my_az==30;
      az_val = 7;
   elseif my_az==45;
      az_val = 8;
   else;
      az_val = 9;
   end;
   if my_el==1;
      el_val = 1;
   elseif my_el==2;
      el_val = 2;
   elseif my_el==3;
      el_val = 3;
   elseif my_el==5;
      el_val = 4;
   elseif my_el==10;
      el_val = 5;
   elseif my_el==15;
      el_val = 6;
   elseif my_el==30;
      el_val = 7;
   elseif my_el==45;
      el_val = 8;
   else;
      el_val = 9;
   end;
end;

switch selector
   case 'init'
      rotategui = figure('Color',get(0,'defaultuicontrolbackgroundcolor'), ...
         'FileName','toolbar_rotate_fcn.m', ...
         'MenuBar','none', ...
         'Units','pixels', ...
         'Position',[scrsz(3)/2-225 (scrsz(4)-115)/2 450 115], ...
         'Tag','RotateGUI', ...
         'Resize','off', ...
         'Name','Axes Rotation Defaults', ...
         'NumberTitle','off', ...
         'WindowStyle','modal', ...
         'Visible','off', ...
         'DeleteFcn','toolbar_rotate_fcn wayout', ...
         'ToolBar','none');

      axesbox([2 2 448 108],'Rotation selections',90,[0.5 0.9]);

      uicontrol('Units','pixels', ...
         'BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'), ...
         'Position',[12 70 208 20], ...
         'FontSize',6, ...
         'Style','text', ...
         'HorizontalAlignment','left', ...
         'String','Change horizontal rotation about Z-axis by:', ...
         'Tag','AzimuthText');

      rotates.azimuth = uicontrol('Units','pixels', ...
         'BackgroundColor',[1 1 1], ...
         'Position',[12 50 208 20], ...
         'Value',az_val, ...
         'String','1 degree|2 degrees|3 degrees|5 degrees|10 degrees|15 degrees|30 degrees|45 degrees|90 degrees', ...
         'FontSize',6, ...
         'Style','popupmenu', ...
         'Callback','toolbar_rotate_fcn change_az', ...
         'Enable','on', ...
         'Tag','AzimuthPopup');

      uicontrol('Units','pixels', ...
         'BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'), ...
         'Position',[230 70 208 20], ...
         'FontSize',6, ...
         'Style','text', ...
         'HorizontalAlignment','left', ...
         'String','Change vertical elevation of viewpoint by:', ...
         'Tag','ElevationText');

      rotates.elevation = uicontrol('Units','pixels', ...
         'BackgroundColor',[1 1 1], ...
         'Position',[230 50 208 20], ...
         'Value',el_val, ...
         'String','1 degree|2 degrees|3 degrees|5 degrees|10 degrees|15 degrees|30 degrees|45 degrees|90 degrees', ...
         'FontSize',6, ...
         'Style','popupmenu', ...
         'Callback','toolbar_rotate_fcn change_el', ...
         'Enable','on', ...
         'Tag','EelevationPopup');

      %
      % Two buttons to select action
      %

      rotates.ok = uicontrol('Units','pixels', ...
         'BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'), ...
         'Position',[107.5 12 75 20], ...
         'String','OK', ...
         'FontSize',6, ...
         'Enable','on', ...
         'Callback','toolbar_rotate_fcn wayout', ...
         'Tag','OKButton');

      rotates.cancel = uicontrol('Units','pixels', ...
         'BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'), ...
         'Position',[187.5 12 75 20], ...
         'String','Cancel', ...
         'FontSize',6, ...
         'Enable','on', ...
         'Callback','toolbar_rotate_fcn cancel', ...
         'Tag','CancelButton');

      rotates.apply = uicontrol('Units','pixels', ...
         'BackgroundColor',get(0,'defaultuicontrolbackgroundcolor'), ...
         'Position',[267.5 12 75 20], ...
         'String','Apply', ...
         'FontSize',6, ...
         'Enable','off', ...
         'Callback','toolbar_rotate_fcn apply', ...
         'Tag','ApplyButton');

      set(rotategui,'UserData',rotates,...
         'HandleVisibility','callback');
   case 'change_az'
      rotates = get(rotategui,'UserData');
      newaz_val = get(rotates.azimuth,'Value');
      if abs(newaz_val-az_val)>0;
         az_val = newaz_val;
         if az_val==1;
            my_az = 1;
         elseif az_val==2;
            my_az = 2;
         elseif az_val==3;
            my_az = 3;
         elseif az_val==4;
            my_az = 5;
         elseif az_val==5;
            my_az = 10;
         elseif az_val==6;
            my_az = 15;
         elseif az_val==7;
            my_az = 30;
         elseif az_val==8;
            my_az = 45;
         else;
            my_az = 90;
         end;
         set(rotates.apply,'Enable','on');
      end;
      set(rotategui,'UserData',rotates);
   case 'change_el'
      rotates = get(rotategui,'UserData');
      newel_val = get(rotates.elevation,'Value');
      if abs(newel_val-el_val)>0;
         el_val = newel_val;
         if el_val==1;
            my_el = 1;
         elseif el_val==2;
            my_el = 2;
         elseif el_val==3;
            my_el = 3;
         elseif el_val==4;
            my_el = 5;
         elseif el_val==5;
            my_el = 10;
         elseif el_val==6;
            my_el = 15;
         elseif el_val==7;
            my_el = 30;
         elseif el_val==8;
            my_el = 45;
         else;
            my_el = 90;
         end;
         set(rotates.apply,'Enable','on');
      end;
      set(rotategui,'UserData',rotates);
   case 'cancel'
      my_az = old_az;
      my_el = old_el;
      toolbar = get(basefig,'UserData');
      curr_azel = get(toolbar.rotate,'UserData');
      curr_azel(3) = old_az;
      curr_azel(4) = old_el;
      set(toolbar.rotate,'UserData',curr_azel);
      rotates = get(rotategui,'UserData');
      if my_az==1;
         az_val = 1;
      elseif my_az==2;
         az_val = 2;
      elseif my_az==3;
         az_val = 3;
      elseif my_az==5;
         az_val = 4;
      elseif my_az==10;
         az_val = 5;
      elseif my_az==15;
         az_val = 6;
      elseif my_az==30;
         az_val = 7;
      elseif my_az==45;
         az_val = 8;
      else;
         az_val = 9;
      end;
      set(rotates.azimuth,'Value',az_val);
      if my_el==1;
         el_val = 1;
      elseif my_el==2;
         el_val = 2;
      elseif my_el==3;
         el_val = 3;
      elseif my_el==5;
         el_val = 4;
      elseif my_el==10;
         el_val = 5;
      elseif my_el==15;
         el_val = 6;
      elseif my_el==30;
         el_val = 7;
      elseif my_el==45;
         el_val = 8;
      else;
         el_val = 9;
      end;
      set(rotates.elevation,'Value',el_val);
      set(rotates.apply,'Enable','off');
      set(rotategui,'UserData',rotates);
   case 'apply'
      toolbar = get(basefig,'UserData');
      curr_azel = get(toolbar.rotate,'UserData');
      curr_azel(3) = my_az;
      curr_azel(4) = my_el;
      set(toolbar.rotate,'UserData',curr_azel);
      rotates = get(rotategui,'UserData');
      set(rotates.apply,'Enable','off');
      set(rotategui,'UserData',rotates);
   case 'wayout'
      delete(rotategui);
      drawnow;
      set(basefig,'Resize','on');
end;

if strcmp(selector,'init')==1;
   set(rotategui,'Visible','on');
end;

%
% end of toolbar_rotate_fcn.m
%
