function out = trace_quant(nr,type_var,cbs)

%
% nr: number of endogenous variables-number of cointegration relations
% trace: Tx1 vector of trace tests for r0<=r
% type_var: deterministic model type
%

out = zeros(nr,1);

if type_var==[1 0 0 0];
   %
   % unrestricted constant
   %
   table = trace_1_model;
elseif type_var==[0 1 0 0];
   %
   % restricted constant
   %
   table = trace_2_model;
elseif type_var==[0 0 1 0];
   %
   % constant+linear trend
   %
   table = trace_3_model;
elseif type_var==[0 0 0 1];
   %
   % constant+restricted linear trend
   %
   table = trace_4_model;
end;
trace_table = table(:,1:nr);

cbs = cbs-49;
pos = (111:2:209)';
trace_table = trace_table(pos,:);
out = trace_table(cbs,:)';

%
% end of trace_quant.m
%
