function update_line_fcn

h = get(0,'CurrentFigure');
toolbar = get(h,'UserData');

my_xlim = get(gca,'XLim');
my_ylim = get(gca,'YLim');
my_zlim = get(gca,'ZLim');

cp = get(h,'CurrentPoint');

if strcmp(get(toolbar.freehand,'State'),'on')==1;
   set(h,'Pointer','custom','PointerShapeCData',pencil_pointer);
else;
   set(h,'Pointer','crosshair');
end;

if strcmp(get(h,'Pointer'),'crosshair')==1;
   if isfield(toolbar,'lineentry')==1;
      myaxes = get(toolbar.print,'UserData');
      check_break = 0;
      set(toolbar.lineentry,'Visible','on');
      for i=1:size(myaxes,2);
         curr_axes = myaxes(1,i);
         old_axes_units = get(curr_axes,'Units');
         set(curr_axes,'Units','pixels');
         curr_pos = get(curr_axes,'Position');
         set(curr_axes,'Units',old_axes_units);
         if (cp(1)>=curr_pos(1)-5)&(cp(1)<=curr_pos(1)+curr_pos(3)+5)&(cp(2)>=curr_pos(2)-5)&(cp(2)<=curr_pos(2)+curr_pos(4)+5);
            ax_cp = get(curr_axes,'CurrentPoint');
            if get(curr_axes,'View')==[0 90];
               %
               % assume 2D graph
               %
               set(toolbar.lineentry,'String',['X: ' num2str(ax_cp(1,1),'%0.4f') '   Y: ' num2str(ax_cp(1,2),'%0.4f')]);
            else;
               set(toolbar.lineentry,'String',['X: ' num2str((ax_cp(1,1)+ax_cp(2,1))/2,'%0.4f') '   Y: ' num2str((ax_cp(1,2)+ax_cp(2,2))/2,'%0.4f') '   Z: ' num2str((ax_cp(1,3)+ax_cp(2,3))/2,'%0.4f')]);
            end;
            check_break = 1;
            break;
         end;
      end;
      if check_break==0;
         set(toolbar.lineentry,'Visible','off');
      end;
   end;
end;

this_line = get(toolbar.addline,'UserData');

%
% get the data from the line
%

x_data = get(this_line,'XData');
y_data = get(this_line,'YData');
z_data = get(this_line,'ZData');

%
% make sure current point is accurate relative to the axes scale
%

axes_cp = get(gca,'CurrentPoint');
axes_cp = (axes_cp(1,:)+axes_cp(2,:))/2;

%
% change the line
%

if (strcmp(get(toolbar.addline,'State'),'on')==1)|(strcmp(get(toolbar.addarrow,'State'),'on')==1);
   x_data = [x_data(1,1);axes_cp(1,1)];
   y_data = [y_data(1,1);axes_cp(1,2)];
   z_data = [z_data(1,1);axes_cp(1,3)];
else;
   x_data = [x_data axes_cp(1,1)];
   y_data = [y_data axes_cp(1,2)];
   z_data = [z_data axes_cp(1,3)];
end;

set(this_line,'XData',x_data,'YData',y_data,'ZData',z_data);
set(gca,'XLim',my_xlim,'YLim',my_ylim,'ZLim',my_zlim);

%
% end of update_line_fcn.m
%
