function update_rectangle_fcn

h = get(0,'CurrentFigure');
toolbar = get(h,'UserData');

my_xlim = get(gca,'XLim');
my_ylim = get(gca,'YLim');
my_zlim = get(gca,'ZLim');

cp = get(h,'CurrentPoint');


if strcmp(get(h,'Pointer'),'crosshair')==1;
   if isfield(toolbar,'lineentry')==1;
      myaxes = get(toolbar.print,'UserData');
      check_break = 0;
      set(toolbar.lineentry,'Visible','on');
      for i=1:size(myaxes,2);
         curr_axes = myaxes(1,i);
         old_axes_units = get(curr_axes,'Units');
         set(curr_axes,'Units','pixels');
         curr_pos = get(curr_axes,'Position');
         set(curr_axes,'Units',old_axes_units);
         if (cp(1)>=curr_pos(1)-5)&(cp(1)<=curr_pos(1)+curr_pos(3)+5)&(cp(2)>=curr_pos(2)-5)&(cp(2)<=curr_pos(2)+curr_pos(4)+5);
            ax_cp = get(curr_axes,'CurrentPoint');
            if get(curr_axes,'View')==[0 90];
               %
               % assume 2D graph
               %
               set(toolbar.lineentry,'String',['X: ' num2str(ax_cp(1,1),'%0.4f') '   Y: ' num2str(ax_cp(1,2),'%0.4f')]);
            else;
               set(toolbar.lineentry,'String',['X: ' num2str((ax_cp(1,1)+ax_cp(2,1))/2,'%0.4f') '   Y: ' num2str((ax_cp(1,2)+ax_cp(2,2))/2,'%0.4f') '   Z: ' num2str((ax_cp(1,3)+ax_cp(2,3))/2,'%0.4f')]);
            end;
            check_break = 1;
            break;
         end;
      end;
      if check_break==0;
         set(toolbar.lineentry,'Visible','off');
      end;
   end;
end;

%
% this_line contains either 1 or 4 handles
%

this_line = get(toolbar.rectangle,'UserData');

if size(this_line,2)==1;
   %
   % now we need to draw 4 lines
   %
   x_data = get(this_line,'XData');
   y_data = get(this_line,'YData');
   delete(this_line);
   %
   % find the new point in data units
   %
   axes_cp = get(gca,'CurrentPoint');
   axes_cp = (axes_cp(1,:)+axes_cp(2,:))/2;
   %
   x_data_1 = [x_data(1) x_data(1)];
   y_data_1 = [y_data(1) axes_cp(2)];
   x_data_2 = [x_data(1) axes_cp(1)];
   y_data_2 = [axes_cp(2) axes_cp(2)];
   x_data_3 = [axes_cp(1) axes_cp(1)];
   y_data_3 = [axes_cp(2) y_data(1)];
   x_data_4 = [axes_cp(1) x_data(1)];
   y_data_4 = [y_data(1) y_data(1)];
   %
   % creating the four lines
   %
   this_line_1 = line('XData',x_data_1, ...
      'YData',y_data_1, ....
      'LineStyle',':', ...
      'Color',[0 0 0], ...
      'Marker','none', ...
      'LineWidth',1, ...
      'Selection','on', ...
      'Tag','varline-');
   %
   this_line_2 = line('XData',x_data_2, ...
      'YData',y_data_2, ....
      'LineStyle',':', ...
      'Color',[0 0 0], ...
      'Marker','none', ...
      'LineWidth',1, ...
      'Selection','on', ...
      'Tag','varline-');
   %
   this_line_3 = line('XData',x_data_3, ...
      'YData',y_data_3, ....
      'LineStyle',':', ...
      'Color',[0 0 0], ...
      'Marker','none', ...
      'LineWidth',1, ...
      'Selection','on', ...
      'Tag','varline-');
   %
   this_line_4 = line('XData',x_data_4, ...
      'YData',y_data_4, ....
      'LineStyle',':', ...
      'Color',[0 0 0], ...
      'Marker','none', ...
      'LineWidth',1, ...
      'Selection','on', ...
      'Tag','varline-');
   %
   this_line = [this_line_1 this_line_2 this_line_3 this_line_4];
   set(toolbar.rectangle,'UserData',this_line);
else;
   x_data_1 = get(this_line(1,1),'XData');
   y_data_1 = get(this_line(1,1),'YData');
   x_data_2 = get(this_line(1,2),'XData');
   y_data_2 = get(this_line(1,2),'YData');
   x_data_3 = get(this_line(1,3),'XData');
   y_data_3 = get(this_line(1,3),'YData');
   x_data_4 = get(this_line(1,4),'XData');
   y_data_4 = get(this_line(1,4),'YData');
   %
   %
   % find the new point in data units
   %
   axes_cp = get(gca,'CurrentPoint');
   axes_cp = (axes_cp(1,:)+axes_cp(2,:))/2;
   %
   x_data_1 = [x_data_1(1) x_data_1(1)];
   y_data_1 = [y_data_1(1) axes_cp(2)];
   x_data_2 = [x_data_1(1) axes_cp(1)];
   y_data_2 = [axes_cp(2) axes_cp(2)];
   x_data_3 = [axes_cp(1) axes_cp(1)];
   y_data_3 = [axes_cp(2) y_data_1(1)];
   x_data_4 = [axes_cp(1) x_data_1(1)];
   y_data_4 = [y_data_1(1) y_data_1(1)];
   %
   % revising the data
   %
   set(this_line(1,1),'XData',x_data_1,'YData',y_data_1);
   set(this_line(1,2),'XData',x_data_2,'YData',y_data_2);
   set(this_line(1,3),'XData',x_data_3,'YData',y_data_3);
   set(this_line(1,4),'XData',x_data_4,'YData',y_data_4);
end;

set(gca,'XLim',my_xlim,'YLim',my_ylim,'ZLim',my_zlim);

%
% end of update_rectangle_fcn.m
%
