function [results,df] = waldgc_boot(Psi,alpha,beta,p,epsilon,Z1,Z2,q1,q0,d,t,ind,moddir,modfile,Sigma_theta,Rlev,c_ind)

if nargin<12;
   ind = 0;
   moddir = '';
   modfile = '';
   Sigma_theta = [];
end;

curr_ini = find_inisettings;

%
% Preliminaries
%

[n T] = size(epsilon);

if isempty(alpha)==0;
   r = size(alpha,2);
   w = [Z2;beta'*Z1];
   beta_y = beta(1:n,:);
else;
   r = 0;
   w = Z2;
   beta_y = [];
end;
nreg = size(w,1);

Omega = (1/T)*epsilon*epsilon';
theta = vec([Psi alpha*beta_y']);

if ind==0;
   inv_ww = eye(nreg)/(w*w');
   if c_ind==0;
      Sigma_theta = kron(inv_ww,Omega);
   end;
end;

if nreg>r;
   if r>0;
      fixpi = [[eye(n*(nreg-r)) zeros(n*(nreg-r),n*r)];[zeros(n*n,n*(nreg-r)) kron(beta_y,eye(n))]];
   else;
      fixpi = [eye(n*nreg);zeros(n*n,n*nreg)];
   end;
else;
   if r>0;
      fixpi = kron(beta_y,eye(n));
   end;
end;

Sigma_pi = fixpi*Sigma_theta*fixpi';

%
% Setting up the tests
%

if r>0;
   W = (Rlev*theta)'*inverse(Rlev*Sigma_pi*Rlev')*Rlev*theta;
else;
   theta = [theta;zeros(size(Sigma_pi,1)-size(theta,1),1)];
   W = (Rlev*theta)'*inverse(Rlev*Sigma_pi*Rlev')*Rlev*theta;
end;
numres = size(Rlev,1);
actual_res = size(Rlev,1);

if curr_ini.sscorrect==0;
   df = actual_res;
   results = W;
else;
   df = [actual_res t+actual_res];
   W = ((t+numres)/(T*numres))*W;
   results = W;
end;

%
% end of waldgc_boot.m
%
